/*
 Navicat MySQL Data Transfer

 Source Server         : dev
 Source Server Type    : MySQL
 Source Server Version : 50620
 Source Host           : 10.105.19.27
 Source Database       : kyphp

 Target Server Type    : MySQL
 Target Server Version : 50620
 File Encoding         : utf-8

 Date: 10/31/2020 15:22:07 PM
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
--  Table structure for `ky_addons`
-- ----------------------------
DROP TABLE IF EXISTS `ky_addons`;
CREATE TABLE `ky_addons` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `name` varchar(50) NOT NULL COMMENT '插件名称',
  `addon` varchar(50) NOT NULL COMMENT '标识名',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `version` varchar(10) NOT NULL COMMENT '版本号',
  `author` varchar(50) NOT NULL COMMENT '作者姓名',
  `logo` varchar(255) NOT NULL DEFAULT '' COMMENT 'LOGO',
  `config` text COMMENT '插件配置',
  `entry_url` varchar(160) NOT NULL COMMENT '前端入口',
  `admin_url` varchar(160) NOT NULL DEFAULT '' COMMENT '后台入口',
  `menu_show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否在菜单显示1：显示 0：隐藏',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `type` enum('mp','mini') NOT NULL DEFAULT 'mp' COMMENT '应用类型',
  `demo_qrcode` varchar(255) NOT NULL DEFAULT '' COMMENT 'demo链接二维码',
  PRIMARY KEY (`id`),
  UNIQUE KEY `addon` (`addon`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='应用表';

-- ----------------------------
--  Records of `ky_addons`
-- ----------------------------
BEGIN;
INSERT INTO `ky_addons` VALUES ('10', '应用demo', 'demo', '这是一款应用demo，基础的文章功能', '1.2', '苟哥', '/addons/demo/logo.png', '[{\"name\":\"title\",\"title\":\"\\u535a\\u5ba2\\u540d\\u79f0\",\"type\":\"text\",\"value\":\"\",\"placeholder\":\"\\u4e0d\\u8d85\\u8fc710\\u4e2a\\u5b57\",\"tip\":\"\",\"extra_attr\":\"required\"},{\"name\":\"wx_auth_open\",\"title\":\"\\u5f00\\u542f\\u7f51\\u9875\\u6388\\u6743\",\"type\":\"radio\",\"options\":[\"\\u5173\\u95ed\",\"\\u5f00\\u542f\"],\"placeholder\":\"\",\"tip\":\"\",\"extra_attr\":\"required\"}]', 'demo/wap/index/index', '', '1', '1', '1593686667', '1599103193', 'mp', ''), ('11', '小程序应用demo', 'mini_demo', '这是一款小程序应用demo', '2.0', '苟哥', '/addons/mini_demo/logo.png', '[{\"name\":\"title\",\"title\":\"\\u914d\\u7f6e\\u6d4b\\u8bd5\",\"type\":\"text\",\"value\":\"\",\"placeholder\":\"\\u4e0d\\u8d85\\u8fc710\\u4e2a\\u5b57\",\"tip\":\"\",\"extra_attr\":\"required\"}]', '/pages/index/index', '', '1', '1', '1595663351', '1595683418', 'mini', ''), ('12', '享约茶', 'gxtea', '共享查实小程序', '1.0', '苟哥', '/addons/gxtea/logo.png', '[{\"name\":\"app_key\",\"title\":\"\\u63a5\\u53e3\\u52a0\\u5bc6key\",\"type\":\"text\",\"value\":\"9eT8gFN2J1efa5e8fadfegas1DDewrqw\",\"placeholder\":\"\\u5efa\\u8bae20\\u523064\\u4f4d\\u957f\\u5ea6\",\"tip\":\"\",\"extra_attr\":\"required\"}]', '/pages/index/index', '', '1', '1', '1595988383', '1595988706', 'mini', ''), ('13', '博饼王', 'bobing', '博饼小程序', '1.0', '官方', '/addons/bobing/logo.jpg', null, '/pages/index/index', '', '1', '1', '0', '0', 'mini', ''), ('14', '博饼礼品版', 'bbgift', '博饼礼品版', '1.0', '官方', '/addons/bobing/logo.jpg', null, '/pages/index/index', '', '1', '1', '0', '0', 'mini', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_addons_cate`
-- ----------------------------
DROP TABLE IF EXISTS `ky_addons_cate`;
CREATE TABLE `ky_addons_cate` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `title` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  `sort` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '排序，数字越小越靠前',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='应用分类表';

-- ----------------------------
--  Records of `ky_addons_cate`
-- ----------------------------
BEGIN;
INSERT INTO `ky_addons_cate` VALUES ('1', '涨粉', '2', '1594997635', '1603701691', '0'), ('2', '营销', '3', '1594997967', '1603701691', '0'), ('3', '商城', '0', '1594997977', '1603701689', '0'), ('4', '游戏', '10', '1594997996', '1603701692', '0'), ('5', '节日', '5', '1594998006', '1603701692', '0'), ('6', '共享', '0', '1597459141', '1603701690', '0');
COMMIT;

-- ----------------------------
--  Table structure for `ky_addons_info`
-- ----------------------------
DROP TABLE IF EXISTS `ky_addons_info`;
CREATE TABLE `ky_addons_info` (
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '应用ID（即addons中的id）',
  `detail` mediumtext COMMENT '应用介绍',
  `sale_num` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '实际销量',
  `sale_num_show` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '虚拟销量',
  `price` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '售价',
  `old_price` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '原价',
  `cates` text COMMENT '标签',
  `snapshot` text COMMENT ' 应用快照',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='应用详细信息';

-- ----------------------------
--  Records of `ky_addons_info`
-- ----------------------------
BEGIN;
INSERT INTO `ky_addons_info` VALUES ('10', '<p>应用介绍</p><p>adfadf</p><p>到发疯</p><p>阿道夫<img src=\"http://devhhb.images.huihuiba.net/1-5ed603542b0f4.jpg\" alt=\"1-5ed603542b0f4.jpg\"/></p>', '4', '112', '0.01', '0.00', '涨粉,营销,商城', 'http://devhhb.images.huihuiba.net/1-5f1582f10db72.jpg,http://devhhb.images.huihuiba.net/1-5f1582f0b24e6.jpg'), ('11', '<p>详细介绍小程序介绍</p>', '6', '107', '0.00', '398.00', '营销', 'http://devhhb.images.huihuiba.net/1-5f1582f10db72.jpg,http://devhhb.images.huihuiba.net/1-5f1582f0b24e6.jpg'), ('12', '<p>详细介绍</p>', '4', '24', '0.00', '0.00', '营销,共享', 'http://devhhb.images.huihuiba.net/1-5f1582f10db72.jpg,http://devhhb.images.huihuiba.net/1-5f1582f0b24e6.jpg'), ('13', '<p>博饼小程序</p>', '2', '101', '0.00', '0.00', '营销,工具', null), ('14', '<p>博饼小程序礼品版</p>', '2', '2', '0.00', '0.00', '营销,工具', null);
COMMIT;

-- ----------------------------
--  Table structure for `ky_addons_template`
-- ----------------------------
DROP TABLE IF EXISTS `ky_addons_template`;
CREATE TABLE `ky_addons_template` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `addon` varchar(30) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '应用标识',
  `template_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '模板id',
  PRIMARY KEY (`id`),
  UNIQUE KEY `addon` (`addon`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序应用对应的模板id';

-- ----------------------------
--  Records of `ky_addons_template`
-- ----------------------------
BEGIN;
INSERT INTO `ky_addons_template` VALUES ('1', 'mini_demo', '1'), ('2', 'gxtea', '1'), ('3', 'bobing', '6'), ('4', 'bbgift', '8');
COMMIT;

-- ----------------------------
--  Table structure for `ky_admin`
-- ----------------------------
DROP TABLE IF EXISTS `ky_admin`;
CREATE TABLE `ky_admin` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `username` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '账号',
  `password` char(60) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '密码',
  `email` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '邮箱',
  `mobile` varchar(15) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '手机号',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '新增时间',
  `update_time` int(10) NOT NULL DEFAULT '0' COMMENT '最后修改时间',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `group_id` tinyint(2) NOT NULL DEFAULT '1' COMMENT '所属角色',
  `realname` varchar(30) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '真实姓名',
  `last_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后登录时间',
  `ip` varchar(16) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '登录IP',
  `admin_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级ID',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `username` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='系统会员表';

-- ----------------------------
--  Records of `ky_admin`
-- ----------------------------
BEGIN;
INSERT INTO `ky_admin` VALUES ('1', 'admin', '$2y$10$/MKbzIp7H1nEuMJ14YkD/.HcV1whIgrAteh77d0O8RJ7EDkHXZrwm', '461960962@qq.com', '15659827559', '0', '1604113466', '1', '1', '傅道集', '1604113466', '112.228.165.85', '0'), ('2', 'test1', '$2y$10$lSnmo7isc6Y7X1trZ/YeH.WirmUAC3TG8JpEkloRODCO1nHXYFnFm', 'test@mail.com', '15659827559', '1590227330', '1602038227', '1', '2', '张三', '1602038227', '106.122.214.109', '1'), ('3', 'test2', '$2y$10$VI/NBVVik3YRAjnrZIgAQeKZ2rKJtY01mGnRwLQ1Saoy956vwOVXC', 'test@mail.com', '', '1594977794', '1594977794', '1', '2', '', '1594977794', '106.122.215.27', '0'), ('4', 'test', '$2y$10$//5v/B9XdvlS5pIgEjZ2Juw9I.RN82BLE652b50evmjxIwFzYv.U6', 'test@mail.com', '', '1594978590', '1603091154', '1', '2', '测试', '1603091154', '211.162.236.44', '0'), ('5', 'tudou', '$2y$10$13UPqVwagYE/g.EZ/1pjUOQsb4AsvEBj9hTzbi0gAWpQVlg.TDrzy', 'test@mail.com', '', '1600324436', '1600324436', '1', '2', '', '1600324436', '115.192.101.188', '0'), ('6', 'admind', '$2y$10$faYT/U0lo.fVRc9/W6vYTe7rACYJ0E8Rzk9fhfi5SkZvfYq6OaR6C', 'test@mail.com', '', '1601001038', '1601001038', '1', '2', '', '1601001038', '113.89.33.197', '0'), ('7', 'natsume', '$2y$10$V88M9u0fGXqjeuwC9GsJteDxxim6cpsrHug5upKzS4LGzD1ukY42m', 'test@mail.com', '', '1601818247', '1601818247', '1', '2', '', '1601818247', '171.83.11.118', '0'), ('8', 'spa123456', '$2y$10$wX7WR5Z/o4EHigNp/iQMxuPOsULhaJVyAf06bfkBtuFzgHT.c8rii', 'test@mail.com', '', '1601951963', '1601951963', '1', '2', '', '1601951963', '49.94.179.221', '0'), ('9', 'headwhy', '$2y$10$7M80S15U7qUwERllAlE/deTWoEJnoIxwK7c3ta/qrzNKXKMP1a1.G', '', '', '1603786058', '1603786058', '1', '2', '', '1603786058', '116.54.54.253', '0');
COMMIT;

-- ----------------------------
--  Table structure for `ky_admin_addon`
-- ----------------------------
DROP TABLE IF EXISTS `ky_admin_addon`;
CREATE TABLE `ky_admin_addon` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `addon` varchar(30) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '应用标识',
  `deadline` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '到期时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后修改时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uid` (`uid`,`addon`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='客户-应用关联表';

-- ----------------------------
--  Records of `ky_admin_addon`
-- ----------------------------
BEGIN;
INSERT INTO `ky_admin_addon` VALUES ('1', '2', 'demo', '1595692800', '1', '1594814243', '1594816271'), ('3', '1', 'demo', '1689914356', '1', '1594817469', '1595312686'), ('5', '1', 'mini_demo', '1627309992', '1', '1595773992', '1595773992'), ('6', '1', 'gxtea', '1659060859', '1', '1595988859', '1596007212'), ('7', '4', 'mini_demo', '1693118948', '1', '1598510948', '1600777579'), ('8', '1', 'bobing', '1694361600', '1', '1599795026', '1603881333'), ('9', '1', 'bbgift', '1695370953', '1', '1600762964', '1603881100'), ('10', '4', 'gxtea', '1632910479', '1', '1601374479', '1601374479'), ('11', '8', 'mini_demo', '1633492851', '1', '1601956851', '1601956851'), ('12', '8', 'gxtea', '1633685540', '1', '1602149540', '1602149540');
COMMIT;

-- ----------------------------
--  Table structure for `ky_admin_group`
-- ----------------------------
DROP TABLE IF EXISTS `ky_admin_group`;
CREATE TABLE `ky_admin_group` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `title` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '用户组名称',
  `store_config` text COLLATE utf8mb4_unicode_ci COMMENT '店铺个数设置',
  `menu_config` text COLLATE utf8mb4_unicode_ci COMMENT '菜单权限',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `sort` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '数字越小越靠前',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='会员权限组';

-- ----------------------------
--  Records of `ky_admin_group`
-- ----------------------------
BEGIN;
INSERT INTO `ky_admin_group` VALUES ('1', '管理员', '{\"mp_limit\":\"0\",\"mini_limit\":\"0\"}', '1,13,14,15,47,17,18,16,68,19,20,43,80,21,22,72,52,84,53,2,25,83,26,51,45,56,74,73,77,67,69,81,57', '1', '0', '1594302168', '1594302168'), ('2', '游客', '{\"mp_limit\":\"2\",\"mini_limit\":\"2\"}', '111,108,114,119,115,110,109,112,1,13,14,15,47,17,18,16,68,19,20,43,96,61,64,46,62,63,80,21,22,72,93,94,100,101,52,84', '1', '0', '1594303678', '1598490203'), ('3', ' 青铜会员', '{\"mp_limit\":\"0\",\"mini_limit\":\"0\"}', '1,13,14,15,47,17,18,16,68,19,20,43,96,61,64,46,62,63,80,21,22,72,93,94,52,84', '1', '0', '1595340975', '1595340975');
COMMIT;

-- ----------------------------
--  Table structure for `ky_admin_store`
-- ----------------------------
DROP TABLE IF EXISTS `ky_admin_store`;
CREATE TABLE `ky_admin_store` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '也是其他平台的id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户ID',
  `type` enum('mp','mini','pc','app') NOT NULL DEFAULT 'mp' COMMENT '平台类型',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8mb4 COMMENT='会员店铺';

-- ----------------------------
--  Records of `ky_admin_store`
-- ----------------------------
BEGIN;
INSERT INTO `ky_admin_store` VALUES ('1', '1', 'mp', '1', '0', '0'), ('2', '2', 'mp', '0', '1590592849', '1590593695'), ('3', '1', 'mp', '1', '0', '0'), ('10', '1', 'mini', '1', '1595557998', '1595557998'), ('11', '1', 'mini', '1', '1596536174', '1596786901'), ('12', '0', 'mp', '1', '1597328829', '1597328829'), ('13', '1', 'mini', '1', '1600056296', '1600056296'), ('14', '1', 'mini', '1', '1600395705', '1600395705'), ('15', '4', 'mp', '1', '1601444306', '1603082604'), ('16', '8', 'mp', '1', '1601952158', '1601952158'), ('17', '8', 'mini', '1', '1601956907', '1601956907');
COMMIT;

-- ----------------------------
--  Table structure for `ky_district`
-- ----------------------------
DROP TABLE IF EXISTS `ky_district`;
CREATE TABLE `ky_district` (
  `id` int(10) unsigned NOT NULL,
  `title` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '名称',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='省市地区字典';

-- ----------------------------
--  Records of `ky_district`
-- ----------------------------
BEGIN;
INSERT INTO `ky_district` VALUES ('110000', '北京', '0'), ('110100', '北京市', '110000'), ('110101', '东城区', '110100'), ('110102', '西城区', '110100'), ('110105', '朝阳区', '110100'), ('110106', '丰台区', '110100'), ('110107', '石景山区', '110100'), ('110108', '海淀区', '110100'), ('110109', '门头沟区', '110100'), ('110111', '房山区', '110100'), ('110112', '通州区', '110100'), ('110113', '顺义区', '110100'), ('110114', '昌平区', '110100'), ('110115', '大兴区', '110100'), ('110116', '怀柔区', '110100'), ('110117', '平谷区', '110100'), ('110228', '密云县', '110100'), ('110229', '延庆县', '110100'), ('120000', '天津', '0'), ('120100', '天津市', '120000'), ('120101', '和平区', '120100'), ('120102', '河东区', '120100'), ('120103', '河西区', '120100'), ('120104', '南开区', '120100'), ('120105', '河北区', '120100'), ('120106', '红桥区', '120100'), ('120110', '东丽区', '120100'), ('120111', '西青区', '120100'), ('120112', '津南区', '120100'), ('120113', '北辰区', '120100'), ('120114', '武清区', '120100'), ('120115', '宝坻区', '120100'), ('120116', '滨海新区', '120100'), ('120221', '宁河县', '120100'), ('120223', '静海县', '120100'), ('120225', '蓟县', '120100'), ('130000', '河北省', '0'), ('130100', '石家庄市', '130000'), ('130101', '市辖区', '130100'), ('130102', '长安区', '130100'), ('130104', '桥西区', '130100'), ('130105', '新华区', '130100'), ('130107', '井陉矿区', '130100'), ('130108', '裕华区', '130100'), ('130109', '藁城区', '130100'), ('130110', '鹿泉区', '130100'), ('130111', '栾城区', '130100'), ('130121', '井陉县', '130100'), ('130123', '正定县', '130100'), ('130125', '行唐县', '130100'), ('130126', '灵寿县', '130100'), ('130127', '高邑县', '130100'), ('130128', '深泽县', '130100'), ('130129', '赞皇县', '130100'), ('130130', '无极县', '130100'), ('130131', '平山县', '130100'), ('130132', '元氏县', '130100'), ('130133', '赵县', '130100'), ('130181', '辛集市', '130100'), ('130183', '晋州市', '130100'), ('130184', '新乐市', '130100'), ('130200', '唐山市', '130000'), ('130201', '市辖区', '130200'), ('130202', '路南区', '130200'), ('130203', '路北区', '130200'), ('130204', '古冶区', '130200'), ('130205', '开平区', '130200'), ('130207', '丰南区', '130200'), ('130208', '丰润区', '130200'), ('130209', '曹妃甸区', '130200'), ('130223', '滦县', '130200'), ('130224', '滦南县', '130200'), ('130225', '乐亭县', '130200'), ('130227', '迁西县', '130200'), ('130229', '玉田县', '130200'), ('130281', '遵化市', '130200'), ('130283', '迁安市', '130200'), ('130300', '秦皇岛市', '130000'), ('130301', '市辖区', '130300'), ('130302', '海港区', '130300'), ('130303', '山海关区', '130300'), ('130304', '北戴河区', '130300'), ('130321', '青龙满族自治县', '130300'), ('130322', '昌黎县', '130300'), ('130323', '抚宁县', '130300'), ('130324', '卢龙县', '130300'), ('130400', '邯郸市', '130000'), ('130401', '市辖区', '130400'), ('130402', '邯山区', '130400'), ('130403', '丛台区', '130400'), ('130404', '复兴区', '130400'), ('130406', '峰峰矿区', '130400'), ('130421', '邯郸县', '130400'), ('130423', '临漳县', '130400'), ('130424', '成安县', '130400'), ('130425', '大名县', '130400'), ('130426', '涉县', '130400'), ('130427', '磁县', '130400'), ('130428', '肥乡县', '130400'), ('130429', '永年县', '130400'), ('130430', '邱县', '130400'), ('130431', '鸡泽县', '130400'), ('130432', '广平县', '130400'), ('130433', '馆陶县', '130400'), ('130434', '魏县', '130400'), ('130435', '曲周县', '130400'), ('130481', '武安市', '130400'), ('130500', '邢台市', '130000'), ('130501', '市辖区', '130500'), ('130502', '桥东区', '130500'), ('130503', '桥西区', '130500'), ('130521', '邢台县', '130500'), ('130522', '临城县', '130500'), ('130523', '内丘县', '130500'), ('130524', '柏乡县', '130500'), ('130525', '隆尧县', '130500'), ('130526', '任县', '130500'), ('130527', '南和县', '130500'), ('130528', '宁晋县', '130500'), ('130529', '巨鹿县', '130500'), ('130530', '新河县', '130500'), ('130531', '广宗县', '130500'), ('130532', '平乡县', '130500'), ('130533', '威县', '130500'), ('130534', '清河县', '130500'), ('130535', '临西县', '130500'), ('130581', '南宫市', '130500'), ('130582', '沙河市', '130500'), ('130600', '保定市', '130000'), ('130601', '市辖区', '130600'), ('130602', '新市区', '130600'), ('130603', '北市区', '130600'), ('130604', '南市区', '130600'), ('130621', '满城县', '130600'), ('130622', '清苑县', '130600'), ('130623', '涞水县', '130600'), ('130624', '阜平县', '130600'), ('130625', '徐水县', '130600'), ('130626', '定兴县', '130600'), ('130627', '唐县', '130600'), ('130628', '高阳县', '130600'), ('130629', '容城县', '130600'), ('130630', '涞源县', '130600'), ('130631', '望都县', '130600'), ('130632', '安新县', '130600'), ('130633', '易县', '130600'), ('130634', '曲阳县', '130600'), ('130635', '蠡县', '130600'), ('130636', '顺平县', '130600'), ('130637', '博野县', '130600'), ('130638', '雄县', '130600'), ('130681', '涿州市', '130600'), ('130682', '定州市', '130600'), ('130683', '安国市', '130600'), ('130684', '高碑店市', '130600'), ('130700', '张家口市', '130000'), ('130701', '市辖区', '130700'), ('130702', '桥东区', '130700'), ('130703', '桥西区', '130700'), ('130705', '宣化区', '130700'), ('130706', '下花园区', '130700'), ('130721', '宣化县', '130700'), ('130722', '张北县', '130700'), ('130723', '康保县', '130700'), ('130724', '沽源县', '130700'), ('130725', '尚义县', '130700'), ('130726', '蔚县', '130700'), ('130727', '阳原县', '130700'), ('130728', '怀安县', '130700'), ('130729', '万全县', '130700'), ('130730', '怀来县', '130700'), ('130731', '涿鹿县', '130700'), ('130732', '赤城县', '130700'), ('130733', '崇礼县', '130700'), ('130800', '承德市', '130000'), ('130801', '市辖区', '130800'), ('130802', '双桥区', '130800'), ('130803', '双滦区', '130800'), ('130804', '鹰手营子矿区', '130800'), ('130821', '承德县', '130800'), ('130822', '兴隆县', '130800'), ('130823', '平泉县', '130800'), ('130824', '滦平县', '130800'), ('130825', '隆化县', '130800'), ('130826', '丰宁满族自治县', '130800'), ('130827', '宽城满族自治县', '130800'), ('130828', '围场满族蒙古族自治县', '130800'), ('130900', '沧州市', '130000'), ('130901', '市辖区', '130900'), ('130902', '新华区', '130900'), ('130903', '运河区', '130900'), ('130921', '沧县', '130900'), ('130922', '青县', '130900'), ('130923', '东光县', '130900'), ('130924', '海兴县', '130900'), ('130925', '盐山县', '130900'), ('130926', '肃宁县', '130900'), ('130927', '南皮县', '130900'), ('130928', '吴桥县', '130900'), ('130929', '献县', '130900'), ('130930', '孟村回族自治县', '130900'), ('130981', '泊头市', '130900'), ('130982', '任丘市', '130900'), ('130983', '黄骅市', '130900'), ('130984', '河间市', '130900'), ('131000', '廊坊市', '130000'), ('131001', '市辖区', '131000'), ('131002', '安次区', '131000'), ('131003', '广阳区', '131000'), ('131022', '固安县', '131000'), ('131023', '永清县', '131000'), ('131024', '香河县', '131000'), ('131025', '大城县', '131000'), ('131026', '文安县', '131000'), ('131028', '大厂回族自治县', '131000'), ('131081', '霸州市', '131000'), ('131082', '三河市', '131000'), ('131100', '衡水市', '130000'), ('131101', '市辖区', '131100'), ('131102', '桃城区', '131100'), ('131121', '枣强县', '131100'), ('131122', '武邑县', '131100'), ('131123', '武强县', '131100'), ('131124', '饶阳县', '131100'), ('131125', '安平县', '131100'), ('131126', '故城县', '131100'), ('131127', '景县', '131100'), ('131128', '阜城县', '131100'), ('131181', '冀州市', '131100'), ('131182', '深州市', '131100'), ('140000', '山西省', '0'), ('140100', '太原市', '140000'), ('140101', '市辖区', '140100'), ('140105', '小店区', '140100'), ('140106', '迎泽区', '140100'), ('140107', '杏花岭区', '140100'), ('140108', '尖草坪区', '140100'), ('140109', '万柏林区', '140100'), ('140110', '晋源区', '140100'), ('140121', '清徐县', '140100'), ('140122', '阳曲县', '140100'), ('140123', '娄烦县', '140100'), ('140181', '古交市', '140100'), ('140200', '大同市', '140000'), ('140201', '市辖区', '140200'), ('140202', '城区', '140200'), ('140203', '矿区', '140200'), ('140211', '南郊区', '140200'), ('140212', '新荣区', '140200'), ('140221', '阳高县', '140200'), ('140222', '天镇县', '140200'), ('140223', '广灵县', '140200'), ('140224', '灵丘县', '140200'), ('140225', '浑源县', '140200'), ('140226', '左云县', '140200'), ('140227', '大同县', '140200'), ('140300', '阳泉市', '140000'), ('140301', '市辖区', '140300'), ('140302', '城区', '140300'), ('140303', '矿区', '140300'), ('140311', '郊区', '140300'), ('140321', '平定县', '140300'), ('140322', '盂县', '140300'), ('140400', '长治市', '140000'), ('140401', '市辖区', '140400'), ('140402', '城区', '140400'), ('140411', '郊区', '140400'), ('140421', '长治县', '140400'), ('140423', '襄垣县', '140400'), ('140424', '屯留县', '140400'), ('140425', '平顺县', '140400'), ('140426', '黎城县', '140400'), ('140427', '壶关县', '140400'), ('140428', '长子县', '140400'), ('140429', '武乡县', '140400'), ('140430', '沁县', '140400'), ('140431', '沁源县', '140400'), ('140481', '潞城市', '140400'), ('140500', '晋城市', '140000'), ('140501', '市辖区', '140500'), ('140502', '城区', '140500'), ('140521', '沁水县', '140500'), ('140522', '阳城县', '140500'), ('140524', '陵川县', '140500'), ('140525', '泽州县', '140500'), ('140581', '高平市', '140500'), ('140600', '朔州市', '140000'), ('140601', '市辖区', '140600'), ('140602', '朔城区', '140600'), ('140603', '平鲁区', '140600'), ('140621', '山阴县', '140600'), ('140622', '应县', '140600'), ('140623', '右玉县', '140600'), ('140624', '怀仁县', '140600'), ('140700', '晋中市', '140000'), ('140701', '市辖区', '140700'), ('140702', '榆次区', '140700'), ('140721', '榆社县', '140700'), ('140722', '左权县', '140700'), ('140723', '和顺县', '140700'), ('140724', '昔阳县', '140700'), ('140725', '寿阳县', '140700'), ('140726', '太谷县', '140700'), ('140727', '祁县', '140700'), ('140728', '平遥县', '140700'), ('140729', '灵石县', '140700'), ('140781', '介休市', '140700'), ('140800', '运城市', '140000'), ('140801', '市辖区', '140800'), ('140802', '盐湖区', '140800'), ('140821', '临猗县', '140800'), ('140822', '万荣县', '140800'), ('140823', '闻喜县', '140800'), ('140824', '稷山县', '140800'), ('140825', '新绛县', '140800'), ('140826', '绛县', '140800'), ('140827', '垣曲县', '140800'), ('140828', '夏县', '140800'), ('140829', '平陆县', '140800'), ('140830', '芮城县', '140800'), ('140881', '永济市', '140800'), ('140882', '河津市', '140800'), ('140900', '忻州市', '140000'), ('140901', '市辖区', '140900'), ('140902', '忻府区', '140900'), ('140921', '定襄县', '140900'), ('140922', '五台县', '140900'), ('140923', '代县', '140900'), ('140924', '繁峙县', '140900'), ('140925', '宁武县', '140900'), ('140926', '静乐县', '140900'), ('140927', '神池县', '140900'), ('140928', '五寨县', '140900'), ('140929', '岢岚县', '140900'), ('140930', '河曲县', '140900'), ('140931', '保德县', '140900'), ('140932', '偏关县', '140900'), ('140981', '原平市', '140900'), ('141000', '临汾市', '140000'), ('141001', '市辖区', '141000'), ('141002', '尧都区', '141000'), ('141021', '曲沃县', '141000'), ('141022', '翼城县', '141000'), ('141023', '襄汾县', '141000'), ('141024', '洪洞县', '141000'), ('141025', '古县', '141000'), ('141026', '安泽县', '141000'), ('141027', '浮山县', '141000'), ('141028', '吉县', '141000'), ('141029', '乡宁县', '141000'), ('141030', '大宁县', '141000'), ('141031', '隰县', '141000'), ('141032', '永和县', '141000'), ('141033', '蒲县', '141000'), ('141034', '汾西县', '141000'), ('141081', '侯马市', '141000'), ('141082', '霍州市', '141000'), ('141100', '吕梁市', '140000'), ('141101', '市辖区', '141100'), ('141102', '离石区', '141100'), ('141121', '文水县', '141100'), ('141122', '交城县', '141100'), ('141123', '兴县', '141100'), ('141124', '临县', '141100'), ('141125', '柳林县', '141100'), ('141126', '石楼县', '141100'), ('141127', '岚县', '141100'), ('141128', '方山县', '141100'), ('141129', '中阳县', '141100'), ('141130', '交口县', '141100'), ('141181', '孝义市', '141100'), ('141182', '汾阳市', '141100'), ('150000', '内蒙古自治区', '0'), ('150100', '呼和浩特市', '150000'), ('150101', '市辖区', '150100'), ('150102', '新城区', '150100'), ('150103', '回民区', '150100'), ('150104', '玉泉区', '150100'), ('150105', '赛罕区', '150100'), ('150121', '土默特左旗', '150100'), ('150122', '托克托县', '150100'), ('150123', '和林格尔县', '150100'), ('150124', '清水河县', '150100'), ('150125', '武川县', '150100'), ('150200', '包头市', '150000'), ('150201', '市辖区', '150200'), ('150202', '东河区', '150200'), ('150203', '昆都仑区', '150200'), ('150204', '青山区', '150200'), ('150205', '石拐区', '150200'), ('150206', '白云鄂博矿区', '150200'), ('150207', '九原区', '150200'), ('150221', '土默特右旗', '150200'), ('150222', '固阳县', '150200'), ('150223', '达尔罕茂明安联合旗', '150200'), ('150300', '乌海市', '150000'), ('150301', '市辖区', '150300'), ('150302', '海勃湾区', '150300'), ('150303', '海南区', '150300'), ('150304', '乌达区', '150300'), ('150400', '赤峰市', '150000'), ('150401', '市辖区', '150400'), ('150402', '红山区', '150400'), ('150403', '元宝山区', '150400'), ('150404', '松山区', '150400'), ('150421', '阿鲁科尔沁旗', '150400'), ('150422', '巴林左旗', '150400'), ('150423', '巴林右旗', '150400'), ('150424', '林西县', '150400'), ('150425', '克什克腾旗', '150400'), ('150426', '翁牛特旗', '150400'), ('150428', '喀喇沁旗', '150400'), ('150429', '宁城县', '150400'), ('150430', '敖汉旗', '150400'), ('150500', '通辽市', '150000'), ('150501', '市辖区', '150500'), ('150502', '科尔沁区', '150500'), ('150521', '科尔沁左翼中旗', '150500'), ('150522', '科尔沁左翼后旗', '150500'), ('150523', '开鲁县', '150500'), ('150524', '库伦旗', '150500'), ('150525', '奈曼旗', '150500'), ('150526', '扎鲁特旗', '150500'), ('150581', '霍林郭勒市', '150500'), ('150600', '鄂尔多斯市', '150000'), ('150601', '市辖区', '150600'), ('150602', '东胜区', '150600'), ('150621', '达拉特旗', '150600'), ('150622', '准格尔旗', '150600'), ('150623', '鄂托克前旗', '150600'), ('150624', '鄂托克旗', '150600'), ('150625', '杭锦旗', '150600'), ('150626', '乌审旗', '150600'), ('150627', '伊金霍洛旗', '150600'), ('150700', '呼伦贝尔市', '150000'), ('150701', '市辖区', '150700'), ('150702', '海拉尔区', '150700'), ('150703', '扎赉诺尔区', '150700'), ('150721', '阿荣旗', '150700'), ('150722', '莫力达瓦达斡尔族自治旗', '150700'), ('150723', '鄂伦春自治旗', '150700'), ('150724', '鄂温克族自治旗', '150700'), ('150725', '陈巴尔虎旗', '150700'), ('150726', '新巴尔虎左旗', '150700'), ('150727', '新巴尔虎右旗', '150700'), ('150781', '满洲里市', '150700'), ('150782', '牙克石市', '150700'), ('150783', '扎兰屯市', '150700'), ('150784', '额尔古纳市', '150700'), ('150785', '根河市', '150700'), ('150800', '巴彦淖尔市', '150000'), ('150801', '市辖区', '150800'), ('150802', '临河区', '150800'), ('150821', '五原县', '150800'), ('150822', '磴口县', '150800'), ('150823', '乌拉特前旗', '150800'), ('150824', '乌拉特中旗', '150800'), ('150825', '乌拉特后旗', '150800'), ('150826', '杭锦后旗', '150800'), ('150900', '乌兰察布市', '150000'), ('150901', '市辖区', '150900'), ('150902', '集宁区', '150900'), ('150921', '卓资县', '150900'), ('150922', '化德县', '150900'), ('150923', '商都县', '150900'), ('150924', '兴和县', '150900'), ('150925', '凉城县', '150900'), ('150926', '察哈尔右翼前旗', '150900'), ('150927', '察哈尔右翼中旗', '150900'), ('150928', '察哈尔右翼后旗', '150900'), ('150929', '四子王旗', '150900'), ('150981', '丰镇市', '150900'), ('152200', '兴安盟', '150000'), ('152201', '乌兰浩特市', '152200'), ('152202', '阿尔山市', '152200'), ('152221', '科尔沁右翼前旗', '152200'), ('152222', '科尔沁右翼中旗', '152200'), ('152223', '扎赉特旗', '152200'), ('152224', '突泉县', '152200'), ('152500', '锡林郭勒盟', '150000'), ('152501', '二连浩特市', '152500'), ('152502', '锡林浩特市', '152500'), ('152522', '阿巴嘎旗', '152500'), ('152523', '苏尼特左旗', '152500'), ('152524', '苏尼特右旗', '152500'), ('152525', '东乌珠穆沁旗', '152500'), ('152526', '西乌珠穆沁旗', '152500'), ('152527', '太仆寺旗', '152500'), ('152528', '镶黄旗', '152500'), ('152529', '正镶白旗', '152500'), ('152530', '正蓝旗', '152500'), ('152531', '多伦县', '152500'), ('152900', '阿拉善盟', '150000'), ('152921', '阿拉善左旗', '152900'), ('152922', '阿拉善右旗', '152900'), ('152923', '额济纳旗', '152900'), ('210000', '辽宁省', '0'), ('210100', '沈阳市', '210000'), ('210101', '市辖区', '210100'), ('210102', '和平区', '210100'), ('210103', '沈河区', '210100'), ('210104', '大东区', '210100'), ('210105', '皇姑区', '210100'), ('210106', '铁西区', '210100'), ('210111', '苏家屯区', '210100'), ('210112', '浑南区', '210100'), ('210113', '沈北新区', '210100'), ('210114', '于洪区', '210100'), ('210122', '辽中县', '210100'), ('210123', '康平县', '210100'), ('210124', '法库县', '210100'), ('210181', '新民市', '210100'), ('210200', '大连市', '210000'), ('210201', '市辖区', '210200'), ('210202', '中山区', '210200'), ('210203', '西岗区', '210200'), ('210204', '沙河口区', '210200'), ('210211', '甘井子区', '210200'), ('210212', '旅顺口区', '210200'), ('210213', '金州区', '210200'), ('210224', '长海县', '210200'), ('210281', '瓦房店市', '210200'), ('210282', '普兰店市', '210200'), ('210283', '庄河市', '210200'), ('210300', '鞍山市', '210000'), ('210301', '市辖区', '210300'), ('210302', '铁东区', '210300'), ('210303', '铁西区', '210300'), ('210304', '立山区', '210300'), ('210311', '千山区', '210300'), ('210321', '台安县', '210300'), ('210323', '岫岩满族自治县', '210300'), ('210381', '海城市', '210300'), ('210400', '抚顺市', '210000'), ('210401', '市辖区', '210400'), ('210402', '新抚区', '210400'), ('210403', '东洲区', '210400'), ('210404', '望花区', '210400'), ('210411', '顺城区', '210400'), ('210421', '抚顺县', '210400'), ('210422', '新宾满族自治县', '210400'), ('210423', '清原满族自治县', '210400'), ('210500', '本溪市', '210000'), ('210501', '市辖区', '210500'), ('210502', '平山区', '210500'), ('210503', '溪湖区', '210500'), ('210504', '明山区', '210500'), ('210505', '南芬区', '210500'), ('210521', '本溪满族自治县', '210500'), ('210522', '桓仁满族自治县', '210500'), ('210600', '丹东市', '210000'), ('210601', '市辖区', '210600'), ('210602', '元宝区', '210600'), ('210603', '振兴区', '210600'), ('210604', '振安区', '210600'), ('210624', '宽甸满族自治县', '210600'), ('210681', '东港市', '210600'), ('210682', '凤城市', '210600'), ('210700', '锦州市', '210000'), ('210701', '市辖区', '210700'), ('210702', '古塔区', '210700'), ('210703', '凌河区', '210700'), ('210711', '太和区', '210700'), ('210726', '黑山县', '210700'), ('210727', '义县', '210700'), ('210781', '凌海市', '210700'), ('210782', '北镇市', '210700'), ('210800', '营口市', '210000'), ('210801', '市辖区', '210800'), ('210802', '站前区', '210800'), ('210803', '西市区', '210800'), ('210804', '鲅鱼圈区', '210800'), ('210811', '老边区', '210800'), ('210881', '盖州市', '210800'), ('210882', '大石桥市', '210800'), ('210900', '阜新市', '210000'), ('210901', '市辖区', '210900'), ('210902', '海州区', '210900'), ('210903', '新邱区', '210900'), ('210904', '太平区', '210900'), ('210905', '清河门区', '210900'), ('210911', '细河区', '210900'), ('210921', '阜新蒙古族自治县', '210900'), ('210922', '彰武县', '210900'), ('211000', '辽阳市', '210000'), ('211001', '市辖区', '211000'), ('211002', '白塔区', '211000'), ('211003', '文圣区', '211000'), ('211004', '宏伟区', '211000'), ('211005', '弓长岭区', '211000'), ('211011', '太子河区', '211000'), ('211021', '辽阳县', '211000'), ('211081', '灯塔市', '211000'), ('211100', '盘锦市', '210000'), ('211101', '市辖区', '211100'), ('211102', '双台子区', '211100'), ('211103', '兴隆台区', '211100'), ('211121', '大洼县', '211100'), ('211122', '盘山县', '211100'), ('211200', '铁岭市', '210000'), ('211201', '市辖区', '211200'), ('211202', '银州区', '211200'), ('211204', '清河区', '211200'), ('211221', '铁岭县', '211200'), ('211223', '西丰县', '211200'), ('211224', '昌图县', '211200'), ('211281', '调兵山市', '211200'), ('211282', '开原市', '211200'), ('211300', '朝阳市', '210000'), ('211301', '市辖区', '211300'), ('211302', '双塔区', '211300'), ('211303', '龙城区', '211300'), ('211321', '朝阳县', '211300'), ('211322', '建平县', '211300'), ('211324', '喀喇沁左翼蒙古族自治县', '211300'), ('211381', '北票市', '211300'), ('211382', '凌源市', '211300'), ('211400', '葫芦岛市', '210000'), ('211401', '市辖区', '211400'), ('211402', '连山区', '211400'), ('211403', '龙港区', '211400'), ('211404', '南票区', '211400'), ('211421', '绥中县', '211400'), ('211422', '建昌县', '211400'), ('211481', '兴城市', '211400'), ('220000', '吉林省', '0'), ('220100', '长春市', '220000'), ('220101', '市辖区', '220100'), ('220102', '南关区', '220100'), ('220103', '宽城区', '220100'), ('220104', '朝阳区', '220100'), ('220105', '二道区', '220100'), ('220106', '绿园区', '220100'), ('220112', '双阳区', '220100'), ('220113', '九台区', '220100'), ('220122', '农安县', '220100'), ('220182', '榆树市', '220100'), ('220183', '德惠市', '220100'), ('220200', '吉林市', '220000'), ('220201', '市辖区', '220200'), ('220202', '昌邑区', '220200'), ('220203', '龙潭区', '220200'), ('220204', '船营区', '220200'), ('220211', '丰满区', '220200'), ('220221', '永吉县', '220200'), ('220281', '蛟河市', '220200'), ('220282', '桦甸市', '220200'), ('220283', '舒兰市', '220200'), ('220284', '磐石市', '220200'), ('220300', '四平市', '220000'), ('220301', '市辖区', '220300'), ('220302', '铁西区', '220300'), ('220303', '铁东区', '220300'), ('220322', '梨树县', '220300'), ('220323', '伊通满族自治县', '220300'), ('220381', '公主岭市', '220300'), ('220382', '双辽市', '220300'), ('220400', '辽源市', '220000'), ('220401', '市辖区', '220400'), ('220402', '龙山区', '220400'), ('220403', '西安区', '220400'), ('220421', '东丰县', '220400'), ('220422', '东辽县', '220400'), ('220500', '通化市', '220000'), ('220501', '市辖区', '220500'), ('220502', '东昌区', '220500'), ('220503', '二道江区', '220500'), ('220521', '通化县', '220500'), ('220523', '辉南县', '220500'), ('220524', '柳河县', '220500'), ('220581', '梅河口市', '220500'), ('220582', '集安市', '220500'), ('220600', '白山市', '220000'), ('220601', '市辖区', '220600'), ('220602', '浑江区', '220600'), ('220605', '江源区', '220600'), ('220621', '抚松县', '220600'), ('220622', '靖宇县', '220600'), ('220623', '长白朝鲜族自治县', '220600'), ('220681', '临江市', '220600'), ('220700', '松原市', '220000'), ('220701', '市辖区', '220700'), ('220702', '宁江区', '220700'), ('220721', '前郭尔罗斯蒙古族自治县', '220700'), ('220722', '长岭县', '220700'), ('220723', '乾安县', '220700'), ('220781', '扶余市', '220700'), ('220800', '白城市', '220000'), ('220801', '市辖区', '220800'), ('220802', '洮北区', '220800'), ('220821', '镇赉县', '220800'), ('220822', '通榆县', '220800'), ('220881', '洮南市', '220800'), ('220882', '大安市', '220800'), ('222400', '延边朝鲜族自治州', '220000'), ('222401', '延吉市', '222400'), ('222402', '图们市', '222400'), ('222403', '敦化市', '222400'), ('222404', '珲春市', '222400'), ('222405', '龙井市', '222400'), ('222406', '和龙市', '222400'), ('222424', '汪清县', '222400'), ('222426', '安图县', '222400'), ('230000', '黑龙江省', '0'), ('230100', '哈尔滨市', '230000'), ('230101', '市辖区', '230100'), ('230102', '道里区', '230100'), ('230103', '南岗区', '230100'), ('230104', '道外区', '230100'), ('230108', '平房区', '230100'), ('230109', '松北区', '230100'), ('230110', '香坊区', '230100'), ('230111', '呼兰区', '230100'), ('230112', '阿城区', '230100'), ('230113', '双城区', '230100'), ('230123', '依兰县', '230100'), ('230124', '方正县', '230100'), ('230125', '宾县', '230100'), ('230126', '巴彦县', '230100'), ('230127', '木兰县', '230100'), ('230128', '通河县', '230100'), ('230129', '延寿县', '230100'), ('230183', '尚志市', '230100'), ('230184', '五常市', '230100'), ('230200', '齐齐哈尔市', '230000'), ('230201', '市辖区', '230200'), ('230202', '龙沙区', '230200'), ('230203', '建华区', '230200'), ('230204', '铁锋区', '230200'), ('230205', '昂昂溪区', '230200'), ('230206', '富拉尔基区', '230200'), ('230207', '碾子山区', '230200'), ('230208', '梅里斯达斡尔族区', '230200'), ('230221', '龙江县', '230200'), ('230223', '依安县', '230200'), ('230224', '泰来县', '230200'), ('230225', '甘南县', '230200'), ('230227', '富裕县', '230200'), ('230229', '克山县', '230200'), ('230230', '克东县', '230200'), ('230231', '拜泉县', '230200'), ('230281', '讷河市', '230200'), ('230300', '鸡西市', '230000'), ('230301', '市辖区', '230300'), ('230302', '鸡冠区', '230300'), ('230303', '恒山区', '230300'), ('230304', '滴道区', '230300'), ('230305', '梨树区', '230300'), ('230306', '城子河区', '230300'), ('230307', '麻山区', '230300'), ('230321', '鸡东县', '230300'), ('230381', '虎林市', '230300'), ('230382', '密山市', '230300'), ('230400', '鹤岗市', '230000'), ('230401', '市辖区', '230400'), ('230402', '向阳区', '230400'), ('230403', '工农区', '230400'), ('230404', '南山区', '230400'), ('230405', '兴安区', '230400'), ('230406', '东山区', '230400'), ('230407', '兴山区', '230400'), ('230421', '萝北县', '230400'), ('230422', '绥滨县', '230400'), ('230500', '双鸭山市', '230000'), ('230501', '市辖区', '230500'), ('230502', '尖山区', '230500'), ('230503', '岭东区', '230500'), ('230505', '四方台区', '230500'), ('230506', '宝山区', '230500'), ('230521', '集贤县', '230500'), ('230522', '友谊县', '230500'), ('230523', '宝清县', '230500'), ('230524', '饶河县', '230500'), ('230600', '大庆市', '230000'), ('230601', '市辖区', '230600'), ('230602', '萨尔图区', '230600'), ('230603', '龙凤区', '230600'), ('230604', '让胡路区', '230600'), ('230605', '红岗区', '230600'), ('230606', '大同区', '230600'), ('230621', '肇州县', '230600'), ('230622', '肇源县', '230600'), ('230623', '林甸县', '230600'), ('230624', '杜尔伯特蒙古族自治县', '230600'), ('230700', '伊春市', '230000'), ('230701', '市辖区', '230700'), ('230702', '伊春区', '230700'), ('230703', '南岔区', '230700'), ('230704', '友好区', '230700'), ('230705', '西林区', '230700'), ('230706', '翠峦区', '230700'), ('230707', '新青区', '230700'), ('230708', '美溪区', '230700'), ('230709', '金山屯区', '230700'), ('230710', '五营区', '230700'), ('230711', '乌马河区', '230700'), ('230712', '汤旺河区', '230700'), ('230713', '带岭区', '230700'), ('230714', '乌伊岭区', '230700'), ('230715', '红星区', '230700'), ('230716', '上甘岭区', '230700'), ('230722', '嘉荫县', '230700'), ('230781', '铁力市', '230700'), ('230800', '佳木斯市', '230000'), ('230801', '市辖区', '230800'), ('230803', '向阳区', '230800'), ('230804', '前进区', '230800'), ('230805', '东风区', '230800'), ('230811', '郊区', '230800'), ('230822', '桦南县', '230800'), ('230826', '桦川县', '230800'), ('230828', '汤原县', '230800'), ('230833', '抚远县', '230800'), ('230881', '同江市', '230800'), ('230882', '富锦市', '230800'), ('230900', '七台河市', '230000'), ('230901', '市辖区', '230900'), ('230902', '新兴区', '230900'), ('230903', '桃山区', '230900'), ('230904', '茄子河区', '230900'), ('230921', '勃利县', '230900'), ('231000', '牡丹江市', '230000'), ('231001', '市辖区', '231000'), ('231002', '东安区', '231000'), ('231003', '阳明区', '231000'), ('231004', '爱民区', '231000'), ('231005', '西安区', '231000'), ('231024', '东宁县', '231000'), ('231025', '林口县', '231000'), ('231081', '绥芬河市', '231000'), ('231083', '海林市', '231000'), ('231084', '宁安市', '231000'), ('231085', '穆棱市', '231000'), ('231100', '黑河市', '230000'), ('231101', '市辖区', '231100'), ('231102', '爱辉区', '231100'), ('231121', '嫩江县', '231100'), ('231123', '逊克县', '231100'), ('231124', '孙吴县', '231100'), ('231181', '北安市', '231100'), ('231182', '五大连池市', '231100'), ('231200', '绥化市', '230000'), ('231201', '市辖区', '231200'), ('231202', '北林区', '231200'), ('231221', '望奎县', '231200'), ('231222', '兰西县', '231200'), ('231223', '青冈县', '231200'), ('231224', '庆安县', '231200'), ('231225', '明水县', '231200'), ('231226', '绥棱县', '231200'), ('231281', '安达市', '231200'), ('231282', '肇东市', '231200'), ('231283', '海伦市', '231200'), ('232700', '大兴安岭地区', '230000'), ('232721', '呼玛县', '232700'), ('232722', '塔河县', '232700'), ('232723', '漠河县', '232700'), ('310000', '上海', '0'), ('310100', '上海市', '310000'), ('310101', '黄浦区', '310100'), ('310104', '徐汇区', '310100'), ('310105', '长宁区', '310100'), ('310106', '静安区', '310100'), ('310107', '普陀区', '310100'), ('310108', '闸北区', '310100'), ('310109', '虹口区', '310100'), ('310110', '杨浦区', '310100'), ('310112', '闵行区', '310100'), ('310113', '宝山区', '310100'), ('310114', '嘉定区', '310100'), ('310115', '浦东新区', '310100'), ('310116', '金山区', '310100'), ('310117', '松江区', '310100'), ('310118', '青浦区', '310100'), ('310120', '奉贤区', '310100'), ('310230', '崇明县', '310100'), ('320000', '江苏省', '0'), ('320100', '南京市', '320000'), ('320101', '市辖区', '320100'), ('320102', '玄武区', '320100'), ('320104', '秦淮区', '320100'), ('320105', '建邺区', '320100'), ('320106', '鼓楼区', '320100'), ('320111', '浦口区', '320100'), ('320113', '栖霞区', '320100'), ('320114', '雨花台区', '320100'), ('320115', '江宁区', '320100'), ('320116', '六合区', '320100'), ('320117', '溧水区', '320100'), ('320118', '高淳区', '320100'), ('320200', '无锡市', '320000'), ('320201', '市辖区', '320200'), ('320202', '崇安区', '320200'), ('320203', '南长区', '320200'), ('320204', '北塘区', '320200'), ('320205', '锡山区', '320200'), ('320206', '惠山区', '320200'), ('320211', '滨湖区', '320200'), ('320281', '江阴市', '320200'), ('320282', '宜兴市', '320200'), ('320300', '徐州市', '320000'), ('320301', '市辖区', '320300'), ('320302', '鼓楼区', '320300'), ('320303', '云龙区', '320300'), ('320305', '贾汪区', '320300'), ('320311', '泉山区', '320300'), ('320312', '铜山区', '320300'), ('320321', '丰县', '320300'), ('320322', '沛县', '320300'), ('320324', '睢宁县', '320300'), ('320381', '新沂市', '320300'), ('320382', '邳州市', '320300'), ('320400', '常州市', '320000'), ('320401', '市辖区', '320400'), ('320402', '天宁区', '320400'), ('320404', '钟楼区', '320400'), ('320405', '戚墅堰区', '320400'), ('320411', '新北区', '320400'), ('320412', '武进区', '320400'), ('320481', '溧阳市', '320400'), ('320482', '金坛市', '320400'), ('320500', '苏州市', '320000'), ('320501', '市辖区', '320500'), ('320505', '虎丘区', '320500'), ('320506', '吴中区', '320500'), ('320507', '相城区', '320500'), ('320508', '姑苏区', '320500'), ('320509', '吴江区', '320500'), ('320581', '常熟市', '320500'), ('320582', '张家港市', '320500'), ('320583', '昆山市', '320500'), ('320585', '太仓市', '320500'), ('320600', '南通市', '320000'), ('320601', '市辖区', '320600'), ('320602', '崇川区', '320600'), ('320611', '港闸区', '320600'), ('320612', '通州区', '320600'), ('320621', '海安县', '320600'), ('320623', '如东县', '320600'), ('320671', '经济技术开发区', '320600'), ('320681', '启东市', '320600'), ('320682', '如皋市', '320600'), ('320684', '海门市', '320600'), ('320700', '连云港市', '320000'), ('320701', '市辖区', '320700'), ('320703', '连云区', '320700'), ('320706', '海州区', '320700'), ('320707', '赣榆区', '320700'), ('320722', '东海县', '320700'), ('320723', '灌云县', '320700'), ('320724', '灌南县', '320700'), ('320800', '淮安市', '320000'), ('320801', '市辖区', '320800'), ('320802', '清河区', '320800'), ('320803', '淮安区', '320800'), ('320804', '淮阴区', '320800'), ('320811', '清浦区', '320800'), ('320812', '清江浦区', '320800'), ('320826', '涟水县', '320800'), ('320829', '洪泽县', '320800'), ('320830', '盱眙县', '320800'), ('320831', '金湖县', '320800'), ('320900', '盐城市', '320000'), ('320901', '市辖区', '320900'), ('320902', '亭湖区', '320900'), ('320903', '盐都区', '320900'), ('320921', '响水县', '320900'), ('320922', '滨海县', '320900'), ('320923', '阜宁县', '320900'), ('320924', '射阳县', '320900'), ('320925', '建湖县', '320900'), ('320981', '东台市', '320900'), ('320982', '大丰市', '320900'), ('321000', '扬州市', '320000'), ('321001', '市辖区', '321000'), ('321002', '广陵区', '321000'), ('321003', '邗江区', '321000'), ('321012', '江都区', '321000'), ('321023', '宝应县', '321000'), ('321081', '仪征市', '321000'), ('321084', '高邮市', '321000'), ('321100', '镇江市', '320000'), ('321101', '市辖区', '321100'), ('321102', '京口区', '321100'), ('321111', '润州区', '321100'), ('321112', '丹徒区', '321100'), ('321181', '丹阳市', '321100'), ('321182', '扬中市', '321100'), ('321183', '句容市', '321100'), ('321200', '泰州市', '320000'), ('321201', '市辖区', '321200'), ('321202', '海陵区', '321200'), ('321203', '高港区', '321200'), ('321204', '姜堰区', '321200'), ('321281', '兴化市', '321200'), ('321282', '靖江市', '321200'), ('321283', '泰兴市', '321200'), ('321300', '宿迁市', '320000'), ('321301', '市辖区', '321300'), ('321302', '宿城区', '321300'), ('321311', '宿豫区', '321300'), ('321322', '沭阳县', '321300'), ('321323', '泗阳县', '321300'), ('321324', '泗洪县', '321300'), ('330000', '浙江省', '0'), ('330100', '杭州市', '330000'), ('330101', '市辖区', '330100'), ('330102', '上城区', '330100'), ('330103', '下城区', '330100'), ('330104', '江干区', '330100'), ('330105', '拱墅区', '330100'), ('330106', '西湖区', '330100'), ('330108', '滨江区', '330100'), ('330109', '萧山区', '330100'), ('330110', '余杭区', '330100'), ('330111', '富阳区', '330100'), ('330122', '桐庐县', '330100'), ('330127', '淳安县', '330100'), ('330182', '建德市', '330100'), ('330185', '临安市', '330100'), ('330200', '宁波市', '330000'), ('330201', '市辖区', '330200'), ('330203', '海曙区', '330200'), ('330204', '江东区', '330200'), ('330205', '江北区', '330200'), ('330206', '北仑区', '330200'), ('330211', '镇海区', '330200'), ('330212', '鄞州区', '330200'), ('330225', '象山县', '330200'), ('330226', '宁海县', '330200'), ('330281', '余姚市', '330200'), ('330282', '慈溪市', '330200'), ('330283', '奉化市', '330200'), ('330300', '温州市', '330000'), ('330301', '市辖区', '330300'), ('330302', '鹿城区', '330300'), ('330303', '龙湾区', '330300'), ('330304', '瓯海区', '330300'), ('330322', '洞头县', '330300'), ('330324', '永嘉县', '330300'), ('330326', '平阳县', '330300'), ('330327', '苍南县', '330300'), ('330328', '文成县', '330300'), ('330329', '泰顺县', '330300'), ('330381', '瑞安市', '330300'), ('330382', '乐清市', '330300'), ('330400', '嘉兴市', '330000'), ('330401', '市辖区', '330400'), ('330402', '南湖区', '330400'), ('330411', '秀洲区', '330400'), ('330421', '嘉善县', '330400'), ('330424', '海盐县', '330400'), ('330481', '海宁市', '330400'), ('330482', '平湖市', '330400'), ('330483', '桐乡市', '330400'), ('330500', '湖州市', '330000'), ('330501', '市辖区', '330500'), ('330502', '吴兴区', '330500'), ('330503', '南浔区', '330500'), ('330521', '德清县', '330500'), ('330522', '长兴县', '330500'), ('330523', '安吉县', '330500'), ('330600', '绍兴市', '330000'), ('330601', '市辖区', '330600'), ('330602', '越城区', '330600'), ('330603', '柯桥区', '330600'), ('330604', '上虞区', '330600'), ('330624', '新昌县', '330600'), ('330681', '诸暨市', '330600'), ('330683', '嵊州市', '330600'), ('330700', '金华市', '330000'), ('330701', '市辖区', '330700'), ('330702', '婺城区', '330700'), ('330703', '金东区', '330700'), ('330723', '武义县', '330700'), ('330726', '浦江县', '330700'), ('330727', '磐安县', '330700'), ('330781', '兰溪市', '330700'), ('330782', '义乌市', '330700'), ('330783', '东阳市', '330700'), ('330784', '永康市', '330700'), ('330800', '衢州市', '330000'), ('330801', '市辖区', '330800'), ('330802', '柯城区', '330800'), ('330803', '衢江区', '330800'), ('330822', '常山县', '330800'), ('330824', '开化县', '330800'), ('330825', '龙游县', '330800'), ('330881', '江山市', '330800'), ('330900', '舟山市', '330000'), ('330901', '市辖区', '330900'), ('330902', '定海区', '330900'), ('330903', '普陀区', '330900'), ('330921', '岱山县', '330900'), ('330922', '嵊泗县', '330900'), ('331000', '台州市', '330000'), ('331001', '市辖区', '331000'), ('331002', '椒江区', '331000'), ('331003', '黄岩区', '331000'), ('331004', '路桥区', '331000'), ('331021', '玉环县', '331000'), ('331022', '三门县', '331000'), ('331023', '天台县', '331000'), ('331024', '仙居县', '331000'), ('331081', '温岭市', '331000'), ('331082', '临海市', '331000'), ('331100', '丽水市', '330000'), ('331101', '市辖区', '331100'), ('331102', '莲都区', '331100'), ('331121', '青田县', '331100'), ('331122', '缙云县', '331100'), ('331123', '遂昌县', '331100'), ('331124', '松阳县', '331100'), ('331125', '云和县', '331100'), ('331126', '庆元县', '331100'), ('331127', '景宁畲族自治县', '331100'), ('331181', '龙泉市', '331100'), ('340000', '安徽省', '0'), ('340100', '合肥市', '340000'), ('340101', '市辖区', '340100'), ('340102', '瑶海区', '340100'), ('340103', '庐阳区', '340100'), ('340104', '蜀山区', '340100'), ('340111', '包河区', '340100'), ('340121', '长丰县', '340100'), ('340122', '肥东县', '340100'), ('340123', '肥西县', '340100'), ('340124', '庐江县', '340100'), ('340181', '巢湖市', '340100'), ('340200', '芜湖市', '340000'), ('340201', '市辖区', '340200'), ('340202', '镜湖区', '340200'), ('340203', '弋江区', '340200'), ('340207', '鸠江区', '340200'), ('340208', '三山区', '340200'), ('340221', '芜湖县', '340200'), ('340222', '繁昌县', '340200'), ('340223', '南陵县', '340200'), ('340225', '无为县', '340200'), ('340300', '蚌埠市', '340000'), ('340301', '市辖区', '340300'), ('340302', '龙子湖区', '340300'), ('340303', '蚌山区', '340300'), ('340304', '禹会区', '340300'), ('340311', '淮上区', '340300'), ('340321', '怀远县', '340300'), ('340322', '五河县', '340300'), ('340323', '固镇县', '340300'), ('340400', '淮南市', '340000'), ('340401', '市辖区', '340400'), ('340402', '大通区', '340400'), ('340403', '田家庵区', '340400'), ('340404', '谢家集区', '340400'), ('340405', '八公山区', '340400'), ('340406', '潘集区', '340400'), ('340421', '凤台县', '340400'), ('340500', '马鞍山市', '340000'), ('340501', '市辖区', '340500'), ('340503', '花山区', '340500'), ('340504', '雨山区', '340500'), ('340506', '博望区', '340500'), ('340521', '当涂县', '340500'), ('340522', '含山县', '340500'), ('340523', '和县', '340500'), ('340600', '淮北市', '340000'), ('340601', '市辖区', '340600'), ('340602', '杜集区', '340600'), ('340603', '相山区', '340600'), ('340604', '烈山区', '340600'), ('340621', '濉溪县', '340600'), ('340700', '铜陵市', '340000'), ('340701', '市辖区', '340700'), ('340702', '铜官山区', '340700'), ('340703', '狮子山区', '340700'), ('340711', '郊区', '340700'), ('340721', '铜陵县', '340700'), ('340800', '安庆市', '340000'), ('340801', '市辖区', '340800'), ('340802', '迎江区', '340800'), ('340803', '大观区', '340800'), ('340811', '宜秀区', '340800'), ('340822', '怀宁县', '340800'), ('340823', '枞阳县', '340800'), ('340824', '潜山县', '340800'), ('340825', '太湖县', '340800'), ('340826', '宿松县', '340800'), ('340827', '望江县', '340800'), ('340828', '岳西县', '340800'), ('340881', '桐城市', '340800'), ('341000', '黄山市', '340000'), ('341001', '市辖区', '341000'), ('341002', '屯溪区', '341000'), ('341003', '黄山区', '341000'), ('341004', '徽州区', '341000'), ('341021', '歙县', '341000'), ('341022', '休宁县', '341000'), ('341023', '黟县', '341000'), ('341024', '祁门县', '341000'), ('341100', '滁州市', '340000'), ('341101', '市辖区', '341100'), ('341102', '琅琊区', '341100'), ('341103', '南谯区', '341100'), ('341122', '来安县', '341100'), ('341124', '全椒县', '341100'), ('341125', '定远县', '341100'), ('341126', '凤阳县', '341100'), ('341181', '天长市', '341100'), ('341182', '明光市', '341100'), ('341200', '阜阳市', '340000'), ('341201', '市辖区', '341200'), ('341202', '颍州区', '341200'), ('341203', '颍东区', '341200'), ('341204', '颍泉区', '341200'), ('341221', '临泉县', '341200'), ('341222', '太和县', '341200'), ('341225', '阜南县', '341200'), ('341226', '颍上县', '341200'), ('341282', '界首市', '341200'), ('341300', '宿州市', '340000'), ('341301', '市辖区', '341300'), ('341302', '埇桥区', '341300'), ('341321', '砀山县', '341300'), ('341322', '萧县', '341300'), ('341323', '灵璧县', '341300'), ('341324', '泗县', '341300'), ('341500', '六安市', '340000'), ('341501', '市辖区', '341500'), ('341502', '金安区', '341500'), ('341503', '裕安区', '341500'), ('341521', '寿县', '341500'), ('341522', '霍邱县', '341500'), ('341523', '舒城县', '341500'), ('341524', '金寨县', '341500'), ('341525', '霍山县', '341500'), ('341600', '亳州市', '340000'), ('341601', '市辖区', '341600'), ('341602', '谯城区', '341600'), ('341621', '涡阳县', '341600'), ('341622', '蒙城县', '341600'), ('341623', '利辛县', '341600'), ('341700', '池州市', '340000'), ('341701', '市辖区', '341700'), ('341702', '贵池区', '341700'), ('341721', '东至县', '341700'), ('341722', '石台县', '341700'), ('341723', '青阳县', '341700'), ('341800', '宣城市', '340000'), ('341801', '市辖区', '341800'), ('341802', '宣州区', '341800'), ('341821', '郎溪县', '341800'), ('341822', '广德县', '341800'), ('341823', '泾县', '341800'), ('341824', '绩溪县', '341800'), ('341825', '旌德县', '341800'), ('341881', '宁国市', '341800'), ('350000', '福建省', '0'), ('350100', '福州市', '350000'), ('350101', '市辖区', '350100'), ('350102', '鼓楼区', '350100'), ('350103', '台江区', '350100'), ('350104', '仓山区', '350100'), ('350105', '马尾区', '350100'), ('350111', '晋安区', '350100'), ('350121', '闽侯县', '350100'), ('350122', '连江县', '350100'), ('350123', '罗源县', '350100'), ('350124', '闽清县', '350100'), ('350125', '永泰县', '350100'), ('350128', '平潭县', '350100'), ('350181', '福清市', '350100'), ('350182', '长乐市', '350100'), ('350200', '厦门市', '350000'), ('350201', '市辖区', '350200'), ('350203', '思明区', '350200'), ('350205', '海沧区', '350200'), ('350206', '湖里区', '350200'), ('350211', '集美区', '350200'), ('350212', '同安区', '350200'), ('350213', '翔安区', '350200'), ('350300', '莆田市', '350000'), ('350301', '市辖区', '350300'), ('350302', '城厢区', '350300'), ('350303', '涵江区', '350300'), ('350304', '荔城区', '350300'), ('350305', '秀屿区', '350300'), ('350322', '仙游县', '350300'), ('350400', '三明市', '350000'), ('350401', '市辖区', '350400'), ('350402', '梅列区', '350400'), ('350403', '三元区', '350400'), ('350421', '明溪县', '350400'), ('350423', '清流县', '350400'), ('350424', '宁化县', '350400'), ('350425', '大田县', '350400'), ('350426', '尤溪县', '350400'), ('350427', '沙县', '350400'), ('350428', '将乐县', '350400'), ('350429', '泰宁县', '350400'), ('350430', '建宁县', '350400'), ('350481', '永安市', '350400'), ('350500', '泉州市', '350000'), ('350501', '市辖区', '350500'), ('350502', '鲤城区', '350500'), ('350503', '丰泽区', '350500'), ('350504', '洛江区', '350500'), ('350505', '泉港区', '350500'), ('350521', '惠安县', '350500'), ('350524', '安溪县', '350500'), ('350525', '永春县', '350500'), ('350526', '德化县', '350500'), ('350527', '金门县', '350500'), ('350581', '石狮市', '350500'), ('350582', '晋江市', '350500'), ('350583', '南安市', '350500'), ('350600', '漳州市', '350000'), ('350601', '市辖区', '350600'), ('350602', '芗城区', '350600'), ('350603', '龙文区', '350600'), ('350622', '云霄县', '350600'), ('350623', '漳浦县', '350600'), ('350624', '诏安县', '350600'), ('350625', '长泰县', '350600'), ('350626', '东山县', '350600'), ('350627', '南靖县', '350600'), ('350628', '平和县', '350600'), ('350629', '华安县', '350600'), ('350681', '龙海市', '350600'), ('350700', '南平市', '350000'), ('350701', '市辖区', '350700'), ('350702', '延平区', '350700'), ('350703', '建阳区', '350700'), ('350721', '顺昌县', '350700'), ('350722', '浦城县', '350700'), ('350723', '光泽县', '350700'), ('350724', '松溪县', '350700'), ('350725', '政和县', '350700'), ('350781', '邵武市', '350700'), ('350782', '武夷山市', '350700'), ('350783', '建瓯市', '350700'), ('350800', '龙岩市', '350000'), ('350801', '市辖区', '350800'), ('350802', '新罗区', '350800'), ('350803', '永定区', '350800'), ('350821', '长汀县', '350800'), ('350823', '上杭县', '350800'), ('350824', '武平县', '350800'), ('350825', '连城县', '350800'), ('350881', '漳平市', '350800'), ('350900', '宁德市', '350000'), ('350901', '市辖区', '350900'), ('350902', '蕉城区', '350900'), ('350921', '霞浦县', '350900'), ('350922', '古田县', '350900'), ('350923', '屏南县', '350900'), ('350924', '寿宁县', '350900'), ('350925', '周宁县', '350900'), ('350926', '柘荣县', '350900'), ('350981', '福安市', '350900'), ('350982', '福鼎市', '350900'), ('360000', '江西省', '0'), ('360100', '南昌市', '360000'), ('360101', '市辖区', '360100'), ('360102', '东湖区', '360100'), ('360103', '西湖区', '360100'), ('360104', '青云谱区', '360100'), ('360105', '湾里区', '360100'), ('360111', '青山湖区', '360100'), ('360121', '南昌县', '360100'), ('360122', '新建县', '360100'), ('360123', '安义县', '360100'), ('360124', '进贤县', '360100'), ('360200', '景德镇市', '360000'), ('360201', '市辖区', '360200'), ('360202', '昌江区', '360200'), ('360203', '珠山区', '360200'), ('360222', '浮梁县', '360200'), ('360281', '乐平市', '360200'), ('360300', '萍乡市', '360000'), ('360301', '市辖区', '360300'), ('360302', '安源区', '360300'), ('360313', '湘东区', '360300'), ('360321', '莲花县', '360300'), ('360322', '上栗县', '360300'), ('360323', '芦溪县', '360300'), ('360400', '九江市', '360000'), ('360401', '市辖区', '360400'), ('360402', '濂溪区', '360400'), ('360403', '浔阳区', '360400'), ('360404', '庐山区', '360400'), ('360421', '九江县', '360400'), ('360423', '武宁县', '360400'), ('360424', '修水县', '360400'), ('360425', '永修县', '360400'), ('360426', '德安县', '360400'), ('360427', '星子县', '360400'), ('360428', '都昌县', '360400'), ('360429', '湖口县', '360400'), ('360430', '彭泽县', '360400'), ('360481', '瑞昌市', '360400'), ('360482', '共青城市', '360400'), ('360500', '新余市', '360000'), ('360501', '市辖区', '360500'), ('360502', '渝水区', '360500'), ('360503', '高新区', '360500'), ('360521', '分宜县', '360500'), ('360600', '鹰潭市', '360000'), ('360601', '市辖区', '360600'), ('360602', '月湖区', '360600'), ('360622', '余江县', '360600'), ('360681', '贵溪市', '360600'), ('360700', '赣州市', '360000'), ('360701', '市辖区', '360700'), ('360702', '章贡区', '360700'), ('360703', '南康区', '360700'), ('360721', '赣县', '360700'), ('360722', '信丰县', '360700'), ('360723', '大余县', '360700'), ('360724', '上犹县', '360700'), ('360725', '崇义县', '360700'), ('360726', '安远县', '360700'), ('360727', '龙南县', '360700'), ('360728', '定南县', '360700'), ('360729', '全南县', '360700'), ('360730', '宁都县', '360700'), ('360731', '于都县', '360700'), ('360732', '兴国县', '360700'), ('360733', '会昌县', '360700'), ('360734', '寻乌县', '360700'), ('360735', '石城县', '360700'), ('360781', '瑞金市', '360700'), ('360783', '经济技术开发区', '360700'), ('360800', '吉安市', '360000'), ('360801', '市辖区', '360800'), ('360802', '吉州区', '360800'), ('360803', '青原区', '360800'), ('360821', '吉安县', '360800'), ('360822', '吉水县', '360800'), ('360823', '峡江县', '360800'), ('360824', '新干县', '360800'), ('360825', '永丰县', '360800'), ('360826', '泰和县', '360800'), ('360827', '遂川县', '360800'), ('360828', '万安县', '360800'), ('360829', '安福县', '360800'), ('360830', '永新县', '360800'), ('360881', '井冈山市', '360800'), ('360900', '宜春市', '360000'), ('360901', '市辖区', '360900'), ('360902', '袁州区', '360900'), ('360921', '奉新县', '360900'), ('360922', '万载县', '360900'), ('360923', '上高县', '360900'), ('360924', '宜丰县', '360900'), ('360925', '靖安县', '360900'), ('360926', '铜鼓县', '360900'), ('360981', '丰城市', '360900'), ('360982', '樟树市', '360900'), ('360983', '高安市', '360900'), ('361000', '抚州市', '360000'), ('361001', '市辖区', '361000'), ('361002', '临川区', '361000'), ('361021', '南城县', '361000'), ('361022', '黎川县', '361000'), ('361023', '南丰县', '361000'), ('361024', '崇仁县', '361000'), ('361025', '乐安县', '361000'), ('361026', '宜黄县', '361000'), ('361027', '金溪县', '361000'), ('361028', '资溪县', '361000'), ('361029', '东乡县', '361000'), ('361030', '广昌县', '361000'), ('361100', '上饶市', '360000'), ('361101', '市辖区', '361100'), ('361102', '信州区', '361100'), ('361121', '上饶县', '361100'), ('361122', '广丰县', '361100'), ('361123', '玉山县', '361100'), ('361124', '铅山县', '361100'), ('361125', '横峰县', '361100'), ('361126', '弋阳县', '361100'), ('361127', '余干县', '361100'), ('361128', '鄱阳县', '361100'), ('361129', '万年县', '361100'), ('361130', '婺源县', '361100'), ('361181', '德兴市', '361100'), ('370000', '山东省', '0'), ('370100', '济南市', '370000'), ('370101', '市辖区', '370100'), ('370102', '历下区', '370100'), ('370103', '市中区', '370100'), ('370104', '槐荫区', '370100'), ('370105', '天桥区', '370100'), ('370112', '历城区', '370100'), ('370113', '长清区', '370100'), ('370124', '平阴县', '370100'), ('370125', '济阳县', '370100'), ('370126', '商河县', '370100'), ('370130', '莱芜区', '370100'), ('370181', '章丘市', '370100'), ('370200', '青岛市', '370000'), ('370201', '市辖区', '370200'), ('370202', '市南区', '370200'), ('370203', '市北区', '370200'), ('370211', '黄岛区', '370200'), ('370212', '崂山区', '370200'), ('370213', '李沧区', '370200'), ('370214', '城阳区', '370200'), ('370281', '胶州市', '370200'), ('370282', '即墨市', '370200'), ('370283', '平度市', '370200'), ('370285', '莱西市', '370200'), ('370300', '淄博市', '370000'), ('370301', '市辖区', '370300'), ('370302', '淄川区', '370300'), ('370303', '张店区', '370300'), ('370304', '博山区', '370300'), ('370305', '临淄区', '370300'), ('370306', '周村区', '370300'), ('370321', '桓台县', '370300'), ('370322', '高青县', '370300'), ('370323', '沂源县', '370300'), ('370400', '枣庄市', '370000'), ('370401', '市辖区', '370400'), ('370402', '市中区', '370400'), ('370403', '薛城区', '370400'), ('370404', '峄城区', '370400'), ('370405', '台儿庄区', '370400'), ('370406', '山亭区', '370400'), ('370481', '滕州市', '370400'), ('370500', '东营市', '370000'), ('370501', '市辖区', '370500'), ('370502', '东营区', '370500'), ('370503', '河口区', '370500'), ('370521', '垦利县', '370500'), ('370522', '利津县', '370500'), ('370523', '广饶县', '370500'), ('370600', '烟台市', '370000'), ('370601', '市辖区', '370600'), ('370602', '芝罘区', '370600'), ('370611', '福山区', '370600'), ('370612', '牟平区', '370600'), ('370613', '莱山区', '370600'), ('370634', '长岛县', '370600'), ('370681', '龙口市', '370600'), ('370682', '莱阳市', '370600'), ('370683', '莱州市', '370600'), ('370684', '蓬莱市', '370600'), ('370685', '招远市', '370600'), ('370686', '栖霞市', '370600'), ('370687', '海阳市', '370600'), ('370700', '潍坊市', '370000'), ('370701', '市辖区', '370700'), ('370702', '潍城区', '370700'), ('370703', '寒亭区', '370700'), ('370704', '坊子区', '370700'), ('370705', '奎文区', '370700'), ('370724', '临朐县', '370700'), ('370725', '昌乐县', '370700'), ('370781', '青州市', '370700'), ('370782', '诸城市', '370700'), ('370783', '寿光市', '370700'), ('370784', '安丘市', '370700'), ('370785', '高密市', '370700'), ('370786', '昌邑市', '370700'), ('370800', '济宁市', '370000'), ('370801', '市辖区', '370800'), ('370811', '任城区', '370800'), ('370812', '兖州区', '370800'), ('370826', '微山县', '370800'), ('370827', '鱼台县', '370800'), ('370828', '金乡县', '370800'), ('370829', '嘉祥县', '370800'), ('370830', '汶上县', '370800'), ('370831', '泗水县', '370800'), ('370832', '梁山县', '370800'), ('370881', '曲阜市', '370800'), ('370883', '邹城市', '370800'), ('370900', '泰安市', '370000'), ('370901', '市辖区', '370900'), ('370902', '泰山区', '370900'), ('370911', '岱岳区', '370900'), ('370921', '宁阳县', '370900'), ('370923', '东平县', '370900'), ('370982', '新泰市', '370900'), ('370983', '肥城市', '370900'), ('371000', '威海市', '370000'), ('371001', '市辖区', '371000'), ('371002', '环翠区', '371000'), ('371081', '文登市', '371000'), ('371082', '荣成市', '371000'), ('371083', '乳山市', '371000'), ('371100', '日照市', '370000'), ('371101', '市辖区', '371100'), ('371102', '东港区', '371100'), ('371103', '岚山区', '371100'), ('371121', '五莲县', '371100'), ('371122', '莒县', '371100'), ('371200', '莱芜市', '370000'), ('371201', '市辖区', '371200'), ('371202', '莱城区', '371200'), ('371203', '钢城区', '371200'), ('371300', '临沂市', '370000'), ('371301', '市辖区', '371300'), ('371302', '兰山区', '371300'), ('371311', '罗庄区', '371300'), ('371312', '河东区', '371300'), ('371321', '沂南县', '371300'), ('371322', '郯城县', '371300'), ('371323', '沂水县', '371300'), ('371324', '兰陵县', '371300'), ('371325', '费县', '371300'), ('371326', '平邑县', '371300'), ('371327', '莒南县', '371300'), ('371328', '蒙阴县', '371300'), ('371329', '临沭县', '371300'), ('371400', '德州市', '370000'), ('371401', '市辖区', '371400'), ('371402', '德城区', '371400'), ('371403', '陵城区', '371400'), ('371422', '宁津县', '371400'), ('371423', '庆云县', '371400'), ('371424', '临邑县', '371400'), ('371425', '齐河县', '371400'), ('371426', '平原县', '371400'), ('371427', '夏津县', '371400'), ('371428', '武城县', '371400'), ('371481', '乐陵市', '371400'), ('371482', '禹城市', '371400'), ('371500', '聊城市', '370000'), ('371501', '市辖区', '371500'), ('371502', '东昌府区', '371500'), ('371521', '阳谷县', '371500'), ('371522', '莘县', '371500'), ('371523', '茌平县', '371500'), ('371524', '东阿县', '371500'), ('371525', '冠县', '371500'), ('371526', '高唐县', '371500'), ('371581', '临清市', '371500'), ('371600', '滨州市', '370000'), ('371601', '市辖区', '371600'), ('371602', '滨城区', '371600'), ('371603', '沾化区', '371600'), ('371621', '惠民县', '371600'), ('371622', '阳信县', '371600'), ('371623', '无棣县', '371600'), ('371625', '博兴县', '371600'), ('371626', '邹平县', '371600'), ('371700', '菏泽市', '370000'), ('371701', '市辖区', '371700'), ('371702', '牡丹区', '371700'), ('371721', '曹县', '371700'), ('371722', '单县', '371700'), ('371723', '成武县', '371700'), ('371724', '巨野县', '371700'), ('371725', '郓城县', '371700'), ('371726', '鄄城县', '371700'), ('371727', '定陶县', '371700'), ('371728', '东明县', '371700'), ('410000', '河南省', '0'), ('410100', '郑州市', '410000'), ('410101', '市辖区', '410100'), ('410102', '中原区', '410100'), ('410103', '二七区', '410100'), ('410104', '管城回族区', '410100'), ('410105', '金水区', '410100'), ('410106', '上街区', '410100'), ('410108', '惠济区', '410100'), ('410122', '中牟县', '410100'), ('410181', '巩义市', '410100'), ('410182', '荥阳市', '410100'), ('410183', '新密市', '410100'), ('410184', '新郑市', '410100'), ('410185', '登封市', '410100'), ('410186', '郑东新区', '410100'), ('410200', '开封市', '410000'), ('410201', '市辖区', '410200'), ('410202', '龙亭区', '410200'), ('410203', '顺河回族区', '410200'), ('410204', '鼓楼区', '410200'), ('410205', '禹王台区', '410200'), ('410211', '金明新区', '410200'), ('410212', '祥符区', '410200'), ('410221', '杞县', '410200'), ('410222', '通许县', '410200'), ('410223', '尉氏县', '410200'), ('410225', '兰考县', '410200'), ('410300', '洛阳市', '410000'), ('410301', '市辖区', '410300'), ('410302', '老城区', '410300'), ('410303', '西工区', '410300'), ('410304', '瀍河回族区', '410300'), ('410305', '涧西区', '410300'), ('410306', '吉利区', '410300'), ('410311', '洛龙区', '410300'), ('410322', '孟津县', '410300'), ('410323', '新安县', '410300'), ('410324', '栾川县', '410300'), ('410325', '嵩县', '410300'), ('410326', '汝阳县', '410300'), ('410327', '宜阳县', '410300'), ('410328', '洛宁县', '410300'), ('410329', '伊川县', '410300'), ('410381', '偃师市', '410300'), ('410400', '平顶山市', '410000'), ('410401', '市辖区', '410400'), ('410402', '新华区', '410400'), ('410403', '卫东区', '410400'), ('410404', '石龙区', '410400'), ('410411', '湛河区', '410400'), ('410421', '宝丰县', '410400'), ('410422', '叶县', '410400'), ('410423', '鲁山县', '410400'), ('410425', '郏县', '410400'), ('410481', '舞钢市', '410400'), ('410482', '汝州市', '410400'), ('410500', '安阳市', '410000'), ('410501', '市辖区', '410500'), ('410502', '文峰区', '410500'), ('410503', '北关区', '410500'), ('410505', '殷都区', '410500'), ('410506', '龙安区', '410500'), ('410522', '安阳县', '410500'), ('410523', '汤阴县', '410500'), ('410526', '滑县', '410500'), ('410527', '内黄县', '410500'), ('410581', '林州市', '410500'), ('410600', '鹤壁市', '410000'), ('410601', '市辖区', '410600'), ('410602', '鹤山区', '410600'), ('410603', '山城区', '410600'), ('410611', '淇滨区', '410600'), ('410621', '浚县', '410600'), ('410622', '淇县', '410600'), ('410700', '新乡市', '410000'), ('410701', '市辖区', '410700'), ('410702', '红旗区', '410700'), ('410703', '卫滨区', '410700'), ('410704', '凤泉区', '410700'), ('410711', '牧野区', '410700'), ('410721', '新乡县', '410700'), ('410724', '获嘉县', '410700'), ('410725', '原阳县', '410700'), ('410726', '延津县', '410700'), ('410727', '封丘县', '410700'), ('410728', '长垣县', '410700'), ('410781', '卫辉市', '410700'), ('410782', '辉县市', '410700'), ('410800', '焦作市', '410000'), ('410801', '市辖区', '410800'), ('410802', '解放区', '410800'), ('410803', '中站区', '410800'), ('410804', '马村区', '410800'), ('410811', '山阳区', '410800'), ('410821', '修武县', '410800'), ('410822', '博爱县', '410800'), ('410823', '武陟县', '410800'), ('410825', '温县', '410800'), ('410882', '沁阳市', '410800'), ('410883', '孟州市', '410800'), ('410900', '濮阳市', '410000'), ('410901', '市辖区', '410900'), ('410902', '华龙区', '410900'), ('410922', '清丰县', '410900'), ('410923', '南乐县', '410900'), ('410926', '范县', '410900'), ('410927', '台前县', '410900'), ('410928', '濮阳县', '410900'), ('411000', '许昌市', '410000'), ('411001', '市辖区', '411000'), ('411002', '魏都区', '411000'), ('411023', '许昌县', '411000'), ('411024', '鄢陵县', '411000'), ('411025', '襄城县', '411000'), ('411081', '禹州市', '411000'), ('411082', '长葛市', '411000'), ('411100', '漯河市', '410000'), ('411101', '市辖区', '411100'), ('411102', '源汇区', '411100'), ('411103', '郾城区', '411100'), ('411104', '召陵区', '411100'), ('411121', '舞阳县', '411100'), ('411122', '临颍县', '411100'), ('411200', '三门峡市', '410000'), ('411201', '市辖区', '411200'), ('411202', '湖滨区', '411200'), ('411221', '渑池县', '411200'), ('411222', '陕县', '411200'), ('411224', '卢氏县', '411200'), ('411281', '义马市', '411200'), ('411282', '灵宝市', '411200'), ('411300', '南阳市', '410000'), ('411301', '市辖区', '411300'), ('411302', '宛城区', '411300'), ('411303', '卧龙区', '411300'), ('411321', '南召县', '411300'), ('411322', '方城县', '411300'), ('411323', '西峡县', '411300'), ('411324', '镇平县', '411300'), ('411325', '内乡县', '411300'), ('411326', '淅川县', '411300'), ('411327', '社旗县', '411300'), ('411328', '唐河县', '411300'), ('411329', '新野县', '411300'), ('411330', '桐柏县', '411300'), ('411381', '邓州市', '411300'), ('411400', '商丘市', '410000'), ('411401', '市辖区', '411400'), ('411402', '梁园区', '411400'), ('411403', '睢阳区', '411400'), ('411421', '民权县', '411400'), ('411422', '睢县', '411400'), ('411423', '宁陵县', '411400'), ('411424', '柘城县', '411400'), ('411425', '虞城县', '411400'), ('411426', '夏邑县', '411400'), ('411481', '永城市', '411400'), ('411500', '信阳市', '410000'), ('411501', '市辖区', '411500'), ('411502', '浉河区', '411500'), ('411503', '平桥区', '411500'), ('411521', '罗山县', '411500'), ('411522', '光山县', '411500'), ('411523', '新县', '411500'), ('411524', '商城县', '411500'), ('411525', '固始县', '411500'), ('411526', '潢川县', '411500'), ('411527', '淮滨县', '411500'), ('411528', '息县', '411500'), ('411600', '周口市', '410000'), ('411601', '市辖区', '411600'), ('411602', '川汇区', '411600'), ('411621', '扶沟县', '411600'), ('411622', '西华县', '411600'), ('411623', '商水县', '411600'), ('411624', '沈丘县', '411600'), ('411625', '郸城县', '411600'), ('411626', '淮阳县', '411600'), ('411627', '太康县', '411600'), ('411628', '鹿邑县', '411600'), ('411681', '项城市', '411600'), ('411700', '驻马店市', '410000'), ('411701', '市辖区', '411700'), ('411702', '驿城区', '411700'), ('411721', '西平县', '411700'), ('411722', '上蔡县', '411700'), ('411723', '平舆县', '411700'), ('411724', '正阳县', '411700'), ('411725', '确山县', '411700'), ('411726', '泌阳县', '411700'), ('411727', '汝南县', '411700'), ('411728', '遂平县', '411700'), ('411729', '新蔡县', '411700'), ('419000', '济源市', '410000'), ('419001', '济源市', '410000'), ('420000', '湖北省', '0'), ('420100', '武汉市', '420000'), ('420101', '市辖区', '420100'), ('420102', '江岸区', '420100'), ('420103', '江汉区', '420100'), ('420104', '硚口区', '420100'), ('420105', '汉阳区', '420100'), ('420106', '武昌区', '420100'), ('420107', '青山区', '420100'), ('420111', '洪山区', '420100'), ('420112', '东西湖区', '420100'), ('420113', '汉南区', '420100'), ('420114', '蔡甸区', '420100'), ('420115', '江夏区', '420100'), ('420116', '黄陂区', '420100'), ('420117', '新洲区', '420100'), ('420200', '黄石市', '420000'), ('420201', '市辖区', '420200'), ('420202', '黄石港区', '420200'), ('420203', '西塞山区', '420200'), ('420204', '下陆区', '420200'), ('420205', '铁山区', '420200'), ('420222', '阳新县', '420200'), ('420281', '大冶市', '420200'), ('420300', '十堰市', '420000'), ('420301', '市辖区', '420300'), ('420302', '茅箭区', '420300'), ('420303', '张湾区', '420300'), ('420304', '郧阳区', '420300'), ('420322', '郧西县', '420300'), ('420323', '竹山县', '420300'), ('420324', '竹溪县', '420300'), ('420325', '房县', '420300'), ('420381', '丹江口市', '420300'), ('420500', '宜昌市', '420000'), ('420501', '市辖区', '420500'), ('420502', '西陵区', '420500'), ('420503', '伍家岗区', '420500'), ('420504', '点军区', '420500'), ('420505', '猇亭区', '420500'), ('420506', '夷陵区', '420500'), ('420525', '远安县', '420500'), ('420526', '兴山县', '420500'), ('420527', '秭归县', '420500'), ('420528', '长阳土家族自治县', '420500'), ('420529', '五峰土家族自治县', '420500'), ('420581', '宜都市', '420500'), ('420582', '当阳市', '420500'), ('420583', '枝江市', '420500'), ('420600', '襄阳市', '420000'), ('420601', '市辖区', '420600'), ('420602', '襄城区', '420600'), ('420606', '樊城区', '420600'), ('420607', '襄州区', '420600'), ('420624', '南漳县', '420600'), ('420625', '谷城县', '420600'), ('420626', '保康县', '420600'), ('420682', '老河口市', '420600'), ('420683', '枣阳市', '420600'), ('420684', '宜城市', '420600'), ('420700', '鄂州市', '420000'), ('420701', '市辖区', '420700'), ('420702', '梁子湖区', '420700'), ('420703', '华容区', '420700'), ('420704', '鄂城区', '420700'), ('420800', '荆门市', '420000'), ('420801', '市辖区', '420800'), ('420802', '东宝区', '420800'), ('420804', '掇刀区', '420800'), ('420821', '京山县', '420800'), ('420822', '沙洋县', '420800'), ('420881', '钟祥市', '420800'), ('420900', '孝感市', '420000'), ('420901', '市辖区', '420900'), ('420902', '孝南区', '420900'), ('420921', '孝昌县', '420900'), ('420922', '大悟县', '420900'), ('420923', '云梦县', '420900'), ('420981', '应城市', '420900'), ('420982', '安陆市', '420900'), ('420984', '汉川市', '420900'), ('421000', '荆州市', '420000'), ('421001', '市辖区', '421000'), ('421002', '沙市区', '421000'), ('421003', '荆州区', '421000'), ('421022', '公安县', '421000'), ('421023', '监利县', '421000'), ('421024', '江陵县', '421000'), ('421081', '石首市', '421000'), ('421083', '洪湖市', '421000'), ('421087', '松滋市', '421000'), ('421100', '黄冈市', '420000'), ('421101', '市辖区', '421100'), ('421102', '黄州区', '421100'), ('421121', '团风县', '421100'), ('421122', '红安县', '421100'), ('421123', '罗田县', '421100'), ('421124', '英山县', '421100'), ('421125', '浠水县', '421100'), ('421126', '蕲春县', '421100'), ('421127', '黄梅县', '421100'), ('421181', '麻城市', '421100'), ('421182', '武穴市', '421100'), ('421200', '咸宁市', '420000'), ('421201', '市辖区', '421200'), ('421202', '咸安区', '421200'), ('421221', '嘉鱼县', '421200'), ('421222', '通城县', '421200'), ('421223', '崇阳县', '421200'), ('421224', '通山县', '421200'), ('421281', '赤壁市', '421200'), ('421300', '随州市', '420000'), ('421301', '市辖区', '421300'), ('421303', '曾都区', '421300'), ('421321', '随县', '421300'), ('421381', '广水市', '421300'), ('422800', '恩施土家族苗族自治州', '420000'), ('422801', '恩施市', '422800'), ('422802', '利川市', '422800'), ('422822', '建始县', '422800'), ('422823', '巴东县', '422800'), ('422825', '宣恩县', '422800'), ('422826', '咸丰县', '422800'), ('422827', '来凤县', '422800'), ('422828', '鹤峰县', '422800'), ('429004', '仙桃市', '420000'), ('429005', '潜江市', '420000'), ('429006', '天门市', '420000'), ('429021', '神农架林区', '420000'), ('430000', '湖南省', '0'), ('430100', '长沙市', '430000'), ('430101', '市辖区', '430100'), ('430102', '芙蓉区', '430100'), ('430103', '天心区', '430100'), ('430104', '岳麓区', '430100'), ('430105', '开福区', '430100'), ('430111', '雨花区', '430100'), ('430112', '望城区', '430100'), ('430121', '长沙县', '430100'), ('430124', '宁乡县', '430100'), ('430181', '浏阳市', '430100'), ('430200', '株洲市', '430000'), ('430201', '市辖区', '430200'), ('430202', '荷塘区', '430200'), ('430203', '芦淞区', '430200'), ('430204', '石峰区', '430200'), ('430211', '天元区', '430200'), ('430221', '株洲县', '430200'), ('430223', '攸县', '430200'), ('430224', '茶陵县', '430200'), ('430225', '炎陵县', '430200'), ('430281', '醴陵市', '430200'), ('430300', '湘潭市', '430000'), ('430301', '市辖区', '430300'), ('430302', '雨湖区', '430300'), ('430304', '岳塘区', '430300'), ('430321', '湘潭县', '430300'), ('430381', '湘乡市', '430300'), ('430382', '韶山市', '430300'), ('430400', '衡阳市', '430000'), ('430401', '市辖区', '430400'), ('430405', '珠晖区', '430400'), ('430406', '雁峰区', '430400'), ('430407', '石鼓区', '430400'), ('430408', '蒸湘区', '430400'), ('430412', '南岳区', '430400'), ('430421', '衡阳县', '430400'), ('430422', '衡南县', '430400'), ('430423', '衡山县', '430400'), ('430424', '衡东县', '430400'), ('430426', '祁东县', '430400'), ('430481', '耒阳市', '430400'), ('430482', '常宁市', '430400'), ('430500', '邵阳市', '430000'), ('430501', '市辖区', '430500'), ('430502', '双清区', '430500'), ('430503', '大祥区', '430500'), ('430511', '北塔区', '430500'), ('430521', '邵东县', '430500'), ('430522', '新邵县', '430500'), ('430523', '邵阳县', '430500'), ('430524', '隆回县', '430500'), ('430525', '洞口县', '430500'), ('430527', '绥宁县', '430500'), ('430528', '新宁县', '430500'), ('430529', '城步苗族自治县', '430500'), ('430581', '武冈市', '430500'), ('430600', '岳阳市', '430000'), ('430601', '市辖区', '430600'), ('430602', '岳阳楼区', '430600'), ('430603', '云溪区', '430600'), ('430611', '君山区', '430600'), ('430621', '岳阳县', '430600'), ('430623', '华容县', '430600'), ('430624', '湘阴县', '430600'), ('430626', '平江县', '430600'), ('430681', '汨罗市', '430600'), ('430682', '临湘市', '430600'), ('430700', '常德市', '430000'), ('430701', '市辖区', '430700'), ('430702', '武陵区', '430700'), ('430703', '鼎城区', '430700'), ('430721', '安乡县', '430700'), ('430722', '汉寿县', '430700'), ('430723', '澧县', '430700'), ('430724', '临澧县', '430700'), ('430725', '桃源县', '430700'), ('430726', '石门县', '430700'), ('430781', '津市市', '430700'), ('430800', '张家界市', '430000'), ('430801', '市辖区', '430800'), ('430802', '永定区', '430800'), ('430811', '武陵源区', '430800'), ('430821', '慈利县', '430800'), ('430822', '桑植县', '430800'), ('430900', '益阳市', '430000'), ('430901', '市辖区', '430900'), ('430902', '资阳区', '430900'), ('430903', '赫山区', '430900'), ('430921', '南县', '430900'), ('430922', '桃江县', '430900'), ('430923', '安化县', '430900'), ('430981', '沅江市', '430900'), ('431000', '郴州市', '430000'), ('431001', '市辖区', '431000'), ('431002', '北湖区', '431000'), ('431003', '苏仙区', '431000'), ('431021', '桂阳县', '431000'), ('431022', '宜章县', '431000'), ('431023', '永兴县', '431000'), ('431024', '嘉禾县', '431000'), ('431025', '临武县', '431000'), ('431026', '汝城县', '431000'), ('431027', '桂东县', '431000'), ('431028', '安仁县', '431000'), ('431081', '资兴市', '431000'), ('431100', '永州市', '430000'), ('431101', '市辖区', '431100'), ('431102', '零陵区', '431100'), ('431103', '冷水滩区', '431100'), ('431121', '祁阳县', '431100'), ('431122', '东安县', '431100'), ('431123', '双牌县', '431100'), ('431124', '道县', '431100'), ('431125', '江永县', '431100'), ('431126', '宁远县', '431100'), ('431127', '蓝山县', '431100'), ('431128', '新田县', '431100'), ('431129', '江华瑶族自治县', '431100'), ('431200', '怀化市', '430000'), ('431201', '市辖区', '431200'), ('431202', '鹤城区', '431200'), ('431221', '中方县', '431200'), ('431222', '沅陵县', '431200'), ('431223', '辰溪县', '431200'), ('431224', '溆浦县', '431200'), ('431225', '会同县', '431200'), ('431226', '麻阳苗族自治县', '431200'), ('431227', '新晃侗族自治县', '431200'), ('431228', '芷江侗族自治县', '431200'), ('431229', '靖州苗族侗族自治县', '431200'), ('431230', '通道侗族自治县', '431200'), ('431281', '洪江市', '431200'), ('431300', '娄底市', '430000'), ('431301', '市辖区', '431300'), ('431302', '娄星区', '431300'), ('431321', '双峰县', '431300'), ('431322', '新化县', '431300'), ('431381', '冷水江市', '431300'), ('431382', '涟源市', '431300'), ('433100', '湘西土家族苗族自治州', '430000'), ('433101', '吉首市', '433100'), ('433122', '泸溪县', '433100'), ('433123', '凤凰县', '433100'), ('433124', '花垣县', '433100'), ('433125', '保靖县', '433100'), ('433126', '古丈县', '433100'), ('433127', '永顺县', '433100'), ('433130', '龙山县', '433100'), ('440000', '广东省', '0'), ('440100', '广州市', '440000'), ('440101', '市辖区', '440100'), ('440103', '荔湾区', '440100'), ('440104', '越秀区', '440100'), ('440105', '海珠区', '440100'), ('440106', '天河区', '440100'), ('440111', '白云区', '440100'), ('440112', '黄埔区', '440100'), ('440113', '番禺区', '440100'), ('440114', '花都区', '440100'), ('440115', '南沙区', '440100'), ('440117', '从化区', '440100'), ('440118', '增城区', '440100'), ('440200', '韶关市', '440000'), ('440201', '市辖区', '440200'), ('440203', '武江区', '440200'), ('440204', '浈江区', '440200'), ('440205', '曲江区', '440200'), ('440222', '始兴县', '440200'), ('440224', '仁化县', '440200'), ('440229', '翁源县', '440200'), ('440232', '乳源瑶族自治县', '440200'), ('440233', '新丰县', '440200'), ('440281', '乐昌市', '440200'), ('440282', '南雄市', '440200'), ('440300', '深圳市', '440000'), ('440301', '市辖区', '440300'), ('440303', '罗湖区', '440300'), ('440304', '福田区', '440300'), ('440305', '南山区', '440300'), ('440306', '宝安区', '440300'), ('440307', '龙岗区', '440300'), ('440308', '盐田区', '440300'), ('440400', '珠海市', '440000'), ('440401', '市辖区', '440400'), ('440402', '香洲区', '440400'), ('440403', '斗门区', '440400'), ('440404', '金湾区', '440400'), ('440500', '汕头市', '440000'), ('440501', '市辖区', '440500'), ('440507', '龙湖区', '440500'), ('440511', '金平区', '440500'), ('440512', '濠江区', '440500'), ('440513', '潮阳区', '440500'), ('440514', '潮南区', '440500'), ('440515', '澄海区', '440500'), ('440523', '南澳县', '440500'), ('440600', '佛山市', '440000'), ('440601', '市辖区', '440600'), ('440604', '禅城区', '440600'), ('440605', '南海区', '440600'), ('440606', '顺德区', '440600'), ('440607', '三水区', '440600'), ('440608', '高明区', '440600'), ('440700', '江门市', '440000'), ('440701', '市辖区', '440700'), ('440703', '蓬江区', '440700'), ('440704', '江海区', '440700'), ('440705', '新会区', '440700'), ('440781', '台山市', '440700'), ('440783', '开平市', '440700'), ('440784', '鹤山市', '440700'), ('440785', '恩平市', '440700'), ('440800', '湛江市', '440000'), ('440801', '市辖区', '440800'), ('440802', '赤坎区', '440800'), ('440803', '霞山区', '440800'), ('440804', '坡头区', '440800'), ('440811', '麻章区', '440800'), ('440823', '遂溪县', '440800'), ('440825', '徐闻县', '440800'), ('440881', '廉江市', '440800'), ('440882', '雷州市', '440800'), ('440883', '吴川市', '440800'), ('440900', '茂名市', '440000'), ('440901', '市辖区', '440900'), ('440902', '茂南区', '440900'), ('440904', '电白区', '440900'), ('440981', '高州市', '440900'), ('440982', '化州市', '440900'), ('440983', '信宜市', '440900'), ('441200', '肇庆市', '440000'), ('441201', '市辖区', '441200'), ('441202', '端州区', '441200'), ('441203', '鼎湖区', '441200'), ('441223', '广宁县', '441200'), ('441224', '怀集县', '441200'), ('441225', '封开县', '441200'), ('441226', '德庆县', '441200'), ('441283', '高要市', '441200'), ('441284', '四会市', '441200'), ('441300', '惠州市', '440000'), ('441301', '市辖区', '441300'), ('441302', '惠城区', '441300'), ('441303', '惠阳区', '441300'), ('441322', '博罗县', '441300'), ('441323', '惠东县', '441300'), ('441324', '龙门县', '441300'), ('441400', '梅州市', '440000'), ('441401', '市辖区', '441400'), ('441402', '梅江区', '441400'), ('441403', '梅县区', '441400'), ('441422', '大埔县', '441400'), ('441423', '丰顺县', '441400'), ('441424', '五华县', '441400'), ('441426', '平远县', '441400'), ('441427', '蕉岭县', '441400'), ('441481', '兴宁市', '441400'), ('441500', '汕尾市', '440000'), ('441501', '市辖区', '441500'), ('441502', '城区', '441500'), ('441521', '海丰县', '441500'), ('441523', '陆河县', '441500'), ('441581', '陆丰市', '441500'), ('441600', '河源市', '440000'), ('441601', '市辖区', '441600'), ('441602', '源城区', '441600'), ('441621', '紫金县', '441600');
INSERT INTO `ky_district` VALUES ('441622', '龙川县', '441600'), ('441623', '连平县', '441600'), ('441624', '和平县', '441600'), ('441625', '东源县', '441600'), ('441700', '阳江市', '440000'), ('441701', '市辖区', '441700'), ('441702', '江城区', '441700'), ('441704', '阳东区', '441700'), ('441721', '阳西县', '441700'), ('441781', '阳春市', '441700'), ('441800', '清远市', '440000'), ('441801', '市辖区', '441800'), ('441802', '清城区', '441800'), ('441803', '清新区', '441800'), ('441821', '佛冈县', '441800'), ('441823', '阳山县', '441800'), ('441825', '连山壮族瑶族自治县', '441800'), ('441826', '连南瑶族自治县', '441800'), ('441881', '英德市', '441800'), ('441882', '连州市', '441800'), ('441900', '东莞市', '440000'), ('442000', '中山市', '440000'), ('445100', '潮州市', '440000'), ('445101', '市辖区', '445100'), ('445102', '湘桥区', '445100'), ('445103', '潮安区', '445100'), ('445122', '饶平县', '445100'), ('445200', '揭阳市', '440000'), ('445201', '市辖区', '445200'), ('445202', '榕城区', '445200'), ('445203', '揭东区', '445200'), ('445222', '揭西县', '445200'), ('445224', '惠来县', '445200'), ('445281', '普宁市', '445200'), ('445300', '云浮市', '440000'), ('445301', '市辖区', '445300'), ('445302', '云城区', '445300'), ('445303', '云安区', '445300'), ('445321', '新兴县', '445300'), ('445322', '郁南县', '445300'), ('445381', '罗定市', '445300'), ('450000', '广西壮族自治区', '0'), ('450100', '南宁市', '450000'), ('450101', '市辖区', '450100'), ('450102', '兴宁区', '450100'), ('450103', '青秀区', '450100'), ('450105', '江南区', '450100'), ('450107', '西乡塘区', '450100'), ('450108', '良庆区', '450100'), ('450109', '邕宁区', '450100'), ('450122', '武鸣县', '450100'), ('450123', '隆安县', '450100'), ('450124', '马山县', '450100'), ('450125', '上林县', '450100'), ('450126', '宾阳县', '450100'), ('450127', '横县', '450100'), ('450200', '柳州市', '450000'), ('450201', '市辖区', '450200'), ('450202', '城中区', '450200'), ('450203', '鱼峰区', '450200'), ('450204', '柳南区', '450200'), ('450205', '柳北区', '450200'), ('450221', '柳江县', '450200'), ('450222', '柳城县', '450200'), ('450223', '鹿寨县', '450200'), ('450224', '融安县', '450200'), ('450225', '融水苗族自治县', '450200'), ('450226', '三江侗族自治县', '450200'), ('450300', '桂林市', '450000'), ('450301', '市辖区', '450300'), ('450302', '秀峰区', '450300'), ('450303', '叠彩区', '450300'), ('450304', '象山区', '450300'), ('450305', '七星区', '450300'), ('450311', '雁山区', '450300'), ('450312', '临桂区', '450300'), ('450321', '阳朔县', '450300'), ('450323', '灵川县', '450300'), ('450324', '全州县', '450300'), ('450325', '兴安县', '450300'), ('450326', '永福县', '450300'), ('450327', '灌阳县', '450300'), ('450328', '龙胜各族自治县', '450300'), ('450329', '资源县', '450300'), ('450330', '平乐县', '450300'), ('450331', '荔浦县', '450300'), ('450332', '恭城瑶族自治县', '450300'), ('450400', '梧州市', '450000'), ('450401', '市辖区', '450400'), ('450403', '万秀区', '450400'), ('450405', '长洲区', '450400'), ('450406', '龙圩区', '450400'), ('450421', '苍梧县', '450400'), ('450422', '藤县', '450400'), ('450423', '蒙山县', '450400'), ('450481', '岑溪市', '450400'), ('450500', '北海市', '450000'), ('450501', '市辖区', '450500'), ('450502', '海城区', '450500'), ('450503', '银海区', '450500'), ('450512', '铁山港区', '450500'), ('450521', '合浦县', '450500'), ('450600', '防城港市', '450000'), ('450601', '市辖区', '450600'), ('450602', '港口区', '450600'), ('450603', '防城区', '450600'), ('450621', '上思县', '450600'), ('450681', '东兴市', '450600'), ('450700', '钦州市', '450000'), ('450701', '市辖区', '450700'), ('450702', '钦南区', '450700'), ('450703', '钦北区', '450700'), ('450721', '灵山县', '450700'), ('450722', '浦北县', '450700'), ('450800', '贵港市', '450000'), ('450801', '市辖区', '450800'), ('450802', '港北区', '450800'), ('450803', '港南区', '450800'), ('450804', '覃塘区', '450800'), ('450821', '平南县', '450800'), ('450881', '桂平市', '450800'), ('450900', '玉林市', '450000'), ('450901', '市辖区', '450900'), ('450902', '玉州区', '450900'), ('450903', '福绵区', '450900'), ('450921', '容县', '450900'), ('450922', '陆川县', '450900'), ('450923', '博白县', '450900'), ('450924', '兴业县', '450900'), ('450981', '北流市', '450900'), ('451000', '百色市', '450000'), ('451001', '市辖区', '451000'), ('451002', '右江区', '451000'), ('451021', '田阳县', '451000'), ('451022', '田东县', '451000'), ('451023', '平果县', '451000'), ('451024', '德保县', '451000'), ('451025', '靖西县', '451000'), ('451026', '那坡县', '451000'), ('451027', '凌云县', '451000'), ('451028', '乐业县', '451000'), ('451029', '田林县', '451000'), ('451030', '西林县', '451000'), ('451031', '隆林各族自治县', '451000'), ('451100', '贺州市', '450000'), ('451101', '市辖区', '451100'), ('451102', '八步区', '451100'), ('451119', '平桂管理区', '451100'), ('451121', '昭平县', '451100'), ('451122', '钟山县', '451100'), ('451123', '富川瑶族自治县', '451100'), ('451200', '河池市', '450000'), ('451201', '市辖区', '451200'), ('451202', '金城江区', '451200'), ('451221', '南丹县', '451200'), ('451222', '天峨县', '451200'), ('451223', '凤山县', '451200'), ('451224', '东兰县', '451200'), ('451225', '罗城仫佬族自治县', '451200'), ('451226', '环江毛南族自治县', '451200'), ('451227', '巴马瑶族自治县', '451200'), ('451228', '都安瑶族自治县', '451200'), ('451229', '大化瑶族自治县', '451200'), ('451281', '宜州市', '451200'), ('451300', '来宾市', '450000'), ('451301', '市辖区', '451300'), ('451302', '兴宾区', '451300'), ('451321', '忻城县', '451300'), ('451322', '象州县', '451300'), ('451323', '武宣县', '451300'), ('451324', '金秀瑶族自治县', '451300'), ('451381', '合山市', '451300'), ('451400', '崇左市', '450000'), ('451401', '市辖区', '451400'), ('451402', '江州区', '451400'), ('451421', '扶绥县', '451400'), ('451422', '宁明县', '451400'), ('451423', '龙州县', '451400'), ('451424', '大新县', '451400'), ('451425', '天等县', '451400'), ('451481', '凭祥市', '451400'), ('460000', '海南省', '0'), ('460100', '海口市', '460000'), ('460101', '市辖区', '460100'), ('460105', '秀英区', '460100'), ('460106', '龙华区', '460100'), ('460107', '琼山区', '460100'), ('460108', '美兰区', '460100'), ('460200', '三亚市', '460000'), ('460201', '市辖区', '460200'), ('460202', '海棠区', '460200'), ('460203', '吉阳区', '460200'), ('460204', '天涯区', '460200'), ('460205', '崖州区', '460200'), ('460300', '三沙市', '460000'), ('460321', '西沙群岛', '460300'), ('460322', '南沙群岛', '460300'), ('460323', '中沙群岛的岛礁及其海域', '460300'), ('469001', '五指山市', '460000'), ('469002', '琼海市', '460000'), ('469003', '儋州市', '460000'), ('469005', '文昌市', '460000'), ('469006', '万宁市', '460000'), ('469007', '东方市', '460000'), ('469021', '定安县', '460000'), ('469022', '屯昌县', '460000'), ('469023', '澄迈县', '460000'), ('469024', '临高县', '460000'), ('469025', '白沙黎族自治县', '460000'), ('469026', '昌江黎族自治县', '460000'), ('469027', '乐东黎族自治县', '460000'), ('469028', '陵水黎族自治县', '460000'), ('469029', '保亭黎族苗族自治县', '460000'), ('469030', '琼中黎族苗族自治县', '460000'), ('500000', '重庆', '0'), ('500100', '重庆市', '500000'), ('500101', '万州区', '500100'), ('500102', '涪陵区', '500100'), ('500103', '渝中区', '500100'), ('500104', '大渡口区', '500100'), ('500105', '江北区', '500100'), ('500106', '沙坪坝区', '500100'), ('500107', '九龙坡区', '500100'), ('500108', '南岸区', '500100'), ('500109', '北碚区', '500100'), ('500110', '綦江区', '500100'), ('500111', '大足区', '500100'), ('500112', '渝北区', '500100'), ('500113', '巴南区', '500100'), ('500114', '黔江区', '500100'), ('500115', '长寿区', '500100'), ('500116', '江津区', '500100'), ('500117', '合川区', '500100'), ('500118', '永川区', '500100'), ('500119', '南川区', '500100'), ('500120', '璧山区', '500100'), ('500151', '铜梁区', '500100'), ('500223', '潼南县', '500100'), ('500226', '荣昌县', '500100'), ('500228', '梁平县', '500100'), ('500229', '城口县', '500100'), ('500230', '丰都县', '500100'), ('500231', '垫江县', '500100'), ('500232', '武隆县', '500100'), ('500233', '忠县', '500100'), ('500234', '开县', '500100'), ('500235', '云阳县', '500100'), ('500236', '奉节县', '500100'), ('500237', '巫山县', '500100'), ('500238', '巫溪县', '500100'), ('500240', '石柱土家族自治县', '500100'), ('500241', '秀山土家族苗族自治县', '500100'), ('500242', '酉阳土家族苗族自治县', '500100'), ('500243', '彭水苗族土家族自治县', '500100'), ('500300', '两江新区', '500100'), ('510000', '四川省', '0'), ('510100', '成都市', '510000'), ('510101', '市辖区', '510100'), ('510104', '锦江区', '510100'), ('510105', '青羊区', '510100'), ('510106', '金牛区', '510100'), ('510107', '武侯区', '510100'), ('510108', '成华区', '510100'), ('510112', '龙泉驿区', '510100'), ('510113', '青白江区', '510100'), ('510114', '新都区', '510100'), ('510115', '温江区', '510100'), ('510121', '金堂县', '510100'), ('510122', '双流县', '510100'), ('510124', '郫县', '510100'), ('510129', '大邑县', '510100'), ('510131', '蒲江县', '510100'), ('510132', '新津县', '510100'), ('510181', '都江堰市', '510100'), ('510182', '彭州市', '510100'), ('510183', '邛崃市', '510100'), ('510184', '崇州市', '510100'), ('510300', '自贡市', '510000'), ('510301', '市辖区', '510300'), ('510302', '自流井区', '510300'), ('510303', '贡井区', '510300'), ('510304', '大安区', '510300'), ('510311', '沿滩区', '510300'), ('510321', '荣县', '510300'), ('510322', '富顺县', '510300'), ('510400', '攀枝花市', '510000'), ('510401', '市辖区', '510400'), ('510402', '东区', '510400'), ('510403', '西区', '510400'), ('510411', '仁和区', '510400'), ('510421', '米易县', '510400'), ('510422', '盐边县', '510400'), ('510500', '泸州市', '510000'), ('510501', '市辖区', '510500'), ('510502', '江阳区', '510500'), ('510503', '纳溪区', '510500'), ('510504', '龙马潭区', '510500'), ('510521', '泸县', '510500'), ('510522', '合江县', '510500'), ('510524', '叙永县', '510500'), ('510525', '古蔺县', '510500'), ('510600', '德阳市', '510000'), ('510601', '市辖区', '510600'), ('510603', '旌阳区', '510600'), ('510623', '中江县', '510600'), ('510626', '罗江县', '510600'), ('510681', '广汉市', '510600'), ('510682', '什邡市', '510600'), ('510683', '绵竹市', '510600'), ('510700', '绵阳市', '510000'), ('510701', '市辖区', '510700'), ('510703', '涪城区', '510700'), ('510704', '游仙区', '510700'), ('510722', '三台县', '510700'), ('510723', '盐亭县', '510700'), ('510724', '安县', '510700'), ('510725', '梓潼县', '510700'), ('510726', '北川羌族自治县', '510700'), ('510727', '平武县', '510700'), ('510781', '江油市', '510700'), ('510800', '广元市', '510000'), ('510801', '市辖区', '510800'), ('510802', '利州区', '510800'), ('510811', '昭化区', '510800'), ('510812', '朝天区', '510800'), ('510821', '旺苍县', '510800'), ('510822', '青川县', '510800'), ('510823', '剑阁县', '510800'), ('510824', '苍溪县', '510800'), ('510900', '遂宁市', '510000'), ('510901', '市辖区', '510900'), ('510903', '船山区', '510900'), ('510904', '安居区', '510900'), ('510921', '蓬溪县', '510900'), ('510922', '射洪县', '510900'), ('510923', '大英县', '510900'), ('511000', '内江市', '510000'), ('511001', '市辖区', '511000'), ('511002', '市中区', '511000'), ('511011', '东兴区', '511000'), ('511024', '威远县', '511000'), ('511025', '资中县', '511000'), ('511028', '隆昌县', '511000'), ('511100', '乐山市', '510000'), ('511101', '市辖区', '511100'), ('511102', '市中区', '511100'), ('511111', '沙湾区', '511100'), ('511112', '五通桥区', '511100'), ('511113', '金口河区', '511100'), ('511123', '犍为县', '511100'), ('511124', '井研县', '511100'), ('511126', '夹江县', '511100'), ('511129', '沐川县', '511100'), ('511132', '峨边彝族自治县', '511100'), ('511133', '马边彝族自治县', '511100'), ('511181', '峨眉山市', '511100'), ('511300', '南充市', '510000'), ('511301', '市辖区', '511300'), ('511302', '顺庆区', '511300'), ('511303', '高坪区', '511300'), ('511304', '嘉陵区', '511300'), ('511321', '南部县', '511300'), ('511322', '营山县', '511300'), ('511323', '蓬安县', '511300'), ('511324', '仪陇县', '511300'), ('511325', '西充县', '511300'), ('511381', '阆中市', '511300'), ('511400', '眉山市', '510000'), ('511401', '市辖区', '511400'), ('511402', '东坡区', '511400'), ('511403', '彭山区', '511400'), ('511421', '仁寿县', '511400'), ('511423', '洪雅县', '511400'), ('511424', '丹棱县', '511400'), ('511425', '青神县', '511400'), ('511500', '宜宾市', '510000'), ('511501', '市辖区', '511500'), ('511502', '翠屏区', '511500'), ('511503', '南溪区', '511500'), ('511521', '宜宾县', '511500'), ('511523', '江安县', '511500'), ('511524', '长宁县', '511500'), ('511525', '高县', '511500'), ('511526', '珙县', '511500'), ('511527', '筠连县', '511500'), ('511528', '兴文县', '511500'), ('511529', '屏山县', '511500'), ('511600', '广安市', '510000'), ('511601', '市辖区', '511600'), ('511602', '广安区', '511600'), ('511603', '前锋区', '511600'), ('511621', '岳池县', '511600'), ('511622', '武胜县', '511600'), ('511623', '邻水县', '511600'), ('511681', '华蓥市', '511600'), ('511700', '达州市', '510000'), ('511701', '市辖区', '511700'), ('511702', '通川区', '511700'), ('511703', '达川区', '511700'), ('511722', '宣汉县', '511700'), ('511723', '开江县', '511700'), ('511724', '大竹县', '511700'), ('511725', '渠县', '511700'), ('511781', '万源市', '511700'), ('511800', '雅安市', '510000'), ('511801', '市辖区', '511800'), ('511802', '雨城区', '511800'), ('511803', '名山区', '511800'), ('511822', '荥经县', '511800'), ('511823', '汉源县', '511800'), ('511824', '石棉县', '511800'), ('511825', '天全县', '511800'), ('511826', '芦山县', '511800'), ('511827', '宝兴县', '511800'), ('511900', '巴中市', '510000'), ('511901', '市辖区', '511900'), ('511902', '巴州区', '511900'), ('511903', '恩阳区', '511900'), ('511921', '通江县', '511900'), ('511922', '南江县', '511900'), ('511923', '平昌县', '511900'), ('512000', '资阳市', '510000'), ('512001', '市辖区', '512000'), ('512002', '雁江区', '512000'), ('512021', '安岳县', '512000'), ('512022', '乐至县', '512000'), ('512081', '简阳市', '512000'), ('513200', '阿坝藏族羌族自治州', '510000'), ('513221', '汶川县', '513200'), ('513222', '理县', '513200'), ('513223', '茂县', '513200'), ('513224', '松潘县', '513200'), ('513225', '九寨沟县', '513200'), ('513226', '金川县', '513200'), ('513227', '小金县', '513200'), ('513228', '黑水县', '513200'), ('513229', '马尔康县', '513200'), ('513230', '壤塘县', '513200'), ('513231', '阿坝县', '513200'), ('513232', '若尔盖县', '513200'), ('513233', '红原县', '513200'), ('513300', '甘孜藏族自治州', '510000'), ('513321', '康定县', '513300'), ('513322', '泸定县', '513300'), ('513323', '丹巴县', '513300'), ('513324', '九龙县', '513300'), ('513325', '雅江县', '513300'), ('513326', '道孚县', '513300'), ('513327', '炉霍县', '513300'), ('513328', '甘孜县', '513300'), ('513329', '新龙县', '513300'), ('513330', '德格县', '513300'), ('513331', '白玉县', '513300'), ('513332', '石渠县', '513300'), ('513333', '色达县', '513300'), ('513334', '理塘县', '513300'), ('513335', '巴塘县', '513300'), ('513336', '乡城县', '513300'), ('513337', '稻城县', '513300'), ('513338', '得荣县', '513300'), ('513400', '凉山彝族自治州', '510000'), ('513401', '西昌市', '513400'), ('513422', '木里藏族自治县', '513400'), ('513423', '盐源县', '513400'), ('513424', '德昌县', '513400'), ('513425', '会理县', '513400'), ('513426', '会东县', '513400'), ('513427', '宁南县', '513400'), ('513428', '普格县', '513400'), ('513429', '布拖县', '513400'), ('513430', '金阳县', '513400'), ('513431', '昭觉县', '513400'), ('513432', '喜德县', '513400'), ('513433', '冕宁县', '513400'), ('513434', '越西县', '513400'), ('513435', '甘洛县', '513400'), ('513436', '美姑县', '513400'), ('513437', '雷波县', '513400'), ('520000', '贵州省', '0'), ('520100', '贵阳市', '520000'), ('520101', '市辖区', '520100'), ('520102', '南明区', '520100'), ('520103', '云岩区', '520100'), ('520111', '花溪区', '520100'), ('520112', '乌当区', '520100'), ('520113', '白云区', '520100'), ('520115', '观山湖区', '520100'), ('520121', '开阳县', '520100'), ('520122', '息烽县', '520100'), ('520123', '修文县', '520100'), ('520181', '清镇市', '520100'), ('520200', '六盘水市', '520000'), ('520201', '钟山区', '520200'), ('520203', '六枝特区', '520200'), ('520221', '水城县', '520200'), ('520222', '盘县', '520200'), ('520300', '遵义市', '520000'), ('520301', '市辖区', '520300'), ('520302', '红花岗区', '520300'), ('520303', '汇川区', '520300'), ('520321', '播州区', '520300'), ('520322', '桐梓县', '520300'), ('520323', '绥阳县', '520300'), ('520324', '正安县', '520300'), ('520325', '道真仡佬族苗族自治县', '520300'), ('520326', '务川仡佬族苗族自治县', '520300'), ('520327', '凤冈县', '520300'), ('520328', '湄潭县', '520300'), ('520329', '余庆县', '520300'), ('520330', '习水县', '520300'), ('520381', '赤水市', '520300'), ('520382', '仁怀市', '520300'), ('520400', '安顺市', '520000'), ('520401', '市辖区', '520400'), ('520402', '西秀区', '520400'), ('520403', '平坝区', '520400'), ('520422', '普定县', '520400'), ('520423', '镇宁布依族苗族自治县', '520400'), ('520424', '关岭布依族苗族自治县', '520400'), ('520425', '紫云苗族布依族自治县', '520400'), ('520500', '毕节市', '520000'), ('520501', '市辖区', '520500'), ('520502', '七星关区', '520500'), ('520521', '大方县', '520500'), ('520522', '黔西县', '520500'), ('520523', '金沙县', '520500'), ('520524', '织金县', '520500'), ('520525', '纳雍县', '520500'), ('520526', '威宁彝族回族苗族自治县', '520500'), ('520527', '赫章县', '520500'), ('520600', '铜仁市', '520000'), ('520601', '市辖区', '520600'), ('520602', '碧江区', '520600'), ('520603', '万山区', '520600'), ('520621', '江口县', '520600'), ('520622', '玉屏侗族自治县', '520600'), ('520623', '石阡县', '520600'), ('520624', '思南县', '520600'), ('520625', '印江土家族苗族自治县', '520600'), ('520626', '德江县', '520600'), ('520627', '沿河土家族自治县', '520600'), ('520628', '松桃苗族自治县', '520600'), ('522300', '黔西南布依族苗族自治州', '520000'), ('522301', '兴义市', '522300'), ('522322', '兴仁县', '522300'), ('522323', '普安县', '522300'), ('522324', '晴隆县', '522300'), ('522325', '贞丰县', '522300'), ('522326', '望谟县', '522300'), ('522327', '册亨县', '522300'), ('522328', '安龙县', '522300'), ('522600', '黔东南苗族侗族自治州', '520000'), ('522601', '凯里市', '522600'), ('522622', '黄平县', '522600'), ('522623', '施秉县', '522600'), ('522624', '三穗县', '522600'), ('522625', '镇远县', '522600'), ('522626', '岑巩县', '522600'), ('522627', '天柱县', '522600'), ('522628', '锦屏县', '522600'), ('522629', '剑河县', '522600'), ('522630', '台江县', '522600'), ('522631', '黎平县', '522600'), ('522632', '榕江县', '522600'), ('522633', '从江县', '522600'), ('522634', '雷山县', '522600'), ('522635', '麻江县', '522600'), ('522636', '丹寨县', '522600'), ('522700', '黔南布依族苗族自治州', '520000'), ('522701', '都匀市', '522700'), ('522702', '福泉市', '522700'), ('522722', '荔波县', '522700'), ('522723', '贵定县', '522700'), ('522725', '瓮安县', '522700'), ('522726', '独山县', '522700'), ('522727', '平塘县', '522700'), ('522728', '罗甸县', '522700'), ('522729', '长顺县', '522700'), ('522730', '龙里县', '522700'), ('522731', '惠水县', '522700'), ('522732', '三都水族自治县', '522700'), ('530000', '云南省', '0'), ('530100', '昆明市', '530000'), ('530101', '市辖区', '530100'), ('530102', '五华区', '530100'), ('530103', '盘龙区', '530100'), ('530111', '官渡区', '530100'), ('530112', '西山区', '530100'), ('530113', '东川区', '530100'), ('530114', '呈贡区', '530100'), ('530122', '晋宁县', '530100'), ('530124', '富民县', '530100'), ('530125', '宜良县', '530100'), ('530126', '石林彝族自治县', '530100'), ('530127', '嵩明县', '530100'), ('530128', '禄劝彝族苗族自治县', '530100'), ('530129', '寻甸回族彝族自治县', '530100'), ('530181', '安宁市', '530100'), ('530300', '曲靖市', '530000'), ('530301', '市辖区', '530300'), ('530302', '麒麟区', '530300'), ('530321', '马龙县', '530300'), ('530322', '陆良县', '530300'), ('530323', '师宗县', '530300'), ('530324', '罗平县', '530300'), ('530325', '富源县', '530300'), ('530326', '会泽县', '530300'), ('530328', '沾益县', '530300'), ('530381', '宣威市', '530300'), ('530400', '玉溪市', '530000'), ('530401', '市辖区', '530400'), ('530402', '红塔区', '530400'), ('530421', '江川县', '530400'), ('530422', '澄江县', '530400'), ('530423', '通海县', '530400'), ('530424', '华宁县', '530400'), ('530425', '易门县', '530400'), ('530426', '峨山彝族自治县', '530400'), ('530427', '新平彝族傣族自治县', '530400'), ('530428', '元江哈尼族彝族傣族自治县', '530400'), ('530500', '保山市', '530000'), ('530501', '市辖区', '530500'), ('530502', '隆阳区', '530500'), ('530521', '施甸县', '530500'), ('530522', '腾冲县', '530500'), ('530523', '龙陵县', '530500'), ('530524', '昌宁县', '530500'), ('530600', '昭通市', '530000'), ('530601', '市辖区', '530600'), ('530602', '昭阳区', '530600'), ('530621', '鲁甸县', '530600'), ('530622', '巧家县', '530600'), ('530623', '盐津县', '530600'), ('530624', '大关县', '530600'), ('530625', '永善县', '530600'), ('530626', '绥江县', '530600'), ('530627', '镇雄县', '530600'), ('530628', '彝良县', '530600'), ('530629', '威信县', '530600'), ('530630', '水富县', '530600'), ('530700', '丽江市', '530000'), ('530701', '市辖区', '530700'), ('530702', '古城区', '530700'), ('530721', '玉龙纳西族自治县', '530700'), ('530722', '永胜县', '530700'), ('530723', '华坪县', '530700'), ('530724', '宁蒗彝族自治县', '530700'), ('530800', '普洱市', '530000'), ('530801', '市辖区', '530800'), ('530802', '思茅区', '530800'), ('530821', '宁洱哈尼族彝族自治县', '530800'), ('530822', '墨江哈尼族自治县', '530800'), ('530823', '景东彝族自治县', '530800'), ('530824', '景谷傣族彝族自治县', '530800'), ('530825', '镇沅彝族哈尼族拉祜族自治县', '530800'), ('530826', '江城哈尼族彝族自治县', '530800'), ('530827', '孟连傣族拉祜族佤族自治县', '530800'), ('530828', '澜沧拉祜族自治县', '530800'), ('530829', '西盟佤族自治县', '530800'), ('530900', '临沧市', '530000'), ('530901', '市辖区', '530900'), ('530902', '临翔区', '530900'), ('530921', '凤庆县', '530900'), ('530922', '云县', '530900'), ('530923', '永德县', '530900'), ('530924', '镇康县', '530900'), ('530925', '双江拉祜族佤族布朗族傣族自治县', '530900'), ('530926', '耿马傣族佤族自治县', '530900'), ('530927', '沧源佤族自治县', '530900'), ('532300', '楚雄彝族自治州', '530000'), ('532301', '楚雄市', '532300'), ('532322', '双柏县', '532300'), ('532323', '牟定县', '532300'), ('532324', '南华县', '532300'), ('532325', '姚安县', '532300'), ('532326', '大姚县', '532300'), ('532327', '永仁县', '532300'), ('532328', '元谋县', '532300'), ('532329', '武定县', '532300'), ('532331', '禄丰县', '532300'), ('532500', '红河哈尼族彝族自治州', '530000'), ('532501', '个旧市', '532500'), ('532502', '开远市', '532500'), ('532503', '蒙自市', '532500'), ('532504', '弥勒市', '532500'), ('532523', '屏边苗族自治县', '532500'), ('532524', '建水县', '532500'), ('532525', '石屏县', '532500'), ('532527', '泸西县', '532500'), ('532528', '元阳县', '532500'), ('532529', '红河县', '532500'), ('532530', '金平苗族瑶族傣族自治县', '532500'), ('532531', '绿春县', '532500'), ('532532', '河口瑶族自治县', '532500'), ('532600', '文山壮族苗族自治州', '530000'), ('532601', '文山市', '532600'), ('532622', '砚山县', '532600'), ('532623', '西畴县', '532600'), ('532624', '麻栗坡县', '532600'), ('532625', '马关县', '532600'), ('532626', '丘北县', '532600'), ('532627', '广南县', '532600'), ('532628', '富宁县', '532600'), ('532800', '西双版纳傣族自治州', '530000'), ('532801', '景洪市', '532800'), ('532822', '勐海县', '532800'), ('532823', '勐腊县', '532800'), ('532900', '大理白族自治州', '530000'), ('532901', '大理市', '532900'), ('532922', '漾濞彝族自治县', '532900'), ('532923', '祥云县', '532900'), ('532924', '宾川县', '532900'), ('532925', '弥渡县', '532900'), ('532926', '南涧彝族自治县', '532900'), ('532927', '巍山彝族回族自治县', '532900'), ('532928', '永平县', '532900'), ('532929', '云龙县', '532900'), ('532930', '洱源县', '532900'), ('532931', '剑川县', '532900'), ('532932', '鹤庆县', '532900'), ('533100', '德宏傣族景颇族自治州', '530000'), ('533102', '瑞丽市', '533100'), ('533103', '芒市', '533100'), ('533122', '梁河县', '533100'), ('533123', '盈江县', '533100'), ('533124', '陇川县', '533100'), ('533300', '怒江傈僳族自治州', '530000'), ('533321', '泸水县', '533300'), ('533323', '福贡县', '533300'), ('533324', '贡山独龙族怒族自治县', '533300'), ('533325', '兰坪白族普米族自治县', '533300'), ('533400', '迪庆藏族自治州', '530000'), ('533401', '香格里拉市', '533400'), ('533422', '德钦县', '533400'), ('533423', '维西傈僳族自治县', '533400'), ('540000', '西藏自治区', '0'), ('540100', '拉萨市', '540000'), ('540101', '市辖区', '540100'), ('540102', '城关区', '540100'), ('540121', '林周县', '540100'), ('540122', '当雄县', '540100'), ('540123', '尼木县', '540100'), ('540124', '曲水县', '540100'), ('540125', '堆龙德庆县', '540100'), ('540126', '达孜县', '540100'), ('540127', '墨竹工卡县', '540100'), ('540200', '日喀则市', '540000'), ('540201', '市辖区', '540200'), ('540202', '桑珠孜区', '540200'), ('540221', '南木林县', '540200'), ('540222', '江孜县', '540200'), ('540223', '定日县', '540200'), ('540224', '萨迦县', '540200'), ('540225', '拉孜县', '540200'), ('540226', '昂仁县', '540200'), ('540227', '谢通门县', '540200'), ('540228', '白朗县', '540200'), ('540229', '仁布县', '540200'), ('540230', '康马县', '540200'), ('540231', '定结县', '540200'), ('540232', '仲巴县', '540200'), ('540233', '亚东县', '540200'), ('540234', '吉隆县', '540200'), ('540235', '聂拉木县', '540200'), ('540236', '萨嘎县', '540200'), ('540237', '岗巴县', '540200'), ('540300', '昌都市', '540000'), ('540301', '市辖区', '540300'), ('540302', '卡若区', '540300'), ('540321', '江达县', '540300'), ('540322', '贡觉县', '540300'), ('540323', '类乌齐县', '540300'), ('540324', '丁青县', '540300'), ('540325', '察雅县', '540300'), ('540326', '八宿县', '540300'), ('540327', '左贡县', '540300'), ('540328', '芒康县', '540300'), ('540329', '洛隆县', '540300'), ('540330', '边坝县', '540300'), ('542200', '山南地区', '540000'), ('542221', '乃东县', '542200'), ('542222', '扎囊县', '542200'), ('542223', '贡嘎县', '542200'), ('542224', '桑日县', '542200'), ('542225', '琼结县', '542200'), ('542226', '曲松县', '542200'), ('542227', '措美县', '542200'), ('542228', '洛扎县', '542200'), ('542229', '加查县', '542200'), ('542231', '隆子县', '542200'), ('542232', '错那县', '542200'), ('542233', '浪卡子县', '542200'), ('542400', '那曲地区', '540000'), ('542421', '那曲县', '542400'), ('542422', '嘉黎县', '542400'), ('542423', '比如县', '542400'), ('542424', '聂荣县', '542400'), ('542425', '安多县', '542400'), ('542426', '申扎县', '542400'), ('542427', '索县', '542400'), ('542428', '班戈县', '542400'), ('542429', '巴青县', '542400'), ('542430', '尼玛县', '542400'), ('542431', '双湖县', '542400'), ('542500', '阿里地区', '540000'), ('542521', '普兰县', '542500'), ('542522', '札达县', '542500'), ('542523', '噶尔县', '542500'), ('542524', '日土县', '542500'), ('542525', '革吉县', '542500'), ('542526', '改则县', '542500'), ('542527', '措勤县', '542500'), ('542600', '林芝地区', '540000'), ('542621', '林芝县', '542600'), ('542622', '工布江达县', '542600'), ('542623', '米林县', '542600'), ('542624', '墨脱县', '542600'), ('542625', '波密县', '542600'), ('542626', '察隅县', '542600'), ('542627', '朗县', '542600'), ('610000', '陕西省', '0'), ('610100', '西安市', '610000'), ('610101', '市辖区', '610100'), ('610102', '新城区', '610100'), ('610103', '碑林区', '610100'), ('610104', '莲湖区', '610100'), ('610111', '灞桥区', '610100'), ('610112', '未央区', '610100'), ('610113', '雁塔区', '610100'), ('610114', '阎良区', '610100'), ('610115', '临潼区', '610100'), ('610116', '长安区', '610100'), ('610117', '高陵区', '610100'), ('610122', '蓝田县', '610100'), ('610124', '周至县', '610100'), ('610125', '户县', '610100'), ('610200', '铜川市', '610000'), ('610201', '市辖区', '610200'), ('610202', '王益区', '610200'), ('610203', '印台区', '610200'), ('610204', '耀州区', '610200'), ('610222', '宜君县', '610200'), ('610300', '宝鸡市', '610000'), ('610301', '市辖区', '610300'), ('610302', '渭滨区', '610300'), ('610303', '金台区', '610300'), ('610304', '陈仓区', '610300'), ('610322', '凤翔县', '610300'), ('610323', '岐山县', '610300'), ('610324', '扶风县', '610300'), ('610326', '眉县', '610300'), ('610327', '陇县', '610300'), ('610328', '千阳县', '610300'), ('610329', '麟游县', '610300'), ('610330', '凤县', '610300'), ('610331', '太白县', '610300'), ('610400', '咸阳市', '610000'), ('610401', '市辖区', '610400'), ('610402', '秦都区', '610400'), ('610403', '杨陵区', '610400'), ('610404', '渭城区', '610400'), ('610422', '三原县', '610400'), ('610423', '泾阳县', '610400'), ('610424', '乾县', '610400'), ('610425', '礼泉县', '610400'), ('610426', '永寿县', '610400'), ('610427', '彬县', '610400'), ('610428', '长武县', '610400'), ('610429', '旬邑县', '610400'), ('610430', '淳化县', '610400'), ('610431', '武功县', '610400'), ('610481', '兴平市', '610400'), ('610500', '渭南市', '610000'), ('610501', '市辖区', '610500'), ('610502', '临渭区', '610500'), ('610521', '华县', '610500'), ('610522', '潼关县', '610500'), ('610523', '大荔县', '610500'), ('610524', '合阳县', '610500'), ('610525', '澄城县', '610500'), ('610526', '蒲城县', '610500'), ('610527', '白水县', '610500'), ('610528', '富平县', '610500'), ('610581', '韩城市', '610500'), ('610582', '华阴市', '610500'), ('610600', '延安市', '610000'), ('610601', '市辖区', '610600'), ('610602', '宝塔区', '610600'), ('610621', '延长县', '610600'), ('610622', '延川县', '610600'), ('610623', '子长县', '610600'), ('610624', '安塞县', '610600'), ('610625', '志丹县', '610600'), ('610626', '吴起县', '610600'), ('610627', '甘泉县', '610600'), ('610628', '富县', '610600'), ('610629', '洛川县', '610600'), ('610630', '宜川县', '610600'), ('610631', '黄龙县', '610600'), ('610632', '黄陵县', '610600'), ('610700', '汉中市', '610000'), ('610701', '市辖区', '610700'), ('610702', '汉台区', '610700'), ('610721', '南郑县', '610700'), ('610722', '城固县', '610700'), ('610723', '洋县', '610700'), ('610724', '西乡县', '610700'), ('610725', '勉县', '610700'), ('610726', '宁强县', '610700'), ('610727', '略阳县', '610700'), ('610728', '镇巴县', '610700'), ('610729', '留坝县', '610700'), ('610730', '佛坪县', '610700'), ('610800', '榆林市', '610000'), ('610801', '市辖区', '610800'), ('610802', '榆阳区', '610800'), ('610803', '高新区', '610800'), ('610821', '神木县', '610800'), ('610822', '府谷县', '610800'), ('610823', '横山县', '610800'), ('610824', '靖边县', '610800'), ('610825', '定边县', '610800'), ('610826', '绥德县', '610800'), ('610827', '米脂县', '610800'), ('610828', '佳县', '610800'), ('610829', '吴堡县', '610800'), ('610830', '清涧县', '610800'), ('610831', '子洲县', '610800'), ('610900', '安康市', '610000'), ('610901', '市辖区', '610900'), ('610921', '汉阴县', '610900'), ('610922', '石泉县', '610900'), ('610923', '宁陕县', '610900'), ('610924', '紫阳县', '610900'), ('610925', '岚皋县', '610900'), ('610926', '平利县', '610900'), ('610927', '镇坪县', '610900'), ('610928', '旬阳县', '610900'), ('610929', '白河县', '610900'), ('611000', '商洛市', '610000'), ('611001', '市辖区', '611000'), ('611002', '商州区', '611000'), ('611021', '洛南县', '611000'), ('611022', '丹凤县', '611000'), ('611023', '商南县', '611000'), ('611024', '山阳县', '611000'), ('611025', '镇安县', '611000'), ('611026', '柞水县', '611000'), ('620000', '甘肃省', '0'), ('620100', '兰州市', '620000'), ('620101', '市辖区', '620100'), ('620102', '城关区', '620100'), ('620103', '七里河区', '620100'), ('620104', '西固区', '620100'), ('620105', '安宁区', '620100'), ('620111', '红古区', '620100'), ('620121', '永登县', '620100'), ('620122', '皋兰县', '620100'), ('620123', '榆中县', '620100'), ('620200', '嘉峪关市', '620000'), ('620201', '市辖区', '620200'), ('620300', '金昌市', '620000'), ('620301', '市辖区', '620300'), ('620302', '金川区', '620300'), ('620321', '永昌县', '620300'), ('620400', '白银市', '620000'), ('620401', '市辖区', '620400'), ('620402', '白银区', '620400'), ('620403', '平川区', '620400'), ('620421', '靖远县', '620400'), ('620422', '会宁县', '620400'), ('620423', '景泰县', '620400'), ('620500', '天水市', '620000'), ('620501', '市辖区', '620500'), ('620502', '秦州区', '620500'), ('620503', '麦积区', '620500'), ('620521', '清水县', '620500'), ('620522', '秦安县', '620500'), ('620523', '甘谷县', '620500'), ('620524', '武山县', '620500'), ('620525', '张家川回族自治县', '620500'), ('620600', '武威市', '620000'), ('620601', '市辖区', '620600'), ('620602', '凉州区', '620600'), ('620621', '民勤县', '620600'), ('620622', '古浪县', '620600'), ('620623', '天祝藏族自治县', '620600'), ('620700', '张掖市', '620000'), ('620701', '市辖区', '620700'), ('620702', '甘州区', '620700'), ('620721', '肃南裕固族自治县', '620700'), ('620722', '民乐县', '620700'), ('620723', '临泽县', '620700'), ('620724', '高台县', '620700'), ('620725', '山丹县', '620700'), ('620800', '平凉市', '620000'), ('620801', '市辖区', '620800'), ('620802', '崆峒区', '620800'), ('620821', '泾川县', '620800'), ('620822', '灵台县', '620800'), ('620823', '崇信县', '620800'), ('620824', '华亭县', '620800'), ('620825', '庄浪县', '620800'), ('620826', '静宁县', '620800'), ('620900', '酒泉市', '620000'), ('620901', '市辖区', '620900'), ('620902', '肃州区', '620900'), ('620921', '金塔县', '620900'), ('620922', '瓜州县', '620900'), ('620923', '肃北蒙古族自治县', '620900'), ('620924', '阿克塞哈萨克族自治县', '620900'), ('620981', '玉门市', '620900'), ('620982', '敦煌市', '620900'), ('621000', '庆阳市', '620000'), ('621001', '市辖区', '621000'), ('621002', '西峰区', '621000'), ('621021', '庆城县', '621000'), ('621022', '环县', '621000'), ('621023', '华池县', '621000'), ('621024', '合水县', '621000'), ('621025', '正宁县', '621000'), ('621026', '宁县', '621000'), ('621027', '镇原县', '621000'), ('621100', '定西市', '620000'), ('621101', '市辖区', '621100'), ('621102', '安定区', '621100'), ('621121', '通渭县', '621100'), ('621122', '陇西县', '621100'), ('621123', '渭源县', '621100'), ('621124', '临洮县', '621100'), ('621125', '漳县', '621100'), ('621126', '岷县', '621100'), ('621200', '陇南市', '620000'), ('621201', '市辖区', '621200'), ('621202', '武都区', '621200'), ('621221', '成县', '621200'), ('621222', '文县', '621200'), ('621223', '宕昌县', '621200'), ('621224', '康县', '621200'), ('621225', '西和县', '621200'), ('621226', '礼县', '621200'), ('621227', '徽县', '621200'), ('621228', '两当县', '621200'), ('622900', '临夏回族自治州', '620000'), ('622901', '临夏市', '622900'), ('622921', '临夏县', '622900'), ('622922', '康乐县', '622900'), ('622923', '永靖县', '622900'), ('622924', '广河县', '622900'), ('622925', '和政县', '622900'), ('622926', '东乡族自治县', '622900'), ('622927', '积石山保安族东乡族撒拉族自治县', '622900'), ('623000', '甘南藏族自治州', '620000'), ('623001', '合作市', '623000'), ('623021', '临潭县', '623000'), ('623022', '卓尼县', '623000'), ('623023', '舟曲县', '623000'), ('623024', '迭部县', '623000'), ('623025', '玛曲县', '623000'), ('623026', '碌曲县', '623000'), ('623027', '夏河县', '623000'), ('630000', '青海省', '0'), ('630100', '西宁市', '630000'), ('630101', '市辖区', '630100'), ('630102', '城东区', '630100'), ('630103', '城中区', '630100'), ('630104', '城西区', '630100'), ('630105', '城北区', '630100'), ('630121', '大通回族土族自治县', '630100'), ('630122', '湟中县', '630100'), ('630123', '湟源县', '630100'), ('630200', '海东市', '630000'), ('630201', '市辖区', '630200'), ('630202', '乐都区', '630200'), ('630221', '平安县', '630200'), ('630222', '民和回族土族自治县', '630200'), ('630223', '互助土族自治县', '630200'), ('630224', '化隆回族自治县', '630200'), ('630225', '循化撒拉族自治县', '630200'), ('632200', '海北藏族自治州', '630000'), ('632221', '门源回族自治县', '632200'), ('632222', '祁连县', '632200'), ('632223', '海晏县', '632200'), ('632224', '刚察县', '632200'), ('632300', '黄南藏族自治州', '630000'), ('632321', '同仁县', '632300'), ('632322', '尖扎县', '632300'), ('632323', '泽库县', '632300'), ('632324', '河南蒙古族自治县', '632300'), ('632500', '海南藏族自治州', '630000'), ('632521', '共和县', '632500'), ('632522', '同德县', '632500'), ('632523', '贵德县', '632500'), ('632524', '兴海县', '632500'), ('632525', '贵南县', '632500'), ('632600', '果洛藏族自治州', '630000'), ('632621', '玛沁县', '632600'), ('632622', '班玛县', '632600'), ('632623', '甘德县', '632600'), ('632624', '达日县', '632600'), ('632625', '久治县', '632600'), ('632626', '玛多县', '632600'), ('632700', '玉树藏族自治州', '630000'), ('632701', '玉树市', '632700'), ('632722', '杂多县', '632700'), ('632723', '称多县', '632700'), ('632724', '治多县', '632700'), ('632725', '囊谦县', '632700'), ('632726', '曲麻莱县', '632700'), ('632800', '海西蒙古族藏族自治州', '630000'), ('632801', '格尔木市', '632800'), ('632802', '德令哈市', '632800'), ('632821', '乌兰县', '632800'), ('632822', '都兰县', '632800'), ('632823', '天峻县', '632800'), ('640000', '宁夏回族自治区', '0'), ('640100', '银川市', '640000'), ('640101', '市辖区', '640100'), ('640104', '兴庆区', '640100'), ('640105', '西夏区', '640100'), ('640106', '金凤区', '640100'), ('640121', '永宁县', '640100'), ('640122', '贺兰县', '640100'), ('640181', '灵武市', '640100'), ('640200', '石嘴山市', '640000'), ('640201', '市辖区', '640200'), ('640202', '大武口区', '640200'), ('640205', '惠农区', '640200'), ('640221', '平罗县', '640200'), ('640300', '吴忠市', '640000'), ('640301', '市辖区', '640300'), ('640302', '利通区', '640300'), ('640303', '红寺堡区', '640300'), ('640323', '盐池县', '640300'), ('640324', '同心县', '640300'), ('640381', '青铜峡市', '640300'), ('640400', '固原市', '640000'), ('640401', '市辖区', '640400'), ('640402', '原州区', '640400'), ('640422', '西吉县', '640400'), ('640423', '隆德县', '640400'), ('640424', '泾源县', '640400'), ('640425', '彭阳县', '640400'), ('640500', '中卫市', '640000'), ('640501', '市辖区', '640500'), ('640502', '沙坡头区', '640500'), ('640521', '中宁县', '640500'), ('640522', '海原县', '640500'), ('650000', '新疆维吾尔自治区', '0'), ('650100', '乌鲁木齐市', '650000'), ('650101', '市辖区', '650100'), ('650102', '天山区', '650100'), ('650103', '沙依巴克区', '650100'), ('650104', '新市区', '650100'), ('650105', '水磨沟区', '650100'), ('650106', '头屯河区', '650100'), ('650107', '达坂城区', '650100'), ('650109', '米东区', '650100'), ('650121', '乌鲁木齐县', '650100'), ('650200', '克拉玛依市', '650000'), ('650201', '市辖区', '650200'), ('650202', '独山子区', '650200'), ('650203', '克拉玛依区', '650200'), ('650204', '白碱滩区', '650200'), ('650205', '乌尔禾区', '650200'), ('652100', '吐鲁番地区', '650000'), ('652101', '吐鲁番市', '652100'), ('652122', '鄯善县', '652100'), ('652123', '托克逊县', '652100'), ('652200', '哈密地区', '650000'), ('652201', '哈密市', '652200'), ('652222', '巴里坤哈萨克自治县', '652200'), ('652223', '伊吾县', '652200'), ('652300', '昌吉回族自治州', '650000'), ('652301', '昌吉市', '652300'), ('652302', '阜康市', '652300'), ('652323', '呼图壁县', '652300'), ('652324', '玛纳斯县', '652300'), ('652325', '奇台县', '652300'), ('652327', '吉木萨尔县', '652300'), ('652328', '木垒哈萨克自治县', '652300'), ('652700', '博尔塔拉蒙古自治州', '650000'), ('652701', '博乐市', '652700'), ('652702', '阿拉山口市', '652700'), ('652722', '精河县', '652700'), ('652723', '温泉县', '652700'), ('652800', '巴音郭楞蒙古自治州', '650000'), ('652801', '库尔勒市', '652800'), ('652822', '轮台县', '652800'), ('652823', '尉犁县', '652800'), ('652824', '若羌县', '652800'), ('652825', '且末县', '652800'), ('652826', '焉耆回族自治县', '652800'), ('652827', '和静县', '652800'), ('652828', '和硕县', '652800'), ('652829', '博湖县', '652800'), ('652900', '阿克苏地区', '650000'), ('652901', '阿克苏市', '652900'), ('652922', '温宿县', '652900'), ('652923', '库车县', '652900'), ('652924', '沙雅县', '652900'), ('652925', '新和县', '652900'), ('652926', '拜城县', '652900'), ('652927', '乌什县', '652900'), ('652928', '阿瓦提县', '652900'), ('652929', '柯坪县', '652900'), ('653000', '克孜勒苏柯尔克孜自治州', '650000'), ('653001', '阿图什市', '653000'), ('653022', '阿克陶县', '653000'), ('653023', '阿合奇县', '653000'), ('653024', '乌恰县', '653000'), ('653100', '喀什地区', '650000'), ('653101', '喀什市', '653100'), ('653121', '疏附县', '653100'), ('653122', '疏勒县', '653100'), ('653123', '英吉沙县', '653100'), ('653124', '泽普县', '653100'), ('653125', '莎车县', '653100'), ('653126', '叶城县', '653100'), ('653127', '麦盖提县', '653100'), ('653128', '岳普湖县', '653100'), ('653129', '伽师县', '653100'), ('653130', '巴楚县', '653100'), ('653131', '塔什库尔干塔吉克自治县', '653100'), ('653200', '和田地区', '650000'), ('653201', '和田市', '653200'), ('653221', '和田县', '653200'), ('653222', '墨玉县', '653200'), ('653223', '皮山县', '653200'), ('653224', '洛浦县', '653200'), ('653225', '策勒县', '653200'), ('653226', '于田县', '653200'), ('653227', '民丰县', '653200'), ('654000', '伊犁哈萨克自治州', '650000'), ('654002', '伊宁市', '654000'), ('654003', '奎屯市', '654000'), ('654004', '霍尔果斯市', '654000'), ('654021', '伊宁县', '654000'), ('654022', '察布查尔锡伯自治县', '654000'), ('654023', '霍城县', '654000'), ('654024', '巩留县', '654000'), ('654025', '新源县', '654000'), ('654026', '昭苏县', '654000'), ('654027', '特克斯县', '654000'), ('654028', '尼勒克县', '654000'), ('654200', '塔城地区', '650000'), ('654201', '塔城市', '654200'), ('654202', '乌苏市', '654200'), ('654221', '额敏县', '654200'), ('654223', '沙湾县', '654200'), ('654224', '托里县', '654200'), ('654225', '裕民县', '654200'), ('654226', '和布克赛尔蒙古自治县', '654200'), ('654300', '阿勒泰地区', '654000'), ('654301', '阿勒泰市', '654000'), ('654321', '布尔津县', '654000'), ('654322', '富蕴县', '654000'), ('654323', '福海县', '654000'), ('654324', '哈巴河县', '654000'), ('654325', '青河县', '654000'), ('654326', '吉木乃县', '654000'), ('659000', '自治区直辖县级行政区划', '650000'), ('659001', '石河子市', '659000'), ('659002', '阿拉尔市', '659000'), ('659003', '图木舒克市', '659000'), ('659004', '五家渠市', '659000'), ('659005', '北屯市', '659000'), ('659006', '铁门关市', '659000'), ('659007', '双河市', '659000'), ('710000', '台湾省', '0'), ('710100', '台北市', '710000'), ('710101', '松山区', '710100'), ('710102', '信义区', '710100'), ('710103', '大安区', '710100'), ('710104', '中山区', '710100'), ('710105', '中正区', '710100'), ('710106', '大同区', '710100'), ('710107', '万华区', '710100'), ('710108', '文山区', '710100'), ('710109', '南港区', '710100'), ('710110', '内湖区', '710100'), ('710111', '士林区', '710100'), ('710112', '北投区', '710100'), ('710200', '高雄市', '710000'), ('710201', '盐埕区', '710200'), ('710202', '鼓山区', '710200'), ('710203', '左营区', '710200'), ('710204', '楠梓区', '710200'), ('710205', '三民区', '710200'), ('710206', '新兴区', '710200'), ('710207', '前金区', '710200'), ('710208', '苓雅区', '710200'), ('710209', '前镇区', '710200'), ('710210', '旗津区', '710200'), ('710211', '小港区', '710200'), ('710212', '凤山区', '710200'), ('710213', '林园区', '710200'), ('710214', '大寮区', '710200'), ('710215', '大树区', '710200'), ('710216', '大社区', '710200'), ('710217', '仁武区', '710200'), ('710218', '鸟松区', '710200'), ('710219', '冈山区', '710200'), ('710220', '桥头区', '710200'), ('710221', '燕巢区', '710200'), ('710222', '田寮区', '710200'), ('710223', '阿莲区', '710200'), ('710224', '路竹区', '710200'), ('710225', '湖内区', '710200'), ('710226', '茄萣区', '710200'), ('710227', '永安区', '710200'), ('710228', '弥陀区', '710200'), ('710229', '梓官区', '710200'), ('710230', '旗山区', '710200'), ('710231', '美浓区', '710200'), ('710232', '六龟区', '710200'), ('710233', '甲仙区', '710200'), ('710234', '杉林区', '710200'), ('710235', '内门区', '710200'), ('710236', '茂林区', '710200'), ('710237', '桃源区', '710200'), ('710238', '那玛夏区', '710200'), ('710300', '基隆市', '710000'), ('710301', '中正区', '710300'), ('710302', '七堵区', '710300'), ('710303', '暖暖区', '710300'), ('710304', '仁爱区', '710300'), ('710305', '中山区', '710300'), ('710306', '安乐区', '710300'), ('710307', '信义区', '710300'), ('710400', '台中市', '710000'), ('710401', '中区', '710400'), ('710402', '东区', '710400'), ('710403', '南区', '710400'), ('710404', '西区', '710400'), ('710405', '北区', '710400'), ('710406', '西屯区', '710400'), ('710407', '南屯区', '710400'), ('710408', '北屯区', '710400'), ('710409', '丰原区', '710400'), ('710410', '东势区', '710400'), ('710411', '大甲区', '710400'), ('710412', '清水区', '710400'), ('710413', '沙鹿区', '710400'), ('710414', '梧栖区', '710400'), ('710415', '后里区', '710400'), ('710416', '神冈区', '710400'), ('710417', '潭子区', '710400'), ('710418', '大雅区', '710400'), ('710419', '新社区', '710400'), ('710420', '石冈区', '710400'), ('710421', '外埔区', '710400'), ('710422', '大安区', '710400'), ('710423', '乌日区', '710400'), ('710424', '大肚区', '710400'), ('710425', '龙井区', '710400'), ('710426', '雾峰区', '710400'), ('710427', '太平区', '710400'), ('710428', '大里区', '710400'), ('710429', '和平区', '710400'), ('710500', '台南市', '710000'), ('710501', '东区', '710500'), ('710502', '南区', '710500'), ('710504', '北区', '710500'), ('710506', '安南区', '710500'), ('710507', '安平区', '710500'), ('710508', '中西区', '710500'), ('710509', '新营区', '710500'), ('710510', '盐水区', '710500'), ('710511', '白河区', '710500'), ('710512', '柳营区', '710500'), ('710513', '后壁区', '710500'), ('710514', '东山区', '710500'), ('710515', '麻豆区', '710500'), ('710516', '下营区', '710500'), ('710517', '六甲区', '710500'), ('710518', '官田区', '710500'), ('710519', '大内区', '710500'), ('710520', '佳里区', '710500'), ('710521', '学甲区', '710500'), ('710522', '西港区', '710500'), ('710523', '七股区', '710500'), ('710524', '将军区', '710500'), ('710525', '北门区', '710500'), ('710526', '新化区', '710500'), ('710527', '善化区', '710500'), ('710528', '新市区', '710500'), ('710529', '安定区', '710500'), ('710530', '山上区', '710500'), ('710531', '玉井区', '710500'), ('710532', '楠西区', '710500'), ('710533', '南化区', '710500'), ('710534', '左镇区', '710500'), ('710535', '仁德区', '710500'), ('710536', '归仁区', '710500'), ('710537', '关庙区', '710500'), ('710538', '龙崎区', '710500'), ('710539', '永康区', '710500'), ('710600', '新竹市', '710000'), ('710601', '东区', '710600'), ('710602', '北区', '710600'), ('710603', '香山区', '710600'), ('710700', '嘉义市', '710000'), ('710701', '东区', '710700'), ('710702', '西区', '710700'), ('710800', '新北市', '710000'), ('710801', '板桥区', '710800'), ('710802', '三重区', '710800'), ('710803', '中和区', '710800'), ('710804', '永和区', '710800'), ('710805', '新庄区', '710800'), ('710806', '新店区', '710800'), ('710807', '树林区', '710800'), ('710808', '莺歌区', '710800'), ('710809', '三峡区', '710800'), ('710810', '淡水区', '710800'), ('710811', '汐止区', '710800'), ('710812', '瑞芳区', '710800'), ('710813', '土城区', '710800'), ('710814', '芦洲区', '710800'), ('710815', '五股区', '710800'), ('710816', '泰山区', '710800'), ('710817', '林口区', '710800'), ('710818', '深坑区', '710800'), ('710819', '石碇区', '710800'), ('710820', '坪林区', '710800'), ('710821', '三芝区', '710800'), ('710822', '石门区', '710800'), ('710823', '八里区', '710800'), ('710824', '平溪区', '710800'), ('710825', '双溪区', '710800'), ('710826', '贡寮区', '710800'), ('710827', '金山区', '710800'), ('710828', '万里区', '710800'), ('710829', '乌来区', '710800'), ('712200', '宜兰县', '710000'), ('712201', '宜兰市', '712200'), ('712221', '罗东镇', '712200'), ('712222', '苏澳镇', '712200'), ('712223', '头城镇', '712200'), ('712224', '礁溪乡', '712200'), ('712225', '壮围乡', '712200'), ('712226', '员山乡', '712200'), ('712227', '冬山乡', '712200'), ('712228', '五结乡', '712200'), ('712229', '三星乡', '712200'), ('712230', '大同乡', '712200'), ('712231', '南澳乡', '712200'), ('712300', '桃园县', '710000'), ('712301', '桃园市', '712300'), ('712302', '中坜市', '712300'), ('712303', '平镇市', '712300'), ('712304', '八德市', '712300'), ('712305', '杨梅市', '712300'), ('712321', '大溪镇', '712300'), ('712323', '芦竹乡', '712300'), ('712324', '大园乡', '712300'), ('712325', '龟山乡', '712300'), ('712327', '龙潭乡', '712300'), ('712329', '新屋乡', '712300'), ('712330', '观音乡', '712300'), ('712331', '复兴乡', '712300'), ('712400', '新竹县', '710000'), ('712401', '竹北市', '712400'), ('712421', '竹东镇', '712400'), ('712422', '新埔镇', '712400'), ('712423', '关西镇', '712400'), ('712424', '湖口乡', '712400'), ('712425', '新丰乡', '712400'), ('712426', '芎林乡', '712400'), ('712427', '橫山乡', '712400'), ('712428', '北埔乡', '712400'), ('712429', '宝山乡', '712400'), ('712430', '峨眉乡', '712400'), ('712431', '尖石乡', '712400'), ('712432', '五峰乡', '712400'), ('712500', '苗栗县', '710000'), ('712501', '苗栗市', '712500'), ('712521', '苑里镇', '712500'), ('712522', '通霄镇', '712500'), ('712523', '竹南镇', '712500'), ('712524', '头份镇', '712500'), ('712525', '后龙镇', '712500'), ('712526', '卓兰镇', '712500'), ('712527', '大湖乡', '712500'), ('712528', '公馆乡', '712500'), ('712529', '铜锣乡', '712500'), ('712530', '南庄乡', '712500'), ('712531', '头屋乡', '712500'), ('712532', '三义乡', '712500'), ('712533', '西湖乡', '712500'), ('712534', '造桥乡', '712500'), ('712535', '三湾乡', '712500'), ('712536', '狮潭乡', '712500'), ('712537', '泰安乡', '712500'), ('712700', '彰化县', '710000'), ('712701', '彰化市', '712700'), ('712721', '鹿港镇', '712700'), ('712722', '和美镇', '712700'), ('712723', '线西乡', '712700'), ('712724', '伸港乡', '712700'), ('712725', '福兴乡', '712700'), ('712726', '秀水乡', '712700'), ('712727', '花坛乡', '712700'), ('712728', '芬园乡', '712700'), ('712729', '员林镇', '712700'), ('712730', '溪湖镇', '712700'), ('712731', '田中镇', '712700'), ('712732', '大村乡', '712700'), ('712733', '埔盐乡', '712700'), ('712734', '埔心乡', '712700'), ('712735', '永靖乡', '712700'), ('712736', '社头乡', '712700'), ('712737', '二水乡', '712700'), ('712738', '北斗镇', '712700'), ('712739', '二林镇', '712700'), ('712740', '田尾乡', '712700'), ('712741', '埤头乡', '712700'), ('712742', '芳苑乡', '712700'), ('712743', '大城乡', '712700'), ('712744', '竹塘乡', '712700'), ('712745', '溪州乡', '712700'), ('712800', '南投县', '710000'), ('712801', '南投市', '712800'), ('712821', '埔里镇', '712800'), ('712822', '草屯镇', '712800'), ('712823', '竹山镇', '712800'), ('712824', '集集镇', '712800'), ('712825', '名间乡', '712800'), ('712826', '鹿谷乡', '712800'), ('712827', '中寮乡', '712800'), ('712828', '鱼池乡', '712800'), ('712829', '国姓乡', '712800'), ('712830', '水里乡', '712800'), ('712831', '信义乡', '712800'), ('712832', '仁爱乡', '712800'), ('712900', '云林县', '710000'), ('712901', '斗六市', '712900'), ('712921', '斗南镇', '712900'), ('712922', '虎尾镇', '712900'), ('712923', '西螺镇', '712900'), ('712924', '土库镇', '712900'), ('712925', '北港镇', '712900'), ('712926', '古坑乡', '712900'), ('712927', '大埤乡', '712900'), ('712928', '莿桐乡', '712900'), ('712929', '林内乡', '712900'), ('712930', '二仑乡', '712900'), ('712931', '仑背乡', '712900'), ('712932', '麦寮乡', '712900'), ('712933', '东势乡', '712900'), ('712934', '褒忠乡', '712900'), ('712935', '台西乡', '712900'), ('712936', '元长乡', '712900'), ('712937', '四湖乡', '712900'), ('712938', '口湖乡', '712900'), ('712939', '水林乡', '712900'), ('713000', '嘉义县', '710000'), ('713001', '太保市', '713000'), ('713002', '朴子市', '713000'), ('713023', '布袋镇', '713000'), ('713024', '大林镇', '713000'), ('713025', '民雄乡', '713000'), ('713026', '溪口乡', '713000'), ('713027', '新港乡', '713000'), ('713028', '六脚乡', '713000'), ('713029', '东石乡', '713000'), ('713030', '义竹乡', '713000'), ('713031', '鹿草乡', '713000'), ('713032', '水上乡', '713000'), ('713033', '中埔乡', '713000'), ('713034', '竹崎乡', '713000'), ('713035', '梅山乡', '713000'), ('713036', '番路乡', '713000'), ('713037', '大埔乡', '713000'), ('713038', '阿里山乡', '713000'), ('713300', '屏东县', '710000'), ('713301', '屏东市', '713300'), ('713321', '潮州镇', '713300'), ('713322', '东港镇', '713300'), ('713323', '恒春镇', '713300'), ('713324', '万丹乡', '713300'), ('713325', '长治乡', '713300'), ('713326', '麟洛乡', '713300'), ('713327', '九如乡', '713300'), ('713328', '里港乡', '713300'), ('713329', '盐埔乡', '713300'), ('713330', '高树乡', '713300'), ('713331', '万峦乡', '713300'), ('713332', '内埔乡', '713300'), ('713333', '竹田乡', '713300'), ('713334', '新埤乡', '713300'), ('713335', '枋寮乡', '713300'), ('713336', '新园乡', '713300'), ('713337', '崁顶乡', '713300'), ('713338', '林边乡', '713300'), ('713339', '南州乡', '713300'), ('713340', '佳冬乡', '713300'), ('713341', '琉球乡', '713300'), ('713342', '车城乡', '713300'), ('713343', '满州乡', '713300'), ('713344', '枋山乡', '713300'), ('713345', '三地门乡', '713300'), ('713346', '雾台乡', '713300'), ('713347', '玛家乡', '713300'), ('713348', '泰武乡', '713300'), ('713349', '来义乡', '713300'), ('713350', '春日乡', '713300'), ('713351', '狮子乡', '713300'), ('713352', '牡丹乡', '713300'), ('713400', '台东县', '710000'), ('713401', '台东市', '713400'), ('713421', '成功镇', '713400'), ('713422', '关山镇', '713400'), ('713423', '卑南乡', '713400'), ('713424', '鹿野乡', '713400'), ('713425', '池上乡', '713400'), ('713426', '东河乡', '713400'), ('713427', '长滨乡', '713400'), ('713428', '太麻里乡', '713400'), ('713429', '大武乡', '713400'), ('713430', '绿岛乡', '713400'), ('713431', '海端乡', '713400'), ('713432', '延平乡', '713400'), ('713433', '金峰乡', '713400'), ('713434', '达仁乡', '713400'), ('713435', '兰屿乡', '713400'), ('713500', '花莲县', '710000'), ('713501', '花莲市', '713500'), ('713521', '凤林镇', '713500'), ('713522', '玉里镇', '713500'), ('713523', '新城乡', '713500'), ('713524', '吉安乡', '713500'), ('713525', '寿丰乡', '713500'), ('713526', '光复乡', '713500'), ('713527', '丰滨乡', '713500'), ('713528', '瑞穗乡', '713500'), ('713529', '富里乡', '713500'), ('713530', '秀林乡', '713500'), ('713531', '万荣乡', '713500'), ('713532', '卓溪乡', '713500'), ('713600', '澎湖县', '710000'), ('713601', '马公市', '713600'), ('713621', '湖西乡', '713600'), ('713622', '白沙乡', '713600'), ('713623', '西屿乡', '713600'), ('713624', '望安乡', '713600'), ('713625', '七美乡', '713600'), ('810000', '香港特别行政区', '0'), ('810100', '香港岛', '810000'), ('810101', '中西区', '810100'), ('810102', '湾仔区', '810100'), ('810103', '东区', '810100'), ('810104', '南区', '810100'), ('810200', '九龙', '810000'), ('810201', '油尖旺区', '810200'), ('810202', '深水埗区', '810200'), ('810203', '九龙城区', '810200'), ('810204', '黄大仙区', '810200'), ('810205', '观塘区', '810200'), ('810300', '新界', '810000'), ('810301', '荃湾区', '810300'), ('810302', '屯门区', '810300'), ('810303', '元朗区', '810300'), ('810304', '北区', '810300'), ('810305', '大埔区', '810300'), ('810306', '西贡区', '810300'), ('810307', '沙田区', '810300'), ('810308', '葵青区', '810300'), ('810309', '离岛区', '810300'), ('820000', '澳门特别行政区', '0'), ('820100', '澳门半岛', '820000'), ('820101', '花地玛堂区', '820100'), ('820102', '圣安多尼堂区', '820100'), ('820103', '大堂区', '820100'), ('820104', '望德堂区', '820100'), ('820105', '风顺堂区', '820100'), ('820200', '氹仔岛', '820000'), ('820201', '嘉模堂区', '820200'), ('820300', '路环岛', '820000'), ('820301', '圣方济各堂区', '820300'), ('2102111', '高新园区', '210200'), ('350902500', '东侨开发区', '350900'), ('441900003', '东城街道', '441900'), ('441900004', '南城街道', '441900'), ('441900005', '万江街道', '441900'), ('441900006', '莞城街道', '441900'), ('441900101', '石碣镇', '441900'), ('441900102', '石龙镇', '441900'), ('441900103', '茶山镇', '441900'), ('441900104', '石排镇', '441900'), ('441900105', '企石镇', '441900'), ('441900106', '横沥镇', '441900'), ('441900107', '桥头镇', '441900'), ('441900108', '谢岗镇', '441900'), ('441900109', '东坑镇', '441900'), ('441900110', '常平镇', '441900'), ('441900111', '寮步镇', '441900'), ('441900112', '樟木头镇', '441900'), ('441900113', '大朗镇', '441900'), ('441900114', '黄江镇', '441900'), ('441900115', '清溪镇', '441900'), ('441900116', '塘厦镇', '441900'), ('441900117', '凤岗镇', '441900'), ('441900118', '大岭山镇', '441900'), ('441900119', '长安镇', '441900'), ('441900121', '虎门镇', '441900'), ('441900122', '厚街镇', '441900'), ('441900123', '沙田镇', '441900'), ('441900124', '道滘镇', '441900'), ('441900125', '洪梅镇', '441900'), ('441900126', '麻涌镇', '441900'), ('441900127', '望牛墩镇', '441900'), ('441900128', '中堂镇', '441900'), ('441900129', '高埗镇', '441900'), ('441900401', '松山湖管委会', '441900'), ('441900402', '东莞港', '441900'), ('441900403', '东莞生态园', '441900'), ('442000001', '石岐区街道', '442000'), ('442000002', '东区街道', '442000'), ('442000003', '火炬开发区街道', '442000'), ('442000004', '西区街道', '442000'), ('442000005', '南区街道', '442000'), ('442000006', '五桂山街道', '442000'), ('442000100', '小榄镇', '442000'), ('442000101', '黄圃镇', '442000'), ('442000102', '民众镇', '442000'), ('442000103', '东凤镇', '442000'), ('442000104', '东升镇', '442000'), ('442000105', '古镇镇', '442000'), ('442000106', '沙溪镇', '442000'), ('442000107', '坦洲镇', '442000'), ('442000108', '港口镇', '442000'), ('442000109', '三角镇', '442000'), ('442000110', '横栏镇', '442000'), ('442000111', '南头镇', '442000'), ('442000112', '阜沙镇', '442000'), ('442000113', '南朗镇', '442000'), ('442000114', '三乡镇', '442000'), ('442000115', '板芙镇', '442000'), ('442000116', '大涌镇', '442000'), ('442000117', '神湾镇', '442000');
COMMIT;

-- ----------------------------
--  Table structure for `ky_friend_link`
-- ----------------------------
DROP TABLE IF EXISTS `ky_friend_link`;
CREATE TABLE `ky_friend_link` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `title` varchar(30) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '名称',
  `link` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '链接',
  `sort` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '数字越小越靠前',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='友链';

-- ----------------------------
--  Records of `ky_friend_link`
-- ----------------------------
BEGIN;
INSERT INTO `ky_friend_link` VALUES ('1', '酷云科技', 'http://www.kuryun.com/', '0', '1596273399', '1596273399', '1'), ('2', 'ThinkPHP', 'https://www.thinkphp.cn/', '1', '1596273469', '1596273548', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_image_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_image_1`;
CREATE TABLE `ky_media_image_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文本内容',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '图片url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（用于判断上传的图片是否小于微信素材库的限制2M）',
  `ext` enum('bmp','jpg','jpeg','png','gif') NOT NULL DEFAULT 'jpg' COMMENT '图片格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='图片素材库';

-- ----------------------------
--  Table structure for `ky_media_image_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_image_2`;
CREATE TABLE `ky_media_image_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文本内容',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '图片url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（用于判断上传的图片是否小于微信素材库的限制2M）',
  `ext` enum('bmp','jpg','jpeg','png','gif') NOT NULL DEFAULT 'jpg' COMMENT '图片格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb4;

-- ----------------------------
--  Records of `ky_media_image_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_image_2` VALUES ('1', '1', '3', 'fdj-sm.jpg', 'http://devhhb.images.huihuiba.net/1-5ed5f6b7e9d06.jpg', '1591080632', '1591080632', '1', '', '107027', 'jpg', ''), ('5', '1', '3', 'tomcat.png', 'http://devhhb.images.huihuiba.net/1-5ed601c39157b.png', '1591083460', '1591083460', '1', 'ZOzBoX0K4goJhq2CjCXt8u29sqn4ytxq4Rb3YEA6MOg', '5103', 'png', ''), ('6', '1', '3', '1212.jpg', 'http://devhhb.images.huihuiba.net/1-5ed603542b0f4.jpg', '1591083861', '1591083861', '1', 'ZOzBoX0K4goJhq2CjCXt8rnE0z02H4jcA9Kw618DmoE', '33185', 'jpg', ''), ('8', '1', '1', '11.jpg', 'http://devhhb.images.huihuiba.net/1-5ed91d9b11916.jpg', '1591287196', '1591287196', '1', 'JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4', '15687', 'jpg', 'Qiniu'), ('11', '1', '3', '3.jpg', 'http://devhhb.images.huihuiba.net/1-5ed9ef3be7526.jpg', '1591340860', '1591340860', '1', '', '11583', 'jpg', 'Qiniu'), ('12', '1', '3', '18.jpg', 'http://devhhb.images.huihuiba.net/1-5ed9ef72329c0.jpg', '1591340914', '1591340915', '1', 'ZOzBoX0K4goJhq2CjCXt8jInOO11NuqcWYOg4A4Gv5Q', '21920', 'jpg', 'Qiniu'), ('13', '1', '3', 'p1.png', 'http://devhhb.images.huihuiba.net/1-5eda5e430bdff.png', '1591369287', '1591369287', '1', '', '629161', 'png', 'Qiniu'), ('14', '1', '3', 'p2.png', 'http://devhhb.images.huihuiba.net/1-5eda5e4754030.png', '1591369293', '1591369293', '1', '', '755358', 'png', 'Qiniu'), ('15', '1', '3', 'IMG_0718.JPG', 'http://devhhb.images.huihuiba.net/1-5eda64b151478.JPG', '1591370931', '1591370984', '1', 'ZOzBoX0K4goJhq2CjCXt8sGRiIUyzt2fMcw0YXvL564', '367667', 'jpg', 'Qiniu'), ('16', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f1011aad2d7e.png', '1594888619', '1594888619', '1', '', '7591', 'png', 'Qiniu'), ('17', '1', '1', 'IMG_1471.JPG', 'http://devhhb.images.huihuiba.net/1-5f13120e0b7c1.JPG', '1595085338', '1595085338', '1', '', '1735226', 'jpg', 'Qiniu'), ('18', '1', '1', 'mp_test.jpg', 'http://devhhb.images.huihuiba.net/1-5f156f510f649.jpg', '1595240273', '1595240273', '1', '', '24614', 'jpg', 'Qiniu'), ('19', '1', '1', '分享小程序.jpg', 'http://devhhb.images.huihuiba.net/1-5f1582f0b24e6.jpg', '1595245297', '1595245297', '1', '', '69368', 'jpg', 'Qiniu'), ('20', '1', '1', '地图找机构.jpg', 'http://devhhb.images.huihuiba.net/1-5f1582f10db72.jpg', '1595245297', '1595245297', '1', '', '157559', 'jpg', 'Qiniu'), ('21', '1', '1', 'fdj.jpg', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', '1595470127', '1595470127', '1', '', '30783', 'jpg', 'Qiniu'), ('22', '1', '1', 'LOGO.png', 'http://devhhb.images.huihuiba.net/1-5f192376a1017.png', '1595482999', '1595482999', '1', '', '214899', 'png', 'Qiniu'), ('23', '1', '1', '10元红包.jpg', '/public/uploads/image/2020-07-29/1-5f21844f8b937.jpg', '1596032079', '1596032079', '1', '', '52835', 'jpg', 'Local'), ('24', '1', '1', '家电小.jpg', 'http://devhhb.images.huihuiba.net/1-5f2223dd6539f.jpg', '1596072925', '1596072925', '1', '', '111848', 'jpg', 'Qiniu'), ('25', '1', '1', '2.png', 'http://devhhb.images.huihuiba.net/1-5f2232d6244a0.png', '1596076758', '1596076758', '1', '', '169743', 'png', 'Qiniu'), ('26', '1', '1', '1.png', 'http://devhhb.images.huihuiba.net/1-5f2232d6c5fac.png', '1596076760', '1596076760', '1', '', '214342', 'png', 'Qiniu'), ('28', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f25196521913.png', '1596266853', '1596266853', '1', '', '9576', 'png', 'Qiniu'), ('29', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f27af582cf0d.png', '1596436312', '1596436312', '1', '', '9902', 'png', 'Qiniu'), ('30', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f27aff29f820.png', '1596436466', '1596708994', '1', 'JW8XS34h_ISSqHFm_g1Wsb42ymhiNocn6sD4gQFbloQ', '4950', 'png', 'Qiniu'), ('31', '1', '1', '微信图片_20200812120423.jpg', 'http://devhhb.images.huihuiba.net/1-5f336a7d80daf.jpg', '1597205117', '1597205117', '1', '', '40519', 'jpg', 'Qiniu'), ('33', '1', '1', 'banner.png', 'http://devhhb.images.huihuiba.net/1-5f6dbbafe39f6.png', '1601026992', '1601026992', '1', '', '23812', 'png', 'Qiniu'), ('34', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f6dbbe663c54.png', '1601027046', '1601027046', '1', '', '10710', 'png', 'Qiniu'), ('35', '1', '1', 'detail.jpg', 'http://devhhb.images.huihuiba.net/1-5f6dbbf695e49.jpg', '1601027064', '1601027064', '1', '', '267735', 'jpg', 'Qiniu'), ('36', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f90de3570d82.png', '1603329589', '1603329589', '1', '', '4950', 'png', 'Qiniu'), ('37', '1', '1', 'logo.png', 'http://devhhb.images.huihuiba.net/1-5f993b50e33cb.png', '1603877713', '1603877713', '1', '', '4950', 'png', 'Qiniu'), ('38', '1', '1', '龙门.jpg', 'http://devhhb.images.huihuiba.net/1-5f9ac33c1e824.jpg', '1603978044', '1603978045', '1', 'JW8XS34h_ISSqHFm_g1WsT-wHid8KQLY90YS3udn7M8', '21161', 'jpg', 'Qiniu'), ('39', '1', '1', '3.jpg', 'http://devhhb.images.huihuiba.net/1-5f9b7a8430ab8.jpg', '1604024964', '1604024965', '1', 'JW8XS34h_ISSqHFm_g1WsbvfZsnw32sHr8Z4GdLavB4', '11583', 'jpg', 'Qiniu');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_image_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_image_3`;
CREATE TABLE `ky_media_image_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文本内容',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '图片url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '文件大小（用于判断上传的图片是否小于微信素材库的限制2M）',
  `ext` enum('bmp','jpg','jpeg','png','gif') NOT NULL DEFAULT 'jpg' COMMENT '图片格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
--  Table structure for `ky_media_image_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_image_4`;
CREATE TABLE `ky_media_image_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文本内容',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '图片url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '文件大小（用于判断上传的图片是否小于微信素材库的限制2M）',
  `ext` enum('bmp','jpg','jpeg','png','gif') NOT NULL DEFAULT 'jpg' COMMENT '图片格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
--  Table structure for `ky_media_image_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_image_5`;
CREATE TABLE `ky_media_image_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文本内容',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '图片url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '文件大小（用于判断上传的图片是否小于微信素材库的限制2M）',
  `ext` enum('bmp','jpg','jpeg','png','gif') NOT NULL DEFAULT 'jpg' COMMENT '图片格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4;

-- ----------------------------
--  Records of `ky_media_image_5`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_image_5` VALUES ('1', '4', '15', 'test.png', 'http://devhhb.images.huihuiba.net/4-5f741b422a336.png', '1601444677', '1601444699', '1', 'd-Bl8fN0nEVenrOk97MnF9PunS1PO3LjGU9zCqqddzM', '558242', 'png', 'Qiniu'), ('2', '4', '15', '35ef90cb20757d2d983bac56044b1700.png', 'http://devhhb.images.huihuiba.net/4-5f7ca841b714d.png', '1602005057', '1602005057', '1', '', '10565', 'png', 'Qiniu');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_music_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_music_1`;
CREATE TABLE `ky_media_music_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '客户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `hq_url` varchar(200) NOT NULL DEFAULT '' COMMENT '高品质链接',
  `thumb_media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='音乐素材';

-- ----------------------------
--  Table structure for `ky_media_music_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_music_2`;
CREATE TABLE `ky_media_music_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '客户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `hq_url` varchar(200) NOT NULL DEFAULT '' COMMENT '高品质链接',
  `thumb_media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='音乐素材';

-- ----------------------------
--  Records of `ky_media_music_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_music_2` VALUES ('2', '1', '3', '音乐1', '音乐描述', 'http://devhhb.images.huihuiba.net/1-5eda125e86564.mp3', 'http://devhhb.images.huihuiba.net/1-5eda125e86564.mp3', '', '1591438777', '1591438777', '1'), ('3', '1', '3', '测试', '描述啊', 'http://devhhb.images.huihuiba.net/1-5eda049e9f1fc.mp3', '', '', '1591452563', '1591452563', '1'), ('4', '1', '3', '音乐2', '活动总动员', 'http://devhhb.images.huihuiba.net/1-5eda6c0655458.mp3', '', '', '1591453031', '1591453031', '1'), ('5', '1', '3', '音乐3', '2323', 'http://devhhb.images.huihuiba.net/1-5edba6680e992.mp3', '', '', '1591453333', '1591453333', '1'), ('6', '1', '1', '音乐1', '描述', 'http://devhhb.images.huihuiba.net/1-5edefa098fed9.mp3', '', '', '1591671475', '1591671475', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_music_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_music_3`;
CREATE TABLE `ky_media_music_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '客户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `hq_url` varchar(200) NOT NULL DEFAULT '' COMMENT '高品质链接',
  `thumb_media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='音乐素材';

-- ----------------------------
--  Table structure for `ky_media_music_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_music_4`;
CREATE TABLE `ky_media_music_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '客户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `hq_url` varchar(200) NOT NULL DEFAULT '' COMMENT '高品质链接',
  `thumb_media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='音乐素材';

-- ----------------------------
--  Table structure for `ky_media_music_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_music_5`;
CREATE TABLE `ky_media_music_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '客户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `hq_url` varchar(200) NOT NULL DEFAULT '' COMMENT '高品质链接',
  `thumb_media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='音乐素材';

-- ----------------------------
--  Table structure for `ky_media_news_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_news_1`;
CREATE TABLE `ky_media_news_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文标题',
  `thumb_media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图片 mediaId',
  `cover_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图url',
  `author` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '作者',
  `show_cover_pic` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在文章内容显示封面图片（1：是；0：否）',
  `digest` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文章内容摘要',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '正文内容',
  `content_source_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的原文地址',
  `media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的id',
  `url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文链接，获取素材中得到的',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '要更新的文章在图文消息中的位置（多图文消息时，此字段才有意义），第一篇为0',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头条id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '图文类型（1：微信图文；2：消息链接）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`mpid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='图文表';

-- ----------------------------
--  Table structure for `ky_media_news_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_news_2`;
CREATE TABLE `ky_media_news_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文标题',
  `thumb_media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图片 mediaId',
  `cover_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图url',
  `author` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '作者',
  `show_cover_pic` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在文章内容显示封面图片（1：是；0：否）',
  `digest` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文章内容摘要',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '正文内容',
  `content_source_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的原文地址',
  `media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的id',
  `url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文链接，获取素材中得到的',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '要更新的文章在图文消息中的位置（多图文消息时，此字段才有意义），第一篇为0',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头条id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '图文类型（1：微信图文；2：消息链接）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`mpid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='图文表';

-- ----------------------------
--  Records of `ky_media_news_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_news_2` VALUES ('1', '1', '1', '图文1', 'JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4', 'http://devhhb.images.huihuiba.net/1-5ed91d9b11916.jpg', '', '0', '', '', 'http://www.huihuiba.net', '', '', '0', '0', '2', '1', '1603944093', '1604028679'), ('2', '1', '1', '图文2-2', 'JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4', 'http://devhhb.images.huihuiba.net/1-5ed91d9b11916.jpg', '', '0', '', '', 'http://www.qq.com/', '', '', '0', '0', '2', '1', '1603944260', '1604071545'), ('3', '1', '1', 'a1', 'ZOzBoX0K4goJhq2CjCXt8jInOO11NuqcWYOg4A4Gv5Q', 'http://devhhb.images.huihuiba.net/1-5ed9ef72329c0.jpg', '', '0', '', '', 'http://www.baidu.com', '', '', '1', '2', '2', '1', '1603944260', '1604071545'), ('5', '1', '1', '微信图文', 'JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4', 'http://devhhb.images.huihuiba.net/1-5ed91d9b11916.jpg', '', '0', 'sssss', '<p>测试<br/></p>', '', '', '', '0', '0', '2', '1', '1603967345', '1603967346'), ('10', '1', '1', '333-改', 'JW8XS34h_ISSqHFm_g1WsT-wHid8KQLY90YS3udn7M8', 'http://devhhb.images.huihuiba.net/1-5f9ac33c1e824.jpg', '苟哥', '0', '测试摘要', '<p>得到的<br/></p>', 'http://www.huihuiba.net', 'JW8XS34h_ISSqHFm_g1WsWHao7iz4Rp0A4OVwPlUneY', '', '0', '0', '1', '1', '1603978115', '1604025323'), ('12', '1', '1', '444', 'JW8XS34h_ISSqHFm_g1WsbvfZsnw32sHr8Z4GdLavB4', 'http://devhhb.images.huihuiba.net/1-5f9b7a8430ab8.jpg', '', '0', '', '<p>444444</p>', '', '', '', '1', '10', '1', '1', '1604025323', '1604025323');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_news_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_news_3`;
CREATE TABLE `ky_media_news_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文标题',
  `thumb_media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图片 mediaId',
  `cover_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图url',
  `author` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '作者',
  `show_cover_pic` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在文章内容显示封面图片（1：是；0：否）',
  `digest` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文章内容摘要',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '正文内容',
  `content_source_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的原文地址',
  `media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的id',
  `url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文链接，获取素材中得到的',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '要更新的文章在图文消息中的位置（多图文消息时，此字段才有意义），第一篇为0',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头条id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '图文类型（1：微信图文；2：消息链接）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`mpid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='图文表';

-- ----------------------------
--  Table structure for `ky_media_news_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_news_4`;
CREATE TABLE `ky_media_news_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文标题',
  `thumb_media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图片 mediaId',
  `cover_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图url',
  `author` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '作者',
  `show_cover_pic` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在文章内容显示封面图片（1：是；0：否）',
  `digest` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文章内容摘要',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '正文内容',
  `content_source_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的原文地址',
  `media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的id',
  `url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文链接，获取素材中得到的',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '要更新的文章在图文消息中的位置（多图文消息时，此字段才有意义），第一篇为0',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头条id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '图文类型（1：微信图文；2：消息链接）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`mpid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='图文表';

-- ----------------------------
--  Table structure for `ky_media_news_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_news_5`;
CREATE TABLE `ky_media_news_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文标题',
  `thumb_media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图片 mediaId',
  `cover_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '封面图url',
  `author` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '作者',
  `show_cover_pic` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在文章内容显示封面图片（1：是；0：否）',
  `digest` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文章内容摘要',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '正文内容',
  `content_source_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的原文地址',
  `media_id` varchar(120) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文消息的id',
  `url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '图文链接，获取素材中得到的',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '要更新的文章在图文消息中的位置（多图文消息时，此字段才有意义），第一篇为0',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头条id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '图文类型（1：微信图文；2：消息链接）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`mpid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='图文表';

-- ----------------------------
--  Table structure for `ky_media_text_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_text_1`;
CREATE TABLE `ky_media_text_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '文本内容',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='文本素材';

-- ----------------------------
--  Table structure for `ky_media_text_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_text_2`;
CREATE TABLE `ky_media_text_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '文本内容',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='文本素材';

-- ----------------------------
--  Records of `ky_media_text_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_text_2` VALUES ('5', '1', '我是一段普通文本', '1591062430', '1591062430', '1'), ('7', '1', '测试', '1591062567', '1591062567', '1'), ('8', '1', '啊啊啊', '1591062606', '1591062606', '1'), ('10', '1', '测试文本', '1591063189', '1591063189', '1'), ('13', '1', '<a href=\"http://www.huihuiba.net/weixin\">加入汇汇吧</a>', '1591063451', '1591063451', '1'), ('14', '1', '这是一段对语音的回复', '1591624178', '1591624178', '1'), ('15', '1', '暂时无法回答你哦', '1591628258', '1591628258', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_text_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_text_3`;
CREATE TABLE `ky_media_text_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '文本内容',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='文本素材';

-- ----------------------------
--  Table structure for `ky_media_text_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_text_4`;
CREATE TABLE `ky_media_text_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '文本内容',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='文本素材';

-- ----------------------------
--  Table structure for `ky_media_text_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_text_5`;
CREATE TABLE `ky_media_text_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '文本内容',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='文本素材';

-- ----------------------------
--  Records of `ky_media_text_5`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_text_5` VALUES ('1', '4', '呵呵呵', '1601444496', '1601444496', '1'), ('2', '4', '你好，请重新输入。', '1601445081', '1601445081', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_video_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_video_1`;
CREATE TABLE `ky_media_video_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp4') NOT NULL DEFAULT 'mp4' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `cover` varchar(200) NOT NULL DEFAULT '' COMMENT '封面',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='视频素材';

-- ----------------------------
--  Table structure for `ky_media_video_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_video_2`;
CREATE TABLE `ky_media_video_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp4') NOT NULL DEFAULT 'mp4' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `cover` varchar(200) NOT NULL DEFAULT '' COMMENT '封面',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='视频素材';

-- ----------------------------
--  Records of `ky_media_video_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_video_2` VALUES ('1', '1', '3', 'test.mp4', 'http://devhhb.images.huihuiba.net/1-5eda5594cb117.mp4', '1591367062', '1591457874', '1', 'ZOzBoX0K4goJhq2CjCXt8tNogKn49PcWU81kOnAXVTs', '318465', 'mp4', 'Qiniu', '', ''), ('2', '1', '3', 'CNAS4517.mp4', 'http://devhhb.images.huihuiba.net/1-5eda5f98a0f9e.mp4', '1591369636', '1591369636', '1', '', '1579529', 'mp4', 'Qiniu', '', ''), ('3', '1', '3', 'CQKW7923.mp4', 'http://devhhb.images.huihuiba.net/1-5eda5fe9ebd35.mp4', '1591369718', '1591370085', '1', 'ZOzBoX0K4goJhq2CjCXt8jV4XLHZXfBYccO8oAsStv8', '1617795', 'mp4', 'Qiniu', '', ''), ('4', '1', '1', 'shoes.mp4', 'http://devhhb.images.huihuiba.net/1-5ede13cc96f94.mp4', '1591612373', '1591612634', '1', 'JW8XS34h_ISSqHFm_g1WsSLp9WAdOkH-Kpe9m-UCR2g', '1259428', 'mp4', 'Qiniu', '', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_video_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_video_3`;
CREATE TABLE `ky_media_video_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp4') NOT NULL DEFAULT 'mp4' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `cover` varchar(200) NOT NULL DEFAULT '' COMMENT '封面',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='视频素材';

-- ----------------------------
--  Table structure for `ky_media_video_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_video_4`;
CREATE TABLE `ky_media_video_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp4') NOT NULL DEFAULT 'mp4' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `cover` varchar(200) NOT NULL DEFAULT '' COMMENT '封面',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='视频素材';

-- ----------------------------
--  Table structure for `ky_media_video_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_video_5`;
CREATE TABLE `ky_media_video_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp4') NOT NULL DEFAULT 'mp4' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '简介',
  `cover` varchar(200) NOT NULL DEFAULT '' COMMENT '封面',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='视频素材';

-- ----------------------------
--  Table structure for `ky_media_voice_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_voice_1`;
CREATE TABLE `ky_media_voice_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp3','wma','wav','amr') NOT NULL DEFAULT 'mp3' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='语音素材';

-- ----------------------------
--  Table structure for `ky_media_voice_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_voice_2`;
CREATE TABLE `ky_media_voice_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp3','wma','wav','amr') NOT NULL DEFAULT 'mp3' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COMMENT='语音素材';

-- ----------------------------
--  Records of `ky_media_voice_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_media_voice_2` VALUES ('1', '1', '3', '纯音乐-抽奖音乐.mp3', 'http://devhhb.images.huihuiba.net/1-5eda049e9f1fc.mp3', '1591346346', '1591349222', '1', 'ZOzBoX0K4goJhq2CjCXt8vWpJY93HrxfTEST_cvTEfI', '1571235', 'mp3', 'Qiniu'), ('2', '1', '3', 'lft.mp3', 'http://devhhb.images.huihuiba.net/1-5eda125e86564.mp3', '1591349862', '1591349921', '1', 'ZOzBoX0K4goJhq2CjCXt8kU2KW1IlNA1ZkYkuDFXN5E', '1092216', 'mp3', 'Qiniu'), ('3', '1', '3', '1.mp3', 'http://devhhb.images.huihuiba.net/1-5eda6c0655458.mp3', '1591372809', '1591372809', '1', '', '535872', 'mp3', 'Qiniu'), ('4', '1', '3', '万宝路进行曲.mp3', 'http://devhhb.images.huihuiba.net/1-5edba6680e992.mp3', '1591453292', '1591453292', '1', '', '587467', 'mp3', 'Qiniu'), ('5', '1', '1', 'lft.mp3', 'http://devhhb.images.huihuiba.net/1-5edefa098fed9.mp3', '1591671313', '1591671313', '1', '', '1092216', 'mp3', 'Qiniu');
COMMIT;

-- ----------------------------
--  Table structure for `ky_media_voice_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_voice_3`;
CREATE TABLE `ky_media_voice_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp3','wma','wav','amr') NOT NULL DEFAULT 'mp3' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='语音素材';

-- ----------------------------
--  Table structure for `ky_media_voice_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_voice_4`;
CREATE TABLE `ky_media_voice_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp3','wma','wav','amr') NOT NULL DEFAULT 'mp3' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='语音素材';

-- ----------------------------
--  Table structure for `ky_media_voice_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_media_voice_5`;
CREATE TABLE `ky_media_voice_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `title` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '文件名称',
  `url` varchar(200) NOT NULL DEFAULT '' COMMENT '文件url',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态',
  `media_id` varchar(100) NOT NULL DEFAULT '' COMMENT '微信素材库中的id',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小（单位B）',
  `ext` enum('mp3','wma','wav','amr') NOT NULL DEFAULT 'mp3' COMMENT '文件格式',
  `location` varchar(50) NOT NULL DEFAULT '' COMMENT '位置Local，Qiniu',
  PRIMARY KEY (`id`),
  KEY `media_id` (`media_id`) USING BTREE,
  KEY `id_uid` (`id`,`uid`) USING BTREE,
  KEY `id_uid_mpid` (`id`,`uid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='语音素材';

-- ----------------------------
--  Table structure for `ky_menu`
-- ----------------------------
DROP TABLE IF EXISTS `ky_menu`;
CREATE TABLE `ky_menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `pid` int(5) unsigned NOT NULL COMMENT '上级ID',
  `title` varchar(50) NOT NULL COMMENT '菜单名称',
  `url` varchar(180) NOT NULL COMMENT 'Url函数地址',
  `sort` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `icon` varchar(180) DEFAULT '' COMMENT '图标',
  `shows` varchar(5) DEFAULT '',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '1菜单 2权限',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=129 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='系统菜单';

-- ----------------------------
--  Records of `ky_menu`
-- ----------------------------
BEGIN;
INSERT INTO `ky_menu` VALUES ('1', '0', '公众号', 'mp/index/index', '1', '&#xe63a;', '', '1', '0', '1596273651', '1'), ('2', '0', '站点', 'system/admin/index', '10', '&#xe620;', '', '1', '0', '1596273651', '1'), ('13', '1', '增强功能', 'null', '0', 'fa fa-briefcase', '', '1', '0', '1596273651', '1'), ('14', '13', '自动回复', 'mp/reply/index', '0', '', '', '1', '0', '1596273651', '1'), ('15', '13', '自定义菜单', 'mp/menu/index', '1', '', '', '1', '0', '1596273651', '1'), ('16', '13', '功能配置', 'mp/setting/index', '10', '', '', '1', '0', '1596273651', '1'), ('17', '13', '二维码/转化链接 ', 'mp/qrcode/index', '4', '', '', '1', '0', '1596273651', '1'), ('18', '13', '素材管理', 'mp/material/index', '5', '', '', '1', '0', '1596273651', '1'), ('19', '1', '粉丝', 'null', '2', 'fa fa-users', '', '1', '0', '1596273651', '1'), ('20', '19', '粉丝管理', 'mp/follow/index', '0', '', '', '1', '0', '1596273651', '1'), ('21', '80', '微信平台', '', '0', 'fa fa-wechat', '', '1', '0', '1596273651', '1'), ('22', '21', '微信公众号', 'system/mp/index', '1', '', '', '1', '0', '1596273651', '1'), ('23', '22', '手动接入', 'system/mp/add', '3', '', '', '1', '0', '1596273651', '2'), ('25', '2', '设置', '', '20', 'fa fa-cogs', '', '1', '0', '1596273651', '1'), ('26', '25', '菜单设置', 'admin/menu/index', '1', '', '', '1', '0', '1596273651', '1'), ('27', '26', '增加菜单', 'admin/menu/add', '2', '', '', '1', '0', '1596273651', '2'), ('28', '22', '编辑公众号', 'system/mp/edit', '5', '', '', '1', '0', '1596273651', '2'), ('29', '22', '管理设置', 'system/mp/info', '3', '', '', '1', '0', '1596273651', '2'), ('30', '17', '增加二维码', 'mp/qrcode/add', '0', '', '', '1', '0', '1596273651', '2'), ('32', '14', '增加关键词', 'mp/reply/add', '0', '', '', '1', '0', '1596273651', '2'), ('41', '14', '特殊消息', 'mp/reply/special', '0', '', '', '1', '0', '1596273651', '2'), ('43', '0', '应用', 'system/store/myapps', '4', '&#xe635;', '', '1', '0', '1596273651', '1'), ('45', '2', '应用管理', 'null', '1', 'fa fa-cubes', '', '1', '0', '1596273651', '1'), ('46', '61', '已过期', 'system/store/overtime', '3', '', null, '1', '0', '1596273651', '1'), ('47', '13', '消息管理', 'mp/msg/index', '1', '', null, '1', '0', '1596273651', '1'), ('48', '47', '回复消息', 'mp/msg/detail', '0', '', null, '1', '0', '1596273651', '2'), ('50', '26', '修改菜单', 'admin/menu/edit', '0', '', null, '1', '0', '1596273651', '2'), ('51', '25', '微信开放平台', 'system/mp/platform', '3', '', null, '1', '0', '1596273651', '1'), ('52', '80', '用户/权限', '', '5', 'fa fa-users', null, '1', '0', '1596273651', '1'), ('53', '67', '注册会员', 'system/admin/index', '0', '', null, '1', '0', '1596273651', '1'), ('54', '53', '更改密码', 'system/admin/updatepwd', '0', '', null, '1', '0', '1596273651', '2'), ('55', '53', '增加成员', 'system/admin/add', '0', '', null, '1', '0', '1596273651', '2'), ('56', '45', '应用管理', 'admin/app/index', '0', '', null, '1', '0', '1596273651', '1'), ('57', '81', '系统公告', 'admin/notice/index', '1', '', null, '1', '0', '1596273651', '1'), ('58', '60', '编辑应用分类', 'admin/addoncate/edit', '3', '', null, '1', '0', '1596273651', '2'), ('59', '60', '新增应用分类', 'admin/addoncate/add', '0', '', null, '1', '0', '1596273651', '2'), ('60', '45', '应用分类', 'admin/addoncate/index', '5', '', null, '1', '0', '1596273651', '1'), ('61', '43', '我的应用', '', '1', 'fa fa-cubes', null, '1', '0', '1596273651', '1'), ('62', '43', '应用市场', '', '4', 'fa fa-cubes', null, '1', '0', '1596273651', '1'), ('63', '62', '应用采购', 'system/store/apps', '0', '', null, '1', '0', '1596273651', '1'), ('64', '61', '正常应用', 'system/store/myapps', '0', '', null, '1', '0', '1596273651', '1'), ('65', '22', '选择接入方式', 'system/mp/choose', '0', '', null, '1', '0', '1596273651', '2'), ('66', '69', '编辑用户组', 'admin/admingroup/edit', '2', '', null, '1', '0', '1596273651', '2'), ('67', '2', '用户管理', 'NULL', '5', 'fa fa-bars', null, '1', '0', '1596273651', '1'), ('68', '1', '数据统计', 'mp/index/index', '0', '', null, '1', '0', '1596273651', '2'), ('69', '67', '用户组', 'admin/admingroup/index', '3', '&#xe68b;', null, '1', '0', '1596273651', '1'), ('70', '69', '新增用户组', 'admin/admingroup/add', '1', '', null, '1', '0', '1596273651', '2'), ('71', '17', '二维码统计', 'mp/qrcode/log', '2', '', null, '1', '0', '1596273651', '2'), ('72', '80', '欢迎回来', 'system/index/index', '0', '', null, '1', '0', '1596273651', '2'), ('73', '74', '应用商店', 'admin/appstore/index', '2', '', null, '1', '0', '1596273651', '1'), ('74', '2', '官方市场', 'NULL', '2', 'fa fa-cart-plus', null, '1', '0', '1597831820', '1'), ('75', '73', '官方市场注册', 'admin/appstore/register', '0', '', null, '1', '0', '1598262621', '2'), ('76', '73', '官方市场登录', 'admin/appstore/login', '0', '', null, '1', '0', '1598262646', '2'), ('77', '56', '编辑应用信息', 'admin/app/edit', '3', '', null, '1', '0', '1596273651', '2'), ('80', '0', '系统', 'system/index/index', '5', '', '', '1', '0', '1596273651', '1'), ('81', '2', '消息管理', '', '15', 'fa fa-bullhorn', '', '1', '0', '1596273651', '1'), ('82', '53', '编辑信息', 'system/admin/edit', '3', '', '', '1', '0', '1596273651', '2'), ('83', '25', '站点设置', 'admin/setting/index', '0', '', '', '1', '1590246581', '1596273651', '1'), ('84', '52', '我的账号', 'system/admin/myinfo', '0', '', '', '1', '1590410830', '1596273651', '1'), ('85', '84', '重置密码', 'system/admin/updatemypwd', '1', '', '', '1', '1590411654', '1596273651', '2'), ('86', '57', '发布公告', 'admin/notice/add', '1', 'fa fa-plus', '', '1', '1590593322', '1596273651', '2'), ('87', '22', '授权接入', 'mp/auth/index', '5', '', '', '1', '1590654308', '1596273651', '2'), ('88', '14', ' 编辑关键词', 'mp/reply/edit', '1', '', '', '1', '1591021404', '1596273651', '2'), ('89', '67', '用户应用', 'admin/adminaddon/index', '5', '', '', '1', '1594806392', '1596273651', '1'), ('90', '89', '开通应用', 'admin/adminaddon/add', '0', '', '', '1', '1594812008', '1596273651', '2'), ('91', '89', '编辑用户应用', 'admin/adminaddon/edit', '2', '', '', '1', '1594812032', '1596273651', '2'), ('92', '57', '编辑公告', 'admin/notice/edit', '5', '', '', '1', '1594896676', '1596273651', '2'), ('93', '80', '系统通知', 'system/notice/index', '0', '', '', '1', '1594900050', '1596273651', '2'), ('94', '80', '切换平台', 'system/store/index', '0', '', '', '1', '1594970326', '1596273651', '2'), ('95', '63', '应用下单', 'system/store/appdetail', '0', '', '', '1', '1595247406', '1596273651', '2'), ('96', '43', '订单支付', 'system/payment/orderaddon', '0', '', '', '1', '1595307609', '1596273651', '2'), ('97', '2', '财务管理', '', '0', 'fa fa-money', '', '1', '1595314612', '1596273651', '1'), ('98', '97', '应用订单', 'admin/orderaddon/index', '0', '', '', '1', '1595314675', '1596273651', '1'), ('99', '98', '修改订单', 'admin/orderaddon/edit', '0', '', '', '1', '1595324991', '1596273651', '2'), ('100', '80', '财务管理', '', '0', 'fa fa-money', '', '1', '1595327151', '1596273651', '1'), ('101', '100', '应用订单', 'system/orderaddon/index', '0', '', '', '1', '1595327214', '1596273651', '1'), ('102', '21', '微信小程序', 'system/mini/index', '3', 'fa fa-weixin', '', '1', '1595416032', '1596273651', '1'), ('103', '102', '添加小程序', 'system/mini/choose', '0', '', '', '1', '1595471638', '1596273651', '2'), ('104', '102', '手动添加小程序', 'system/mini/add', '0', '', '', '1', '1595471732', '1596273651', '2'), ('105', '102', '管理设置', 'system/mini/info', '0', '', '', '1', '1595485512', '1596273651', '2'), ('106', '102', '编辑小程序', 'system/mini/edit', '0', '', '', '1', '1595485527', '1596273651', '2'), ('107', '102', '授权失败', 'mini/auth/fail', '0', '', '', '1', '1595494584', '1596273651', '2'), ('108', '111', '管理', '', '0', 'fa fa-th-list', '', '1', '1595561919', '1596273651', '1'), ('109', '115', '用户管理', 'mini/follow/index', '3', '', '', '1', '1595562103', '1596273651', '1'), ('110', '115', '数据统计与分析', 'mini/index/index', '0', '', '', '1', '1595562456', '1596273651', '1'), ('111', '0', '小程序', 'mini/index/index', '0', '', '', '1', '1595563196', '1596273651', '1'), ('112', '115', '配置', 'mini/setting/index', '10', '', '', '1', '1595571661', '1596273651', '1'), ('113', '45', '小程序模板', 'admin/minitemplate/index', '10', '', '', '1', '1595578963', '1596273651', '1'), ('114', '108', '版本管理', 'mini/template/index', '0', '', '', '1', '1595660483', '1596273651', '1'), ('115', '111', '功能', '', '3', 'fa fa-list', '', '1', '1595660750', '1596273651', '1'), ('116', '56', '设置模版', 'admin/app/settemplate', '0', '', '', '1', '1595681557', '1596273651', '2'), ('117', '114', '新建版本', 'mini/template/choose', '0', '', '', '1', '1595772252', '1596273651', '2'), ('118', '114', '历史版本', 'mini/template/log', '0', '', '', '1', '1595843089', '1596273651', '2'), ('119', '108', '体验者管理', 'mini/tester/index', '3', '', '', '1', '1595900462', '1596273651', '1'), ('120', '119', '新增体验者', 'mini/tester/add', '0', '', '', '1', '1595902322', '1596273651', '2'), ('121', '115', '小程序码', 'mini/qrcode/index', '7', '', '', '0', '1595935890', '1596273651', '1'), ('122', '2', '运营管理', '', '0', 'fa fa-bar-chart', '', '1', '1596271318', '1596273651', '1'), ('123', '122', '友情链接', 'admin/friendlink/index', '0', '', '', '1', '1596271404', '1596273651', '1'), ('124', '123', '新增友链', 'admin/friendlink/add', '0', '', '', '1', '1596273508', '1596273651', '2'), ('125', '123', '编辑友链', 'admin/friendlink/edit', '0', '', '', '1', '1596273522', '1596273651', '2'), ('126', '73', '登录应用市场', 'admin/appstore/detail', '0', '', '', '1', '1598262355', '1598262493', '2'), ('127', '74', '应用升级', 'admin/appstore/upgrade', '3', '', '', '1', '1599096597', '1599096633', '1'), ('128', '18', '新增图文', 'mp/material/newsadd', '0', '', '', '1', '1603893364', '1603893364', '2'), ('132', '108', '类目管理', 'mini/category/index', '5', '', '', '1', '1605521429', '1605521429', '1'), ('133', '132', '新增类目', 'mini/category/add', '0', '', '', '1', '1605521452', '1605521452', '2'), ('134', '108', '扫码关注组件', 'mini/showwxa/index', '7', '', '', '1', '1605584417', '1605584417', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini`;
CREATE TABLE `ky_mini` (
  `id` int(10) unsigned NOT NULL COMMENT 'store中的id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `appid` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '小程序appid',
  `appsecret` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手动接入的需要',
  `refresh_token` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `nick_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方昵称',
  `head_img` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方头像',
  `service_type_info` tinyint(1) NOT NULL DEFAULT '0' COMMENT '授权方公众号类型，0代表订阅号，1代表由历史老帐号升级后的订阅号，2代表服务号',
  `verify_type_info` tinyint(1) NOT NULL DEFAULT '-1' COMMENT '授权方认证类型，-1代表未认证，0代表微信认证',
  `user_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方小程序的原始ID',
  `principal_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '小程序的主体名称',
  `alias` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方公众号所设置的微信号，可能为空',
  `business_info` text COLLATE utf8mb4_unicode_ci COMMENT '用以了解以下功能的开通状况（0代表未开通，1代表已开通）：',
  `qrcode_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '二维码图片url',
  `idc` tinyint(1) NOT NULL DEFAULT '1',
  `signature` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '公众号功能简介',
  `func_info` text COLLATE utf8mb4_unicode_ci COMMENT '授权功能集',
  `mini_program_info` text CHARACTER SET utf8 COMMENT '可根据这个字段判断是否为小程序类型授权',
  `is_auth` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否已授权',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `verify_file` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '校验文件',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `appid` (`appid`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='小程序平台';

-- ----------------------------
--  Records of `ky_mini`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini` VALUES ('10', '1', 'wx85a60c8853fa7d49', '', 'refreshtoken@@@jAaSgPRUJT28mYinBSa2PR6teSV0yegrQbZ1VKDCiPA', '占卜手', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8pTns0QBtSPQFSx4cz9JMXNAPLGCDvgXwwA32VLGXZw9fEPYQwdzia8JFm6JS2ZSVZUge25p7KIZ4/0', '0', '-1', 'gh_811a6be57067', '厦门酷云网络科技有限公司', '', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/c59227b6ffd3648a062c4f98750e2099', '1', '研究易经，免费算命的应用,提供八字算命婚姻,化煞解灾改运,八卦六爻择日预测,企业风水,周公解梦十二生肖运势等命理类服务。', '[{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":67}}]', '{\"network\":{\"RequestDomain\":[\"https:\\/\\/kyphp.fdj.kuryun.cn\"],\"WsRequestDomain\":[\"wss:\\/\\/kyphp.fdj.kuryun.cn\"],\"UploadDomain\":[\"https:\\/\\/kyphp.fdj.kuryun.cn\"],\"DownloadDomain\":[\"https:\\/\\/kyphp.fdj.kuryun.cn\"],\"BizDomain\":[\"https:\\/\\/kyphp.fdj.kuryun.cn\"],\"UDPDomain\":[]},\"categories\":[{\"first\":\"\\u5de5\\u5177\",\"second\":\"\\u4fe1\\u606f\\u67e5\\u8be2\"},{\"first\":\"\\u751f\\u6d3b\\u670d\\u52a1\",\"second\":\"\\u4f11\\u95f2\\u5a31\\u4e50\"}],\"visit_status\":0}', '1', '1', '1595557998', '1596513074', ''), ('11', '1', 'wx7f61eafb0a0f3c77', '', 'refreshtoken@@@vZFzZNff61bi8bxrIpi5l7f-X1nZUf921o9o6_I67Dc', '爱儿本', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8iaVnSsD0V7zVDfkicOL96aMSwibnmnNpIFZHh5gK8ibN7mJdlia7z9AapN1eiajawNeJAkw2QsXTdibBH9/0', '0', '0', 'gh_b778980b9522', '厦门酷云网络科技有限公司', '', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/06190c9e80184308a077292c19ec0bfc', '1', '儿童相册、成长日记、育儿知识分享', '[{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":67}}]', '{\"network\":{\"RequestDomain\":[\"https:\\/\\/weixin.open.huihuiba.net\"],\"WsRequestDomain\":[\"wss:\\/\\/weixin.open.huihuiba.net\"],\"UploadDomain\":[\"https:\\/\\/weixin.open.huihuiba.net\"],\"DownloadDomain\":[\"https:\\/\\/weixin.open.huihuiba.net\"],\"BizDomain\":[\"https:\\/\\/www.huihuiba.net\"],\"UDPDomain\":[]},\"categories\":[{\"first\":\"\\u5de5\\u5177\",\"second\":\"\\u5907\\u5fd8\\u5f55\"},{\"first\":\"\\u5de5\\u5177\",\"second\":\"\\u56fe\\u7247\"},{\"first\":\"\\u5de5\\u5177\",\"second\":\"\\u9884\\u7ea6\\/\\u62a5\\u540d\"},{\"first\":\"\\u751f\\u6d3b\\u670d\\u52a1\",\"second\":\"\\u4f11\\u95f2\\u5a31\\u4e50\"}],\"visit_status\":0}', '1', '1', '1596536174', '1596786901', ''), ('13', '1', 'wx2da22794b5ac0205', '', 'refreshtoken@@@g8oBP_R3rY0NjYjTJzybcZFwb8nN43r6axm0FCooMHI', '博饼引流助手', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ujGYb5ZGnxEGxMic9gj3r485dLVRXOE9blicibiaRIlQxgR6XfOwZG1wcJBt2QcQJyU4icRAjS1JrD3s/0', '0', '0', 'gh_92a1caa1407f', '厦门至高点教育科技有限公司', '', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/e9722148171e9bf1f7e6f1edcd73ede2', '1', '结合闽南地区中秋特色博饼活动，助力商家线上制作活动，形成线上推广裂变，引流到店，帮助商家更好的开展活动', '[{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":67}}]', '{\"network\":{\"RequestDomain\":[],\"WsRequestDomain\":[],\"UploadDomain\":[],\"DownloadDomain\":[],\"BizDomain\":[],\"UDPDomain\":[]},\"categories\":[{\"first\":\"\\u751f\\u6d3b\\u670d\\u52a1\",\"second\":\"\\u4f11\\u95f2\\u5a31\\u4e50\"}],\"visit_status\":0}', '0', '1', '1600056296', '1600225767', ''), ('14', '1', 'wxf52602f160d7bc11', '', 'refreshtoken@@@Xihs6nhWvguQX6_YCi3pDAlyiOUC13UgJGAzjHjacac', '博科举夺状元', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8mp28bPfQdRJa4CNscRTfKhAB4pOhPLthoq31dZdYAp5NicJe2zLl8FiaGJ6I1rB537sFMIBLROOU9/0', '0', '0', 'gh_3f8c455939d3', '厦门至高点教育科技有限公司', '', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/eb748db531ad5912e85aa4a1c906cfa9', '1', '博科举夺状元，根据玩家博饼得到的对应等级，可获得商家设置的礼品，商家可自行设置礼品、商家地址、', '[{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":67}}]', '{\"network\":{\"RequestDomain\":[],\"WsRequestDomain\":[],\"UploadDomain\":[],\"DownloadDomain\":[],\"BizDomain\":[],\"UDPDomain\":[]},\"categories\":[{\"first\":\"\\u751f\\u6d3b\\u670d\\u52a1\",\"second\":\"\\u4f11\\u95f2\\u5a31\\u4e50\"}],\"visit_status\":0}', '0', '1', '1600395705', '1600769289', ''), ('17', '8', 'wx04493d73c6356dbd', '', 'refreshtoken@@@fFLVLQeChyRcnZz9ji9-8ogbf0C5qrIFAOz7p4o0z64', '斯派科售后', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ueOHPOQh5rgyiayvUdyL8dSZxmaJF7J0Q6XuMhokwEFINQYXPnTsVUbptzS2gLoITaZjaBc6K1aF/0', '0', '0', 'gh_73805d236773', '南京斯派科信息科技有限公司', '', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/6f148a99b20a18bc8d219b2d630de86d', '1', '斯派科用户产品故障售后小程序', '[{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":67}}]', '{\"network\":{\"RequestDomain\":[\"https:\\/\\/api.wpweixin.com\",\"https:\\/\\/api.97866.com\"],\"WsRequestDomain\":[],\"UploadDomain\":[\"https:\\/\\/api.wpweixin.com\",\"https:\\/\\/api.97866.com\"],\"DownloadDomain\":[\"https:\\/\\/cdn.wpweixin.com\",\"https:\\/\\/cdn.97866.com\"],\"BizDomain\":[],\"UDPDomain\":[]},\"categories\":[{\"first\":\"\\u5de5\\u5177\",\"second\":\"\\u9884\\u7ea6\\/\\u62a5\\u540d\"}],\"visit_status\":0}', '1', '1', '1601956907', '1601956907', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_addon`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_addon`;
CREATE TABLE `ky_mini_addon` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `addon` varchar(50) NOT NULL DEFAULT '' COMMENT '插件标识',
  `infos` text COMMENT '配置信息',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mpid_addon` (`mini_id`,`addon`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8 COMMENT='小程序-插件关联表';

-- ----------------------------
--  Records of `ky_mini_addon`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_addon` VALUES ('1', '10', 'mini_demo', '{\"title\":\"\\u6d4b\\u8bd5\\u503c\",\"app_key\":\"9eT8gFN2J1efa5e8fadfegas1DDewrqw\"}', '1595932225', '1595947318', '1'), ('8', '10', 'gxtea', '{\"app_key\":\"123456\"}', '1595988929', '1596186644', '1'), ('9', '11', 'gxtea', '{\"kefu_tel\":\"15659827559\"}', '1596536891', '1596695344', '1'), ('10', '11', 'bobing', '{\"kefu_tel\":\"15611111111\"}', '0', '1599796431', '1'), ('11', '13', 'bobing', null, '1600225087', '1600225087', '1'), ('12', '0', 'bbgift', null, '1600768335', '1600768335', '1'), ('13', '10', 'bobing', null, '1601012146', '1601012146', '1'), ('14', '11', 'bbgift', null, '1601256333', '1601256333', '1'), ('15', '17', 'mini_demo', null, '1601957040', '1601957040', '1'), ('16', '1', 'bbgift', null, '1602292128', '1602292128', '1'), ('17', '10', 'bbgift', null, '1602292188', '1602292188', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_follow_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_follow_1`;
CREATE TABLE `ky_mini_follow_1` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `openid` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '城市',
  `language` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别（1：男；2：女，0：未知）',
  `remark` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `unionid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'unionid',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `openid` (`mini_id`,`openid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序微信用户表';

-- ----------------------------
--  Records of `ky_mini_follow_1`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_follow_1` VALUES ('1', '10', '', '888888', '', '', '中国', '', '', 'zh_CN', '1', '', '0', '0', ''), ('2', '10', '', 'oq-q-4ptVVjB5AtO2Lt5zzUcmt2I', '丁昌乾-Jason', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTKSOvNVhIS4YJ3TZ25uN9s95cGXRQA8j49gfUf9hMDFmDk68fUeth7ppbCaficBWtibLxvrpBrvvialg/132', 'China', 'Fujian', 'Xiamen', 'zh_CN', '1', '', '1596160012', '1600762554', ''), ('3', '10', '', 'oq-q-4mmtz8-TEz2E6oHHbzFArSY', '字强不息教育-小鑫老师', 'https://thirdwx.qlogo.cn/mmopen/vi_32/VqC1ROPKSrePXiacY0Picr6BicqmwqfLPImCSY7GPqQ1Wpia2024s6aMial0Op8gjVw6TbOxibiaVgRv4ArO9z3ScK1Pg/132', 'China', 'Fujian', 'Xiamen', 'zh_CN', '1', '', '1600763088', '1600763095', ''), ('4', '10', '', 'oq-q-4pmT6TTDiXMBauFqJRy560o', '菜篮子', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTJiaLic1QoaomRkMeTYrUYcDTeGich4t7qGfeBuqMQImkhB2RF2LcGecJfk8O9x9HD4rDvk8uHx7Bdgg/132', 'China', 'Fujian', 'Sanming', 'zh_CN', '2', '', '1600763101', '1600764440', ''), ('5', '10', '15659827559', 'oq-q-4g2qxBsY-YPlH8SyOD1jxDA', 'momo', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q3auHgzwzM6av3G0SsD17tkYHzhzSysCsPTznf2rcJO7rxhyH9IBRfWyJIVibyjDwpichDfuNAOaThW0zmcea80A/132', 'China', 'Fujian', 'Xiamen', 'zh_CN', '1', '', '1600763115', '1600765903', ''), ('6', '10', '', 'oq-q-4jOb1nY90nEZGdEBWxn_mpA', '妮子°', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTIEvv6LrW98WVFA7SJT4Skxb12ibGyibqTsdc6iaeaEOGzhXZibnkcrWQVGAZicHXAD5TpxE9yXN1Bic8ZQ/132', 'China', 'Fujian', 'Xiamen', 'zh_CN', '2', '', '1600763222', '1600766165', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_follow_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_follow_2`;
CREATE TABLE `ky_mini_follow_2` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `openid` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '城市',
  `language` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别（1：男；2：女，0：未知）',
  `remark` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `unionid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'unionid',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `openid` (`mini_id`,`openid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序微信用户表';

-- ----------------------------
--  Records of `ky_mini_follow_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_follow_2` VALUES ('8', '11', '', 'oUcHy5F7WcJp14Ivfd3wJrOKH6m4', '', '', '中国', '', '', 'zh_CN', '1', '', '1600248013', '1600248013', 'ogJwHwwYFZISQGDXJx15ukXjB04Q'), ('9', '11', '', 'oUcHy5LOrkjDoZtHqGFsiKJlLcQs', '', '', '中国', '', '', 'zh_CN', '1', '', '1600248296', '1600248296', 'ogJwHw3_w0OKwJKDN9FktjKLBLjk');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_follow_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_follow_3`;
CREATE TABLE `ky_mini_follow_3` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `openid` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '城市',
  `language` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别（1：男；2：女，0：未知）',
  `remark` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `unionid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'unionid',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `openid` (`mini_id`,`openid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序微信用户表';

-- ----------------------------
--  Table structure for `ky_mini_follow_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_follow_4`;
CREATE TABLE `ky_mini_follow_4` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `openid` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '城市',
  `language` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别（1：男；2：女，0：未知）',
  `remark` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `unionid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'unionid',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `openid` (`mini_id`,`openid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序微信用户表';

-- ----------------------------
--  Records of `ky_mini_follow_4`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_follow_4` VALUES ('1', '13', '13275008183', 'oPUMA5BQOAxijWx48E3WgIgoB8Rs', '丁昌乾-Jason', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTIwnkic4unZ9GAtyEHjVmFvJEkAPnt8PEE7JrDXOJRibvyh3bp0TqOcscCwSMXxtSbRTlFLSZ4NCKvg/132', '中国', '福建', '厦门', 'zh_CN', '1', '', '1600056333', '1600219677', ''), ('2', '13', '15659827559', 'oPUMA5DLvU43rILjA4n_YRbydTGI', '傅道集', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83eowujUxhialVzOzIibibREbR3iaxAOpmmdicctnFZYRibbCttXH8sZ7FrSlzwKZBw0B9XZ9K1GW5q7iaUAFA/132', '中国', '福建', '厦门', 'zh_CN', '1', '', '1600150179', '1600227443', ''), ('3', '13', '', 'oPUMA5BdbLkz6QN5_gIgfa5oWRAA', '菜篮子', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTKXRd2ib77XGicu4ZR5jiar3tbdTZBxKk2d2hTddOjgjct7SX7cy2TJuImjM16ZEfy40LYUlQGaBX6zQ/132', '中国', '福建', '三明', 'zh_CN', '2', '', '1600165984', '1600166013', ''), ('4', '13', '', 'oPUMA5ITBkurgEiE9QE5Ho53jTR8', '汇汇吧2', 'https://thirdwx.qlogo.cn/mmopen/vi_32/ibLLb9OrOR1lUZfPv8H3vXA9TuLaicibcoDOyIWzIS7I3vA9s0EdgibL6932Me62Y1ySQsZ08EIT8L8B1oY887zp3Q/132', '', '', '', 'zh_CN', '0', '', '1600166010', '1600166055', ''), ('5', '13', '', 'oPUMA5HnIKWXasTXW8NW8-CdGYSs', '字强不息教育-小鑫老师', 'https://thirdwx.qlogo.cn/mmopen/vi_32/KFYascFx9oDnhPwGn4ZGFhwdkfQG3JLlNabCicclTZV2LaKel9NzsFt07SEfXyFuyxkLpDJCDicvsplTJpCADPBw/132', '中国', '福建', '厦门', 'zh_CN', '1', '', '1600166126', '1600166134', ''), ('6', '13', '', 'oPUMA5F99JBZkCtensde9oyDJfuI', '妮子°', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTK2Gr2DKmRiaX6t83SEHAOwYOEODsl5Mpnh4dia8dlP49TcicO0v2gEJ0zjVDFVwbKyraNEJhUOdjOSA/132', '中国', '福建', '厦门', 'zh_CN', '2', '', '1600166541', '1600166642', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_follow_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_follow_5`;
CREATE TABLE `ky_mini_follow_5` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `openid` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '城市',
  `language` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别（1：男；2：女，0：未知）',
  `remark` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `unionid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'unionid',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `openid` (`mini_id`,`openid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序微信用户表';

-- ----------------------------
--  Table structure for `ky_mini_setting`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_setting`;
CREATE TABLE `ky_mini_setting` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID，大于0表示附属公众号的配置',
  `name` varchar(30) NOT NULL DEFAULT '' COMMENT '标识',
  `title` varchar(30) NOT NULL DEFAULT '' COMMENT '名称',
  `value` text COMMENT '配置值',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='小程序配置';

-- ----------------------------
--  Records of `ky_mini_setting`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_setting` VALUES ('1', '10', 'wxpay', '微信支付', '{\"appid\":\"wxe1b7737e3a0c7153\",\"secret\":\"887bb389abbe27e69982576a96a515b3\",\"merchant_id\":\"1449332102\",\"key\":\"Tm44FMGt484Y44TjV34V3VG2ZEG4pf4f\",\"cert_path\":\"\",\"key_path\":\"\",\"rsa_path\":\"\"}', '1591886422', '1596031924'), ('2', '11', 'wxpay', '微信支付', '{\"appid\":\"wx7f61eafb0a0f3c77\",\"secret\":\"2c7fb3e2183d0ba784501ce7c834d5914\",\"merchant_id\":\"14493321021\",\"key\":\"Tm14FMGt484Y44TjV34V3VG2ZEG4pf4f\",\"cert_path\":\"\",\"key_path\":\"\",\"rsa_path\":\"\"}', '1591886422', '1602657770');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_template`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_template`;
CREATE TABLE `ky_mini_template` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `template_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序模板id',
  `user_desc` varchar(200) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '模版描述 开发者自定义字段',
  `user_version` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '版本号',
  `upload_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上传时间',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '类型（1：模板；2：草稿）',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `source_miniprogram_appid` varchar(64) NOT NULL DEFAULT '' COMMENT '来自小程序appid',
  `source_miniprogram` varchar(64) NOT NULL DEFAULT '' COMMENT '来自小程序名称',
  `developer` varchar(50) NOT NULL DEFAULT '' COMMENT '开发者',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=86 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='小程序模板库';

-- ----------------------------
--  Records of `ky_mini_template`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_template` VALUES ('69', '1', '占卜手1.0', 'zbs1.0', '1595589040', '1', '1', '1595589584', '1595589584', 'wx85a60c8853fa7d49', '占卜手', '傅道集'), ('70', '0', '占卜手1.0', 'zbs1.0', '1595576319', '2', '1', '1595590347', '1595590347', 'wx85a60c8853fa7d49', '占卜手', '傅道集'), ('71', '1', '丁昌乾-Jason 在 2020年8月10日上午9点32分 提交上传', '1.0.0', '1597023161', '2', '1', '1597326484', '1597326484', 'wx7f61eafb0a0f3c77', '爱儿本', '丁昌乾-Jason'), ('73', '2', '丁昌乾-Jason 在 2020年9月15日下午2点05分 提交上传', '1.0.0', '1600149988', '1', '1', '1600149993', '1600149993', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('75', '3', '丁昌乾-Jason 在 2020年9月15日晚上6点16分 提交上传', '1.0.1', '1600165078', '1', '1', '1600165082', '1600165082', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('77', '4', '丁昌乾-Jason 在 2020年9月15日晚上6点20分 提交上传', '1.0.2', '1600165299', '1', '1', '1600165303', '1600165303', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('79', '5', '丁昌乾-Jason 在 2020年9月16日上午10点45分 提交上传', '1.0.3', '1600224371', '1', '1', '1600224374', '1600224374', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('80', '8', '丁昌乾-Jason 在 2020年9月16日上午10点53分 提交上传', '1.0.6', '1600224821', '2', '1', '1600224878', '1600224878', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('81', '6', '丁昌乾-Jason 在 2020年9月16日上午10点53分 提交上传', '1.0.6', '1600224888', '1', '1', '1600224893', '1600224893', 'wx2da22794b5ac0205', '博饼引流助手', '丁昌乾-Jason'), ('83', '7', '丁昌乾-Jason 在 2020年9月22日下午4点18分 提交上传', '1.0.0', '1600762869', '1', '1', '1600762873', '1600762873', 'wx85a60c8853fa7d49', '占卜手', '丁昌乾-Jason'), ('84', '11', '丁昌乾-Jason 在 2020年9月22日下午5点41分 提交上传', '1.0.2', '1600767683', '2', '1', '1600768304', '1600768304', 'wx85a60c8853fa7d49', '占卜手', '丁昌乾-Jason'), ('85', '8', '丁昌乾-Jason 在 2020年9月22日下午5点41分 提交上传', '1.0.2', '1600768307', '1', '1', '1600768311', '1600768311', 'wx85a60c8853fa7d49', '占卜手', '丁昌乾-Jason');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_template_log`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_template_log`;
CREATE TABLE `ky_mini_template_log` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小程序id',
  `template_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '模板id',
  `addon` varchar(30) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '应用标识',
  `ext_json` text COMMENT '第三方自定义配置',
  `user_version` varchar(64) NOT NULL DEFAULT '' COMMENT '代码版本号',
  `user_desc` varchar(200) NOT NULL DEFAULT '' COMMENT '代码描述',
  `qr_code` varchar(200) NOT NULL DEFAULT '' COMMENT '体验二维码',
  `extend_info` text COMMENT '扩展信息',
  `audit_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '审核编号',
  `reason` varchar(125) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'status为1时的拒绝原因',
  `verify_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上传审核时间',
  `publish_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，其中0待提交审核 1为审核中， 2为审核成功，3为审核失败，4为已发布, 5:为已撤回，6审核延后',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `is_current` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否当前提交版本',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`) USING BTREE,
  KEY `mini_id_status` (`mini_id`,`status`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='小程序模版记录';

-- ----------------------------
--  Records of `ky_mini_template_log`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_template_log` VALUES ('1', '1', '10', '1', 'mini_demo', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\"}}', '1.0', '第一版', '', null, '0', '', '0', '0', '0', '1595777043', '1595850926', '0'), ('3', '1', '10', '1', 'mini_demo', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\"}}', '2.0', '更新个人中心', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_10_1595863113.png', '[{\"first_id\":\"287\",\"first_class\":\"\\u5de5\\u5177\",\"address\":\"pages\\/index\\/index\",\"tag\":\"\\u5de5\\u5177 \\u5a31\\u4e50\",\"second_id\":\"612\",\"second_class\":\"\\u4fe1\\u606f\\u67e5\\u8be2\"}]', '520692775', '1:小程序内容不符合规则:<br>(1):你好，小程序所实际提供的服务和内容，必须是正式的，不能以Demo形式提交。<br>', '1595918042', '0', '3', '1595850926', '1595995083', '0'), ('4', '1', '10', '1', 'gxtea', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\"}}', '1.0', '2.1', '', null, '0', '', '0', '0', '0', '1595988892', '1600762980', '0'), ('5', '1', '11', '1', 'gxtea', '{\"ext\":{\"appId\":\"wx7f61eafb0a0f3c77\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '1.0', '', null, '0', '', '0', '0', '0', '1596536868', '1596536868', '1'), ('6', '1', '13', '2', 'bobing', '{\"ext\":{\"appId\":\"wx2da22794b5ac0205\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '博饼助手预发版', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_13_1600150165.png', null, '0', '', '0', '0', '0', '1600150088', '1600165131', '0'), ('7', '1', '13', '3', 'bobing', '{\"ext\":{\"appId\":\"wx2da22794b5ac0205\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '更新', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_13_1600165138.png', null, '0', '', '0', '0', '0', '1600165131', '1600165345', '0'), ('8', '1', '13', '4', 'bobing', '{\"ext\":{\"appId\":\"wx2da22794b5ac0205\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '更新1.0.2', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_13_1600165350.png', null, '0', '', '0', '0', '0', '1600165345', '1600224404', '0'), ('9', '1', '13', '5', 'bobing', '{\"ext\":{\"appId\":\"wx2da22794b5ac0205\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '新增客服联系', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_13_1600224411.png', null, '0', '', '0', '0', '0', '1600224404', '1600224927', '0'), ('10', '1', '13', '6', 'bobing', '{\"ext\":{\"appId\":\"wx2da22794b5ac0205\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '优化', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_13_1600224931.png', null, '0', '', '0', '0', '0', '1600224927', '1600224931', '1'), ('11', '1', '10', '7', 'bbgift', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/gxtea\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '1.0', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_10_1600762985.png', null, '0', '', '0', '0', '0', '1600762980', '1600765603', '0'), ('12', '1', '10', '7', 'bbgift', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\",\"env\":{\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', 'fix a bug', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_10_1600765607.png', null, '0', '', '0', '0', '0', '1600765603', '1600765876', '0'), ('13', '1', '10', '7', 'bbgift', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/bbgift\\/api\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '调整', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_10_1600765881.png', null, '0', '', '0', '0', '0', '1600765876', '1600768380', '0'), ('14', '1', '10', '8', 'bbgift', '{\"ext\":{\"appId\":\"wx85a60c8853fa7d49\",\"env\":{\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"1.0\"}}}', '1.0', '优化页面', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_10_1600768390.png', null, '0', '', '0', '0', '0', '1600768380', '1600768390', '1'), ('15', '8', '17', '1', 'mini_demo', '{\"ext\":{\"appId\":\"wx04493d73c6356dbd\",\"env\":{\"restUrl\":\"https:\\/\\/kyphp.fdj.kuryun.cn\\/app\\/mini_demo\\/\",\"qiniuDomain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"appKey\":\"123456\",\"mapKey\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\",\"version\":\"2.0\"}}}', '2.0', '啊', 'http://devhhb.images.huihuiba.net/mini_qrcode_test_17_1601957002.png', null, '0', '', '0', '0', '0', '1601956994', '1601957002', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mini_tester`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mini_tester`;
CREATE TABLE `ky_mini_tester` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `mini_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '授权小程序id',
  `wechat_id` varchar(60) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '微信号',
  `remark` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `mini_id` (`mini_id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='小程序体验者';

-- ----------------------------
--  Records of `ky_mini_tester`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mini_tester` VALUES ('1', '10', 'zgdian2', '至高点测试2', '1', '1595902513', '1595903725'), ('2', '11', 'djf951212', '111', '0', '1597994819', '1597994902'), ('3', '13', 'ZYN-5-2-5-', '妮子', '1', '1600165968', '1600165968'), ('4', '13', 'zgdian2', '至高点测试2', '1', '1600165981', '1600165981'), ('5', '13', 'wxid_tnefh3mvcwe722', '小鑫', '1', '1600166114', '1600166114'), ('6', '13', 'weiwei562608', '萍子', '1', '1600167203', '1600167203'), ('7', '13', 'wxid_zk363dtri1wv22', '余金华', '1', '1600167221', '1600167221');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp`;
CREATE TABLE `ky_mp` (
  `id` int(10) unsigned NOT NULL COMMENT 'store中的id',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员ID',
  `appid` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '公众号appid',
  `appsecret` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'appsecret,手动接入需要',
  `refresh_token` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '包含手动接入的token和授权的refresh_token',
  `nick_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方昵称',
  `head_img` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方头像',
  `service_type_info` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '授权方公众号类型，0代表订阅号，1代表由历史老帐号升级后的订阅号，2代表服务号',
  `verify_type_info` tinyint(1) NOT NULL DEFAULT '-1' COMMENT '授权方认证类型，-1代表未认证，0代表微信认证，1代表新浪微博认证，2代表腾讯微博认证，3代表已资质认证通过但还未通过名称认证，4代表已资质认证通过、还未通过名称认证，但通过了新浪微博认证，5代表已资质认证通过、还未通过名称认证，但通过了腾讯微博认证',
  `user_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方公众号的原始ID',
  `principal_name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '公众号的主体名称',
  `alias` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '授权方公众号所设置的微信号，可能为空',
  `business_info` text COLLATE utf8mb4_unicode_ci COMMENT '用以了解以下功能的开通状况（0代表未开通，1代表已开通）：',
  `qrcode_url` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '二维码图片url',
  `idc` tinyint(1) NOT NULL DEFAULT '1',
  `signature` varchar(300) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '公众号功能简介',
  `func_info` text COLLATE utf8mb4_unicode_ci COMMENT '授权功能集',
  `is_auth` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否已授权',
  `create_time` int(10) NOT NULL DEFAULT '0',
  `update_time` int(10) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `remark` text COLLATE utf8mb4_unicode_ci,
  `encodingaeskey` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '接口加密key，手动接入的公众号需要',
  `verify_file` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '校验文件',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `appid` (`appid`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT;

-- ----------------------------
--  Records of `ky_mp`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp` VALUES ('1', '1', 'wx10ddcef6537dd78c', '26a4eb806b640ef07b08777c08fde731', 'MIL4umO8pWIkfNhvNx01uBDupfUqS7J4', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', '2', '0', 'gh_96bd876da264', '', 'test1', null, 'http://devhhb.images.huihuiba.net/1-5ece7c72a8f5f.png', '1', '', null, '1', '1590324684', '1595470144', '1', null, '', '/1198741614.txt'), ('2', '2', 'dsaas', 'asdfasdf', 'hwrPcgezvPSAuFRCMnlAVocARzOIbbWE', 'sssss', '', '0', '-1', 'asdafasdf', '', '', null, '', '1', '', null, '1', '1590592849', '1590593695', '1', null, '', ''), ('3', '1', 'wx43df34a2cc394eb8', '', 'refreshtoken@@@8x14HncR97pzmXXRg1h_vaZjyY6AdsHmIJCRGCMIlyA', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', '1', '-1', 'gh_d17efaa86a49', '个人', 'fdaoji', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://mmbiz.qpic.cn/mmbiz_jpg/1cpRfYg4VdqSjtX9QpFL7z2qIF2ibib2GuEWeFh5SLY04Vf7YicNoAzQoTghBPFw9y3fx4na2h8VtIL1VF6kZgN5Q/0', '1', '记录学习笔记，探讨科技前沿，崇尚开放、分享、创新。', '[{\"funcscope_category\":{\"id\":1}},{\"funcscope_category\":{\"id\":15}},{\"funcscope_category\":{\"id\":4}},{\"funcscope_category\":{\"id\":7}},{\"funcscope_category\":{\"id\":2}},{\"funcscope_category\":{\"id\":3}},{\"funcscope_category\":{\"id\":11}},{\"funcscope_category\":{\"id\":6}},{\"funcscope_category\":{\"id\":5}},{\"funcscope_category\":{\"id\":8}},{\"funcscope_category\":{\"id\":13}},{\"funcscope_category\":{\"id\":9}},{\"funcscope_category\":{\"id\":10}},{\"funcscope_category\":{\"id\":12}},{\"funcscope_category\":{\"id\":22}},{\"funcscope_category\":{\"id\":23}},{\"funcscope_category\":{\"id\":26}},{\"funcscope_category\":{\"id\":27},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":33},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":34}},{\"funcscope_category\":{\"id\":35}},{\"funcscope_category\":{\"id\":44},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":46}},{\"funcscope_category\":{\"id\":47}},{\"funcscope_category\":{\"id\":54}},{\"funcscope_category\":{\"id\":66}}]', '1', '1590660532', '1590664040', '1', null, '', ''), ('12', '0', 'wx570bc396a51b8ff8', '', 'refreshtoken@@@55456ocGjGsS-WpbpdbK7AkX3vI5W_wmDAjP69Wbmik', 'mpqinyetest001', 'http://wx.qlogo.cn/mmopen/jiavAo66h5f3iaTWhwbn2cElUQwg1kpUxHsNPeuib4gZXdCSWXia00S2fP7WoX0lBM60ypW34kmXeAM5tibkKwWYe6FyoKFMscXxO/0', '2', '-1', 'gh_3c884a361561', '3072995023', 'mpqinyetest001', '{\"open_pay\":0,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/48f65b0fd2f002d7d32b7eb4e2833c82', '3', '此账号用于授权组件入场检测用途', '[{\"funcscope_category\":{\"id\":1}},{\"funcscope_category\":{\"id\":15}},{\"funcscope_category\":{\"id\":4}},{\"funcscope_category\":{\"id\":7}},{\"funcscope_category\":{\"id\":2}},{\"funcscope_category\":{\"id\":3}},{\"funcscope_category\":{\"id\":11}},{\"funcscope_category\":{\"id\":6}},{\"funcscope_category\":{\"id\":5}},{\"funcscope_category\":{\"id\":8}},{\"funcscope_category\":{\"id\":13}},{\"funcscope_category\":{\"id\":9}},{\"funcscope_category\":{\"id\":10}},{\"funcscope_category\":{\"id\":12}},{\"funcscope_category\":{\"id\":17}},{\"funcscope_category\":{\"id\":18},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":19}},{\"funcscope_category\":{\"id\":22}},{\"funcscope_category\":{\"id\":23}},{\"funcscope_category\":{\"id\":24},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":25},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":26}},{\"funcscope_category\":{\"id\":27},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":30},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":31},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":33},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":34}},{\"funcscope_category\":{\"id\":35}},{\"funcscope_category\":{\"id\":36}},{\"funcscope_category\":{\"id\":37}},{\"funcscope_category\":{\"id\":40}},{\"funcscope_category\":{\"id\":41},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":44},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":45}},{\"funcscope_category\":{\"id\":46}},{\"funcscope_category\":{\"id\":47}},{\"funcscope_category\":{\"id\":48}},{\"funcscope_category\":{\"id\":49},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":51}},{\"funcscope_category\":{\"id\":54}},{\"funcscope_category\":{\"id\":57}},{\"funcscope_category\":{\"id\":65}},{\"funcscope_category\":{\"id\":66}},{\"funcscope_category\":{\"id\":67}}]', '0', '1597328829', '1597331689', '1', null, '', ''), ('15', '4', 'asdsad', 'asdsad', 'asdsad', 'asdsad', '', '2', '0', 'asdsad', '', '', null, '', '1', '', null, '1', '1601444306', '1603082604', '1', null, '', ''), ('16', '8', 'wx791db88ac9dcc7b9', '', 'refreshtoken@@@I3gXu-rgMo3FxXoyzwMGKWVDOP-7cA46IeQFaoRPgCM', 'spacle', 'http://wx.qlogo.cn/mmopen/TTQibyKjrickwllHbobTML9oKf4GVMbmUVSIbEMCJQNmgyl2nibtexicXIt6raom8F4ShuBSUnsfAxpezxLPwptYTl82Jso1vtfh/0', '2', '0', 'gh_20223cbc18db', '南京斯派科信息科技有限公司', 'baijiaoxi', '{\"open_pay\":1,\"open_shake\":0,\"open_scan\":0,\"open_card\":0,\"open_store\":0}', 'http://devhhb.images.huihuiba.net/41001f95b4595ba5629d33236cfde75f', '1', '斯派科，工业数字营销及管理解决方案供应商', '[{\"funcscope_category\":{\"id\":1}},{\"funcscope_category\":{\"id\":15}},{\"funcscope_category\":{\"id\":4}},{\"funcscope_category\":{\"id\":7}},{\"funcscope_category\":{\"id\":2}},{\"funcscope_category\":{\"id\":3}},{\"funcscope_category\":{\"id\":11}},{\"funcscope_category\":{\"id\":6}},{\"funcscope_category\":{\"id\":5}},{\"funcscope_category\":{\"id\":8}},{\"funcscope_category\":{\"id\":13}},{\"funcscope_category\":{\"id\":9}},{\"funcscope_category\":{\"id\":10}},{\"funcscope_category\":{\"id\":12}},{\"funcscope_category\":{\"id\":22}},{\"funcscope_category\":{\"id\":23}},{\"funcscope_category\":{\"id\":26}},{\"funcscope_category\":{\"id\":27},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":33},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":35}},{\"funcscope_category\":{\"id\":44},\"confirm_info\":{\"need_confirm\":0,\"already_confirm\":0,\"can_confirm\":0}},{\"funcscope_category\":{\"id\":46}},{\"funcscope_category\":{\"id\":47}},{\"funcscope_category\":{\"id\":54}},{\"funcscope_category\":{\"id\":66}}]', '1', '1601952158', '1601952158', '1', null, '', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_addon`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_addon`;
CREATE TABLE `ky_mp_addon` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `addon` varchar(50) NOT NULL DEFAULT '' COMMENT '插件标识',
  `infos` text COMMENT '配置信息',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mpid_addon` (`mpid`,`addon`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='公众号-插件关联表';

-- ----------------------------
--  Records of `ky_mp_addon`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_addon` VALUES ('6', '1', 'demo', '{\"title\":\"\\u8bb0\\u4e8b\\u672c\",\"wx_auth_open\":\"1\"}', '1594817610', '1594817649', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_follow_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_follow_1`;
CREATE TABLE `ky_mp_follow_1` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `mpid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '微信号',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `subscribe` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关注',
  `headimgurl` varchar(300) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '城市',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(100) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `groupid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '粉丝分组id',
  `subscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的关注时间',
  `unsubscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的取消关注时间',
  `unionid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '开放平台唯一ID，用于不同应用间的打通',
  `tagid_list` varchar(255) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '用户被打上的标签ID列表',
  `language` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `subscribe_scene` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '',
  `qr_scene` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景（开发者自定义）',
  `qr_scene_str` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景描述（开发者自定义）',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='微信用户表';

-- ----------------------------
--  Records of `ky_mp_follow_1`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_follow_1` VALUES ('1', '15', 'otosB6AenCK-s9GA9C8ysbDAh9nE', 'Mr.Fan', '1', 'http://thirdwx.qlogo.cn/mmopen/8gDj7MYQlccEoDBdNzVo1MYagcfpGs0icpn1tiaBRCwyf9eiceOzARicHy3Z3cLB3sNXNXhcicFw1r5FokAy0fdXg32BpENiawZLibW/132', '美国', '纽约', '纽约市', '1601447211', '1601447211', '1', '', '0', '1601447210', '0', '', '[]', 'zh_CN', 'ADD_SCENE_QR_CODE', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_follow_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_follow_2`;
CREATE TABLE `ky_mp_follow_2` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mpid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '微信号',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `subscribe` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关注',
  `headimgurl` varchar(300) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '城市',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(100) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `groupid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '粉丝分组id',
  `subscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的关注时间',
  `unsubscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的取消关注时间',
  `unionid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '开放平台唯一ID，用于不同应用间的打通',
  `tagid_list` varchar(255) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '用户被打上的标签ID列表',
  `language` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `subscribe_scene` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '',
  `qr_scene` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景（开发者自定义）',
  `qr_scene_str` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景描述（开发者自定义）',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='微信用户表';

-- ----------------------------
--  Records of `ky_mp_follow_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_follow_2` VALUES ('1', '1', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', '傅道集', '1', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', '中国', '福建', '厦门', '1590849022', '1595919922', '1', '', '0', '1595919921', '1595919848', '', '[]', 'zh_CN', 'ADD_SCENE_QR_CODE', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_follow_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_follow_3`;
CREATE TABLE `ky_mp_follow_3` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mpid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '微信号',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `subscribe` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关注',
  `headimgurl` varchar(300) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '城市',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(100) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `groupid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '粉丝分组id',
  `subscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的关注时间',
  `unsubscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的取消关注时间',
  `unionid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '开放平台唯一ID，用于不同应用间的打通',
  `tagid_list` varchar(255) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '用户被打上的标签ID列表',
  `language` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `subscribe_scene` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '',
  `qr_scene` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景（开发者自定义）',
  `qr_scene_str` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景描述（开发者自定义）',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='微信用户表';

-- ----------------------------
--  Table structure for `ky_mp_follow_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_follow_4`;
CREATE TABLE `ky_mp_follow_4` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mpid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '微信号',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `subscribe` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关注',
  `headimgurl` varchar(300) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '城市',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(100) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `groupid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '粉丝分组id',
  `subscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的关注时间',
  `unsubscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的取消关注时间',
  `unionid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '开放平台唯一ID，用于不同应用间的打通',
  `tagid_list` varchar(255) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '用户被打上的标签ID列表',
  `language` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `subscribe_scene` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '',
  `qr_scene` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景（开发者自定义）',
  `qr_scene_str` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景描述（开发者自定义）',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='微信用户表';

-- ----------------------------
--  Records of `ky_mp_follow_4`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_follow_4` VALUES ('1', '3', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', '', '1', '', '中国', '', '', '1590850559', '1590850780', '1', '', '0', '1590850780', '1590850771', '', '', 'zh_CN', '', '', ''), ('2', '3', 'oVTwBwQGvRd15VxgfIWfMTMjAOAE', '', '0', '', '中国', '', '', '1594891657', '1596293314', '1', '', '0', '1594891657', '1596293314', '', '', 'zh_CN', '', '', ''), ('3', '3', 'oVTwBwaByhDLgVaR1BBWfuHLUlHo', '', '1', '', '中国', '', '', '1594965138', '1594965138', '1', '', '0', '1594965138', '0', '', '', 'zh_CN', '', '', '');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_follow_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_follow_5`;
CREATE TABLE `ky_mp_follow_5` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `mpid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '微信号',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `subscribe` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关注',
  `headimgurl` varchar(300) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '头像',
  `country` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '中国' COMMENT '国家',
  `province` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '省份',
  `city` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '城市',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(100) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '备注',
  `groupid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '粉丝分组id',
  `subscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的关注时间',
  `unsubscribe_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '微信官方传来的取消关注时间',
  `unionid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '开放平台唯一ID，用于不同应用间的打通',
  `tagid_list` varchar(255) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '用户被打上的标签ID列表',
  `language` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT 'zh_CN' COMMENT '语言',
  `subscribe_scene` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '',
  `qr_scene` varchar(30) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景（开发者自定义）',
  `qr_scene_str` varchar(50) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '二维码扫码场景描述（开发者自定义）',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=COMPACT COMMENT='微信用户表';

-- ----------------------------
--  Table structure for `ky_mp_menu`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_menu`;
CREATE TABLE `ky_mp_menu` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mpid` int(10) NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '父级菜单ID',
  `type` enum('click','view','miniprogram','scancode_push','scancode_waitmsg','pic_sysphoto','pic_photo_or_album','pic_weixin','location_select','media_id','view_limited') CHARACTER SET utf8mb4 NOT NULL DEFAULT 'click' COMMENT '类型',
  `name` varchar(10) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '菜单名称',
  `key` varchar(20) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '事件类型对应的key值',
  `url` varchar(200) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '跳转链接和小程序时必填',
  `appid` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '小程序必填',
  `pagepath` varchar(64) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '小程序必填',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否启用',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  `sort` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排序，数字越小越靠前',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='自定义菜单';

-- ----------------------------
--  Records of `ky_mp_menu`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_menu` VALUES ('9', '15', '0', 'click', '主菜单一', '文本', 'https://www.baidu.com/', '', '', '1', '1601446462', '1601447254', '0'), ('10', '15', '0', 'view', '主菜单二', '', 'https://www.baidu.com/', '', '', '1', '1601446462', '1601447254', '1'), ('15', '16', '0', 'click', '官网', '', '', '', '', '1', '1601952176', '1601952176', '0'), ('16', '16', '0', 'miniprogram', '资料', '', 'http://website.shengchanren.com', 'wx83f30c0e6008b46f', 'pages/index/index', '1', '1601952176', '1601952176', '1'), ('17', '16', '0', 'miniprogram', '菜单名称', '', 'http://baidu.com', 'wxf1031767ecd42115', '/pages/channel/channel?rid=71&type=2&scene=402', '1', '1601952176', '1601952176', '2'), ('18', '1', '0', 'click', '汇汇吧', '', '', '', '', '1', '1602118659', '1602118659', '0'), ('19', '1', '0', 'view', '货好多', '', 'http://hmall.huihuiba.net', '', '', '1', '1602118659', '1602118659', '1'), ('20', '1', '0', 'view', '百度', '', 'http://www.baidu.com', '', '', '1', '1602118659', '1602118659', '2');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_msg_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_msg_1`;
CREATE TABLE `ky_mp_msg_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增 ID',
  `mpid` int(11) NOT NULL DEFAULT '0' COMMENT '公众号标识',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一条消息 ID',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `openid` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'openid',
  `type` varchar(32) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '消息类型',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '消息内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未回复，1已回复',
  `is_reply` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1表示公众号回复',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `openid_mpid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='公众号粉丝消息';

-- ----------------------------
--  Table structure for `ky_mp_msg_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_msg_2`;
CREATE TABLE `ky_mp_msg_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增 ID',
  `mpid` int(11) NOT NULL DEFAULT '0' COMMENT '公众号标识',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一条消息 ID',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `openid` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'openid',
  `type` varchar(32) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '消息类型',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '消息内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未回复，1已回复',
  `is_reply` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1表示公众号回复',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `openid_mpid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=140 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Records of `ky_mp_msg_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_msg_2` VALUES ('28', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591672630\",\"MsgType\":\"text\",\"Content\":\"视频\",\"MsgId\":\"22787272947141282\"}', '0', '0', '1591672630'), ('29', '1', '28', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'video', '{\"MediaId\":\"JW8XS34h_ISSqHFm_g1WsSLp9WAdOkH-Kpe9m-UCR2g\",\"Title\":\"shoes.mp4\",\"Description\":\"\"}', '0', '1', '1591672630'), ('30', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591673166\",\"MsgType\":\"text\",\"Content\":\"好\",\"MsgId\":\"22787283152509117\"}', '0', '0', '1591673166'), ('31', '1', '30', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"暂时无法回答你哦\"}', '0', '1', '1591673166'), ('34', '1', '33', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"这是一段对语音的回复\"}', '0', '1', '1591673507'), ('35', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591673687\",\"MsgType\":\"image\",\"PicUrl\":\"http:\\/\\/mmbiz.qpic.cn\\/mmbiz_jpg\\/KVW98mspEY3bCOcNDSnJFZib5RATl0Ac7ibc8qhp1Xkf2L2PxIQCaseOf1OfseJLOS8XW0cYLflAtGic6DdjBDeGQ\\/0\",\"MsgId\":\"22787287571393185\",\"MediaId\":\"kSLBrDoUSEl1sBfwUKj7gu341eOK13V7R700nuV9OrwSkPmbIAMc_FLc0txtmF5E\"}', '0', '0', '1591673687'), ('36', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591674513\",\"MsgType\":\"image\",\"PicUrl\":\"http://mmbiz.qpic.cn/mmbiz_jpg/KVW98mspEY3bCOcNDSnJFZib5RATl0Ac7V0Bx0CPM0SOAtLuyIsXCZibSWFuCr0CWuw7PeyuSUzliagn7uibSA1T5A/0\",\"MsgId\":\"22787300781808213\",\"MediaId\":\"1UA02fj9f-8_bBniro_rftM-fma5CrMafp4MEdQlK65AFZRhFmHuZZLdr7_bNCih\",\"url\":\"http://devhhb.images.huihuiba.net/87bf103a7e3df0b0a58b192389591f97\"}', '0', '0', '1591674513'), ('37', '1', '36', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"MediaId\":\"JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4\"}', '0', '1', '1591674513'), ('38', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591674976\",\"MsgType\":\"text\",\"Content\":\"测试\",\"MsgId\":\"22787305683134211\"}', '0', '0', '1591674977'), ('39', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591675001\",\"MsgType\":\"text\",\"Content\":\"测试\",\"MsgId\":\"22787306999742339\"}', '0', '0', '1591675001'), ('40', '1', '39', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"暂时无法回答你哦\"}', '0', '1', '1591675001'), ('41', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591675007\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22787307809091099\"}', '0', '0', '1591675007'), ('42', '1', '41', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"暂时无法回答你哦\"}', '0', '1', '1591675007'), ('43', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591675030\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22787309589990687\"}', '0', '0', '1591675030'), ('44', '1', '43', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1591675030'), ('45', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591675152\",\"MsgType\":\"image\",\"PicUrl\":\"http://mmbiz.qpic.cn/mmbiz_jpg/KVW98mspEY3bCOcNDSnJFZib5RATl0Ac7x1fGmZE9Vl1xYXAtVbGOXu62Hc8rV2icXxW749jKIRaE1z9tRjicqrxg/0\",\"MsgId\":\"22787305790293866\",\"MediaId\":\"MeeyR0RJYT5408e_JcYWrfUU91ecjmE6rTG6Da98k7Da7njNIZIQgXrHToSY7PQP\",\"url\":\"http://devhhb.images.huihuiba.net/331eb777a9e080054c119a7847f79a5a\"}', '0', '0', '1591675153'), ('46', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591675184\",\"MsgType\":\"image\",\"PicUrl\":\"http://mmbiz.qpic.cn/mmbiz_jpg/KVW98mspEY3bCOcNDSnJFZib5RATl0Ac7x1fGmZE9Vl1xYXAtVbGOXu62Hc8rV2icXxW749jKIRaE1z9tRjicqrxg/0\",\"MsgId\":\"22787308211611839\",\"MediaId\":\"BObmk8Kx4v0HOo_QSMBUBvLsjFjj5S3-5wKHxVLvrirb1rZndFZdMlCiAvQPNM6d\",\"url\":\"http://devhhb.images.huihuiba.net/caa16ead5520ca1a00e5cad2afa1e0c0\"}', '0', '0', '1591675184'), ('47', '1', '46', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"MediaId\":\"JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4\"}', '0', '1', '1591675184'), ('48', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591698010\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22787639407063122\"}', '0', '0', '1591698010'), ('49', '1', '48', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"暂时无法回答你哦\"}', '0', '1', '1591698010'), ('50', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591715061\",\"MsgType\":\"text\",\"Content\":\"我\",\"MsgId\":\"22787879855298707\"}', '0', '0', '1591715061'), ('51', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591715079\",\"MsgType\":\"text\",\"Content\":\"乾\",\"MsgId\":\"22787877843727722\"}', '0', '0', '1591715079'), ('52', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591715082\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22787879160232801\"}', '1', '0', '1591715082'), ('53', '1', '52', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1591715082'), ('54', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591715139\",\"MsgType\":\"text\",\"Content\":\"啊\",\"MsgId\":\"22787882122084167\"}', '0', '0', '1591715139'), ('55', '1', '0', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'voice', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591715374\",\"MsgType\":\"voice\",\"MediaId\":\"e77lzf4ynL60IzUjBIySjAC_1e46NTfE0eB5PC7MWn-9uNriEKrMdKjkAG_byOMx\",\"Format\":\"amr\",\"MsgId\":\"6836365475870408704\",\"Recognition\":\"\\u6d4b\\u8bd5\\u6d4b\\u8bd5\\u3002\",\"url\":\"http://devhhb.images.huihuiba.net/448677370109cded6e8842dfd52961d3\"}', '1', '0', '1591715374'), ('56', '1', '55', '', '', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"这是一段对语音的回复\"}', '0', '1', '1591715374'), ('57', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1591783870\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22788865409188681\"}', '1', '0', '1591783870'), ('58', '1', '57', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1591783870'), ('59', '1', '57', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"这是一段对语音的回复\"}', '0', '1', '1591845366'), ('60', '1', '57', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'image', '{\"MediaId\":\"JW8XS34h_ISSqHFm_g1WsSkOYPPrDPD6w8LZtha8VF4\",\"url\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5ed91d9b11916.jpg\"}', '0', '1', '1591845821'), ('61', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'location', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592468598\",\"MsgType\":\"location\",\"Location_X\":\"24.531233\",\"Location_Y\":\"118.186280\",\"Scale\":\"15\",\"Label\":\"福建省厦门市湖里区泗水道669号厦门国贸商务中心\",\"MsgId\":\"22798666509597003\"}', '1', '0', '1592468599'), ('62', '1', '61', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1592468599'), ('63', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'location', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592895890\",\"MsgType\":\"location\",\"Location_X\":\"24.531142\",\"Location_Y\":\"118.186346\",\"Scale\":\"15\",\"Label\":\"福建省厦门市湖里区泗水道669号厦门国贸商务中心\",\"MsgId\":\"22804783775556604\"}', '1', '0', '1592895890'), ('64', '1', '63', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1592895890'), ('65', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592896108\",\"MsgType\":\"text\",\"Content\":\"http:\\/\\/kyphp.fdj.kuryun.cn\\/mp\\/reply\\/special.html\",\"MsgId\":\"22804790110140758\"}', '0', '0', '1592896108'), ('66', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592896129\",\"MsgType\":\"text\",\"Content\":\"http:\\/\\/kyphp.fdj.kuryun.cn\\/mp\\/reply\\/special.html\",\"MsgId\":\"22804789634516761\"}', '0', '0', '1592896129'), ('67', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592896334\",\"MsgType\":\"text\",\"Content\":\"http:\\/\\/kyphp.fdj.kuryun.cn\\/mp\\/reply\\/special.html\",\"MsgId\":\"22804791194747199\"}', '0', '0', '1592896334'), ('68', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592896372\",\"MsgType\":\"text\",\"Content\":\"http:\\/\\/kyphp.fdj.kuryun.cn\\/mp\\/reply\\/special.html\",\"MsgId\":\"22804792036977892\"}', '0', '0', '1592896372'), ('69', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1592896389\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22804792098652331\"}', '1', '0', '1592896390'), ('70', '1', '69', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1592896390'), ('71', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1593417052\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22812250521754089\"}', '1', '0', '1593417052'), ('72', '1', '71', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1593417052'), ('73', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104123\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822086067560726\"}', '0', '0', '1594104123'), ('74', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104329\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822086620961426\"}', '0', '0', '1594104329'), ('75', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104666\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822093088621078\"}', '0', '0', '1594104667'), ('76', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104669\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22822091763879004\"}', '0', '0', '1594104669'), ('77', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104735\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22822090562249432\"}', '0', '0', '1594104735'), ('78', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104752\",\"MsgType\":\"text\",\"Content\":\"2\",\"MsgId\":\"22822091084661516\"}', '0', '0', '1594104752'), ('79', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104766\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822091702679452\"}', '0', '0', '1594104766'), ('80', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594104786\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822093741042382\"}', '0', '0', '1594104786'), ('81', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594105821\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22822109345123521\"}', '0', '0', '1594105821'), ('82', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594105829\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822109465144712\"}', '0', '0', '1594105829'), ('83', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594105862\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822111239130568\"}', '0', '0', '1594105862'), ('84', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594105891\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822107833727545\"}', '0', '0', '1594105891'), ('85', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594105925\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822110228153695\"}', '0', '0', '1594105925'), ('86', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106016\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822109304447292\"}', '0', '0', '1594106017'), ('87', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106057\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822109469026017\"}', '0', '0', '1594106058'), ('88', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106167\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822115572477619\"}', '0', '0', '1594106168'), ('89', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106201\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822115766443138\"}', '0', '0', '1594106201'), ('90', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106230\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22822114774034176\"}', '0', '0', '1594106230'), ('91', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106376\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822112494155963\"}', '0', '0', '1594106376'), ('92', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106562\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822118229671998\"}', '0', '0', '1594106563'), ('93', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106592\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822119604813518\"}', '0', '0', '1594106592'), ('94', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594106694\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822117453655939\"}', '0', '0', '1594106695'), ('95', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594107927\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822139660674143\"}', '0', '0', '1594107927'), ('96', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594107993\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822140164950643\"}', '0', '0', '1594107993'), ('97', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108024\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822141799884321\"}', '0', '0', '1594108025'), ('98', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108058\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822139999443418\"}', '0', '0', '1594108058'), ('99', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108087\",\"MsgType\":\"text\",\"Content\":\"demi\",\"MsgId\":\"22822140303552005\"}', '0', '0', '1594108087'), ('100', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108089\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822141923914645\"}', '0', '0', '1594108089'), ('101', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108140\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822140639464906\"}', '0', '0', '1594108140'), ('102', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108901\",\"MsgType\":\"text\",\"Content\":\"demo\",\"MsgId\":\"22822152108643829\"}', '0', '0', '1594108901'), ('103', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1594108908\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22822151220841328\"}', '1', '0', '1594108908'), ('104', '1', '103', '测试号', 'http://we7.fdj.oudewa.cn/attachment/headimg_1.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1594108908'), ('105', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1595556045\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22842873031241924\"}', '1', '0', '1595556046'), ('106', '1', '105', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1595556046'), ('107', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1595919945\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22848083533982898\"}', '1', '0', '1595919945'), ('108', '1', '107', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1595919945'), ('109', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1595991286\",\"MsgType\":\"text\",\"Content\":\"demo1\",\"MsgId\":\"22849098015897750\"}', '0', '0', '1595991286'), ('110', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1597329834\",\"MsgType\":\"text\",\"Content\":\"齐\",\"MsgId\":\"22868262545563354\"}', '0', '0', '1597329835'), ('111', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1597329846\",\"MsgType\":\"text\",\"Content\":\"demo1\",\"MsgId\":\"22868261655728541\"}', '0', '0', '1597329846'), ('112', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1601445491\",\"MsgType\":\"text\",\"Content\":\"测试\",\"MsgId\":\"22927188171756182\"}', '0', '0', '1601445491'), ('113', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1601445618\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22927188903936687\"}', '1', '0', '1601445618'), ('114', '1', '113', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"我是一段普通文本\"}', '0', '1', '1601445618'), ('115', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604028399\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964164434216243\"}', '0', '0', '1604028400'), ('116', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604028649\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964171173331025\"}', '0', '0', '1604028649'), ('117', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604028787\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964169809336365\"}', '0', '0', '1604028787'), ('118', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604028834\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964171620132981\"}', '0', '0', '1604028834'), ('119', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604028864\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964169577188719\"}', '0', '0', '1604028864'), ('120', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604030108\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964189456277596\"}', '0', '0', '1604030108'), ('121', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604030249\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964189868238639\"}', '0', '0', '1604030249'), ('122', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604030306\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964190927543657\"}', '0', '0', '1604030306'), ('123', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604030517\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964195644888419\"}', '0', '0', '1604030517'), ('124', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604031499\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964209935878457\"}', '0', '0', '1604031499'), ('125', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604070626\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964772044889072\"}', '0', '0', '1604070626'), ('126', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604070701\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964771473802617\"}', '0', '0', '1604070701'), ('127', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604070818\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964769814692912\"}', '0', '0', '1604070818'), ('128', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604070887\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964772455058566\"}', '0', '0', '1604070887'), ('129', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604070977\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964777036756801\"}', '1', '0', '1604070977'), ('130', '1', '129', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"num2\"}', '0', '1', '1604070977'), ('131', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071236\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964778055359994\"}', '0', '0', '1604071237'), ('132', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071309\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964778241051416\"}', '1', '0', '1604071309'), ('133', '1', '132', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"\"}', '0', '1', '1604071309'), ('134', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071426\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964781185005667\"}', '1', '0', '1604071426'), ('135', '1', '134', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"http:\\/\\/www.baidu.com\"}', '0', '1', '1604071426'), ('136', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071482\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964778202772360\"}', '1', '0', '1604071482'), ('137', '1', '136', '测试号', 'http://devhhb.images.huihuiba.net/1-5f18f12eab894.jpg', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"Content\":\"http:\\/\\/www.baidu.com\"}', '0', '1', '1604071482'), ('138', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071501\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964782308191873\"}', '0', '0', '1604071501'), ('139', '1', '0', '傅道集', 'http://thirdwx.qlogo.cn/mmopen/XuuoWKYP66n7RHE98H4mgVW90ibAVJEVreTtyX5dIuSjiaKSzBMjC9hO9bBGOGUg700icQyFsibFjv8K1tHcRIicqBw/132', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', 'text', '{\"ToUserName\":\"gh_96bd876da264\",\"FromUserName\":\"ogoRYuCp4BBGko7A-_s2weCjTJYQ\",\"CreateTime\":\"1604071549\",\"MsgType\":\"text\",\"Content\":\"图文\",\"MsgId\":\"22964785819902224\"}', '0', '0', '1604071550');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_msg_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_msg_3`;
CREATE TABLE `ky_mp_msg_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增 ID',
  `log_mpid` int(11) NOT NULL DEFAULT '0' COMMENT '公众号标识',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一条消息 ID',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `openid` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'openid',
  `type` varchar(32) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '消息类型',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '消息内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未回复，1已回复',
  `is_reply` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1表示公众号回复',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `openid_mpid` (`openid`,`log_mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Table structure for `ky_mp_msg_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_msg_4`;
CREATE TABLE `ky_mp_msg_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增 ID',
  `mpid` int(11) NOT NULL DEFAULT '0' COMMENT '公众号标识',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一条消息 ID',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `openid` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'openid',
  `type` varchar(32) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '消息类型',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '消息内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未回复，1已回复',
  `is_reply` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1表示公众号回复',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `openid_mpid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=55 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Records of `ky_mp_msg_4`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_msg_4` VALUES ('28', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591710511\",\"MsgType\":\"text\",\"Content\":\"音乐\",\"MsgId\":\"22787814973843601\"}', '1', '0', '1591710511'), ('29', '3', '28', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'music', '{\"Title\":\"音乐1\",\"Description\":\"音乐描述\",\"MusicUrl\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5eda125e86564.mp3\",\"HQMusicUrl\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5eda125e86564.mp3\"}', '0', '1', '1591710511'), ('30', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591710591\",\"MsgType\":\"text\",\"Content\":\"视频\",\"MsgId\":\"22787816321783031\"}', '1', '0', '1591710591'), ('31', '3', '30', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'video', '{\"MediaId\":\"ZOzBoX0K4goJhq2CjCXt8tNogKn49PcWU81kOnAXVTs\",\"Title\":\"test.mp4\",\"Description\":\"\"}', '0', '1', '1591710591'), ('32', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591714267\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22787868775969527\"}', '1', '0', '1591714268'), ('33', '3', '32', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1591714268'), ('34', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591714642\",\"MsgType\":\"text\",\"Content\":\"音频\",\"MsgId\":\"22787875569329279\"}', '1', '0', '1591714642'), ('35', '3', '34', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'voice', '{\"MediaId\":\"ZOzBoX0K4goJhq2CjCXt8kU2KW1IlNA1ZkYkuDFXN5E\"}', '0', '1', '1591714643'), ('36', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591714652\",\"MsgType\":\"text\",\"Content\":\"音乐\",\"MsgId\":\"22787874448141377\"}', '1', '0', '1591714652'), ('37', '3', '36', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'music', '{\"Title\":\"音乐1\",\"Description\":\"音乐描述\",\"MusicUrl\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5eda125e86564.mp3\",\"HQMusicUrl\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5eda125e86564.mp3\"}', '0', '1', '1591714652'), ('38', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591714659\",\"MsgType\":\"text\",\"Content\":\"视频\",\"MsgId\":\"22787873027776143\"}', '1', '0', '1591714659'), ('39', '3', '38', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'video', '{\"MediaId\":\"ZOzBoX0K4goJhq2CjCXt8tNogKn49PcWU81kOnAXVTs\",\"Title\":\"test.mp4\",\"Description\":\"\"}', '0', '1', '1591714659'), ('40', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591783829\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22788865958477352\"}', '1', '0', '1591783830'), ('41', '3', '40', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1591783830'), ('42', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591784693\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22788875857619069\"}', '0', '0', '1591784693'), ('43', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591784707\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22788877664982235\"}', '1', '0', '1591784707'), ('44', '3', '43', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1591784707'), ('45', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'image', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591785140\",\"MsgType\":\"image\",\"PicUrl\":\"http://mmbiz.qpic.cn/mmbiz_jpg/BicGVQs3yBibzv4KhYfxic8to4y3TNzAporwxCCxh1jzE4zswMicU7n4GMc56ZDZdzsmWqh53rmTzEWpCZT94GLKiaA/0\",\"MsgId\":\"22788885039786085\",\"MediaId\":\"tBKCt3C8zi2jidLDU1xVmUlC53gE0EWUTvU6SPxpFez3Zg-rwz-G25K-cRz0TYeo\",\"url\":\"http://devhhb.images.huihuiba.net/d6e42e7e39944c197add540e4ee575c3\"}', '0', '0', '1591785141'), ('46', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'video', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591785203\",\"MsgType\":\"video\",\"MediaId\":\"kAC0bhOi3jodTY99ivRynjBreN3yrlqZ9qTHw6LM-Ik0C0u74ytTpZKSqDxM2HzG\",\"ThumbMediaId\":\"bixRWoTwDcSN0zSM0Wm6eSiZOFdSbK6n8EPITsMQPNaQOsOM9yY_hm6hwAAEOGhw\",\"MsgId\":\"22788885601799578\",\"url\":\"http://devhhb.images.huihuiba.net/c31793b37b5cd748ed9ed0000b3ac2d6\"}', '0', '0', '1591785204'), ('47', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591794307\",\"MsgType\":\"text\",\"Content\":\"1\",\"MsgId\":\"22789015058077985\"}', '0', '0', '1591794308'), ('48', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1591794313\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22789016976492309\"}', '1', '0', '1591794313'), ('49', '3', '48', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1591794313'), ('50', '3', '0', '', '', 'oVTwBwQGvRd15VxgfIWfMTMjAOAE', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQGvRd15VxgfIWfMTMjAOAE\",\"CreateTime\":\"1594891667\",\"MsgType\":\"text\",\"Content\":\"张剑\",\"MsgId\":\"22833356281407188\"}', '0', '0', '1594891667'), ('51', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1595919769\",\"MsgType\":\"text\",\"Content\":\"文本\",\"MsgId\":\"22848075589395877\"}', '1', '0', '1595919770'), ('52', '3', '51', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1595919770'), ('53', '3', '0', '', '', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"ToUserName\":\"gh_d17efaa86a49\",\"FromUserName\":\"oVTwBwQ4mQBMzON1pXo_WhJSmlyI\",\"CreateTime\":\"1596277794\",\"MsgType\":\"text\",\"Content\":\"测试\",\"MsgId\":\"22853200922407092\"}', '1', '0', '1596277794'), ('54', '3', '53', '苟哥', 'http://wx.qlogo.cn/mmopen/icU3wjyUPLMsTMc8ApkQS8ogWbMzUa6gKW3eVCPw5OWvhbSe3TpZ55F4DTA8T9F5D5lq0pcxDiaUxFtUic2Ob78yPAGRdfEiaTGf/0', 'oVTwBwQ4mQBMzON1pXo_WhJSmlyI', 'text', '{\"Content\":\"测试\"}', '0', '1', '1596277794');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_msg_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_msg_5`;
CREATE TABLE `ky_mp_msg_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增 ID',
  `mpid` int(11) NOT NULL DEFAULT '0' COMMENT '公众号标识',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一条消息 ID',
  `nickname` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '昵称',
  `headimgurl` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '头像',
  `openid` varchar(64) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT 'openid',
  `type` varchar(32) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '消息类型',
  `content` text COLLATE utf8mb4_unicode_ci COMMENT '消息内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0未回复，1已回复',
  `is_reply` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1表示公众号回复',
  `create_time` int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `openid_mpid` (`openid`,`mpid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Table structure for `ky_mp_order`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_order`;
CREATE TABLE `ky_mp_order` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `order_no` varchar(32) NOT NULL DEFAULT '' COMMENT '平台交易单号',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '商家公众号id',
  `openid` varchar(64) NOT NULL DEFAULT '' COMMENT '公众号粉丝openid',
  `subject` varchar(250) NOT NULL DEFAULT '' COMMENT '购买主题',
  `body` text NOT NULL COMMENT '购买详情',
  `amount` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '实际支付总金额',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态1有效 0废弃',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `extend_info` text COMMENT '其他信息',
  `paid` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否支付 1已支付  0未支付',
  `notify_url` varchar(255) NOT NULL DEFAULT '' COMMENT '回调地址',
  `return_url` varchar(255) NOT NULL DEFAULT '' COMMENT '返回链接',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `index_order_no` (`order_no`) USING BTREE,
  KEY `mpid` (`mpid`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='公众号统一订单表';

-- ----------------------------
--  Records of `ky_mp_order`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_order` VALUES ('1', 'demo159359860610110099', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【测试文章】', '1', '1', '1593598606', '1593662452', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/3/mid/1'), ('2', 'demo159365231357575451', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【测试文章】', '1', '1', '1593652313', '1593661228', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/3/mid/1'), ('3', 'demo159366068056521005', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【文章1】', '1', '1', '1593660680', '1593660680', null, '0', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/2/mid/1'), ('4', 'demo159366081648545650', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【文章1】', '1', '1', '1593660816', '1593661089', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/2/mid/1'), ('5', 'demo159366104856495656', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【文章1】', '1', '1', '1593661048', '1593661075', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/2/mid/1'), ('6', 'demo159366155450484851', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【文章1】', '1', '1', '1593661554', '1593661807', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/2/mid/1'), ('7', 'demo159367232250975710', '1', 'ow0_twM63wenpWy2IOiGEKS1w4GA', '打赏', '文章【文章1】', '1', '1', '1593672322', '1593672365', null, '1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/payCallback/mid/1', 'http://kyphp.fdj.kuryun.cn/app/demo/index/detail/id/2/mid/1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_qrcode`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode`;
CREATE TABLE `ky_mp_qrcode` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '场景名称',
  `scene_str` varchar(64) NOT NULL DEFAULT '' COMMENT '场景值字符串',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关联关键词',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0:永久  1临时',
  `expire` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `ticket` varchar(150) NOT NULL DEFAULT '' COMMENT '二维码Ticket',
  `short_url` varchar(255) NOT NULL DEFAULT '' COMMENT '二维码短地址',
  `qrcode_url` varchar(200) NOT NULL COMMENT '二维码原始地址',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '二维码图片解析后的地址',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码创建时间',
  `scan_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '扫码次数',
  `gz_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关注数量',
  PRIMARY KEY (`id`),
  KEY `mpid` (`mpid`),
  KEY `keyword` (`keyword`),
  KEY `ticket` (`ticket`,`mpid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='公众号二维码表';

-- ----------------------------
--  Records of `ky_mp_qrcode`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_qrcode` VALUES ('2', '1', '永久场景1', '场景2', '图片', '0', '0', 'gQF28TwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyZmN0TUZjMjQ5b1UxMDAwMDAwN3EAAgTLEOteAwQAAAAA', 'https://w.url.cn/s/A59go3o', 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=gQF28TwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyZmN0TUZjMjQ5b1UxMDAwMDAwN3EAAgTLEOteAwQAAAAA', 'http://weixin.qq.com/q/02fctMFc249oU10000007q', '1592463563', '1', '0'), ('3', '1', '临时场景1', 'sdas', '文本', '1', '3600', 'gQH27zwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyRl9XbkU2MjQ5b1UxTmlESGh1Y3UAAgRCGeteAwQQDgAA', 'https://w.url.cn/s/AXkrakp', 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=gQH27zwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyRl9XbkU2MjQ5b1UxTmlESGh1Y3UAAgRCGeteAwQQDgAA', 'http://weixin.qq.com/q/02F_WnE6249oU1NiDHhucu', '1592465730', '3', '1'), ('4', '15', '沙漠场景', 'test_scence', '沙漠', '0', '0', 'gQE08DwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyYm53a0U4U2JjMUUxMDAwMGcwN2wAAgQdHXRfAwQAAAAA', 'https://w.url.cn/s/AuEf3dZ', 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=gQE08DwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyYm53a0U4U2JjMUUxMDAwMGcwN2wAAgQdHXRfAwQAAAAA', 'http://weixin.qq.com/q/02bnwkE8Sbc1E10000g07l', '1601445149', '2', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_qrcode_log_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode_log_1`;
CREATE TABLE `ky_mp_qrcode_log_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `qrcode_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码id',
  `log_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0默认  1扫码关注',
  `ticket` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `scan_num` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '扫码次数',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首次扫码时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrcode_id` (`qrcode_id`,`log_mpid`,`openid`),
  KEY `qrcode_id_2` (`qrcode_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='公众号二维码被扫记录';

-- ----------------------------
--  Records of `ky_mp_qrcode_log_1`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_qrcode_log_1` VALUES ('1', '4', '15', 'otosB6AenCK-s9GA9C8ysbDAh9nE', '0', 'gQE08DwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyYm53a0U4U2JjMUUxMDAwMGcwN2wAAgQdHXRfAwQAAAAA', '2', '1601446961', '1601447211');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_qrcode_log_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode_log_2`;
CREATE TABLE `ky_mp_qrcode_log_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `qrcode_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码id',
  `log_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0默认  1扫码关注',
  `ticket` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `scan_num` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '扫码次数',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首次扫码时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrcode_id` (`qrcode_id`,`log_mpid`,`openid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Records of `ky_mp_qrcode_log_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_qrcode_log_2` VALUES ('1', '3', '1', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', '0', 'gQH27zwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyRl9XbkU2MjQ5b1UxTmlESGh1Y3UAAgRCGeteAwQQDgAA', '2', '1592467860', '1592468103'), ('2', '2', '1', 'ogoRYuCp4BBGko7A-_s2weCjTJYQ', '0', 'gQF28TwAAAAAAAAAAS5odHRwOi8vd2VpeGluLnFxLmNvbS9xLzAyZmN0TUZjMjQ5b1UxMDAwMDAwN3EAAgTLEOteAwQAAAAA', '1', '1592469140', '1592469140');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_qrcode_log_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode_log_3`;
CREATE TABLE `ky_mp_qrcode_log_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `qrcode_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码id',
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0默认  1扫码关注',
  `ticket` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `scan_num` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '扫码次数',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首次扫码时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrcode_id` (`qrcode_id`,`mpid`,`openid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Table structure for `ky_mp_qrcode_log_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode_log_4`;
CREATE TABLE `ky_mp_qrcode_log_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `qrcode_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码id',
  `log_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0默认  1扫码关注',
  `ticket` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `scan_num` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '扫码次数',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首次扫码时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrcode_id` (`qrcode_id`,`log_mpid`,`openid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Table structure for `ky_mp_qrcode_log_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_qrcode_log_5`;
CREATE TABLE `ky_mp_qrcode_log_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `qrcode_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '二维码id',
  `log_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `openid` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'openid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0默认  1扫码关注',
  `ticket` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `scan_num` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '扫码次数',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首次扫码时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrcode_id` (`qrcode_id`,`log_mpid`,`openid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
--  Table structure for `ky_mp_rule_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_rule_1`;
CREATE TABLE `ky_mp_rule_1` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `rule_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `keyword` varchar(80) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '关键词内容',
  `media_type` varchar(50) NOT NULL DEFAULT '' COMMENT '触发类型：text,addon,images,news,voice,music,video',
  `media_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '回复素材ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态(1开启:0关闭)',
  PRIMARY KEY (`id`),
  KEY `mpid` (`rule_mpid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='公众号响应规则';

-- ----------------------------
--  Records of `ky_mp_rule_1`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_rule_1` VALUES ('1', '15', '文本', 'text', '2', '1'), ('2', '15', '图片', 'image', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_rule_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_rule_2`;
CREATE TABLE `ky_mp_rule_2` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `rule_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `keyword` varchar(80) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '关键词内容',
  `media_type` varchar(50) NOT NULL DEFAULT '' COMMENT '触发类型：text,addon,images,news,voice,music,video',
  `media_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '回复素材ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态(1开启:0关闭)',
  PRIMARY KEY (`id`),
  KEY `mpid` (`rule_mpid`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='公众号响应规则';

-- ----------------------------
--  Records of `ky_mp_rule_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_rule_2` VALUES ('1', '1', '图片', 'image', '8', '0'), ('2', '1', '语音', 'text', '14', '1'), ('3', '1', '无应答', 'text', '15', '1'), ('4', '1', '视频', 'video', '4', '1'), ('5', '1', '音乐', 'music', '6', '1'), ('6', '1', '文本', 'text', '5', '1'), ('7', '1', 'demo1', 'addon', '10', '1'), ('8', '1', '图文', 'news', '2', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_rule_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_rule_3`;
CREATE TABLE `ky_mp_rule_3` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `rule_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `keyword` varchar(80) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '关键词内容',
  `media_type` varchar(50) NOT NULL DEFAULT '' COMMENT '触发类型：text,addon,images,news,voice,music,video',
  `media_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '回复素材ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态(1开启:0关闭)',
  PRIMARY KEY (`id`),
  KEY `mpid` (`rule_mpid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公众号响应规则';

-- ----------------------------
--  Table structure for `ky_mp_rule_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_rule_4`;
CREATE TABLE `ky_mp_rule_4` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `rule_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `keyword` varchar(80) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '关键词内容',
  `media_type` varchar(50) NOT NULL DEFAULT '' COMMENT '触发类型：text,addon,images,news,voice,music,video',
  `media_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '回复素材ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态(1开启:0关闭)',
  PRIMARY KEY (`id`),
  KEY `mpid` (`rule_mpid`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COMMENT='公众号响应规则';

-- ----------------------------
--  Records of `ky_mp_rule_4`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_rule_4` VALUES ('1', '3', '测试', 'text', '7', '1'), ('2', '3', '图片', 'image', '5', '1'), ('3', '3', '文本', 'text', '7', '1'), ('4', '3', '我和奶奶', 'image', '15', '1'), ('5', '3', '音频', 'voice', '2', '1'), ('6', '3', '视频', 'video', '1', '1'), ('7', '3', '音乐', 'music', '2', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_rule_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_rule_5`;
CREATE TABLE `ky_mp_rule_5` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `rule_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID',
  `keyword` varchar(80) CHARACTER SET utf8mb4 NOT NULL DEFAULT '' COMMENT '关键词内容',
  `media_type` varchar(50) NOT NULL DEFAULT '' COMMENT '触发类型：text,addon,images,news,voice,music,video',
  `media_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '回复素材ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态(1开启:0关闭)',
  PRIMARY KEY (`id`),
  KEY `mpid` (`rule_mpid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公众号响应规则';

-- ----------------------------
--  Table structure for `ky_mp_setting`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_setting`;
CREATE TABLE `ky_mp_setting` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号ID，大于0表示附属公众号的配置',
  `name` varchar(30) NOT NULL DEFAULT '' COMMENT '标识',
  `title` varchar(30) NOT NULL DEFAULT '' COMMENT '名称',
  `value` text COMMENT '配置值',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='公众号配置';

-- ----------------------------
--  Records of `ky_mp_setting`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_setting` VALUES ('4', '1', 'wxpay', '微信支付', '{\"appid\":\"wxe1b7737e3a0c7153\",\"secret\":\"887bb389abbe27e69982576a96a515b3\",\"merchant_id\":\"1449332102\",\"key\":\"Tm44FMGt484Y44TjV34V3VG2ZEG4pf4f\",\"cert_path\":\"3241432332342432432432\",\"key_path\":\"3344334343434\",\"rsa_path\":\"\"}', '1591886422', '1596709233');
COMMIT;

-- ----------------------------
--  Table structure for `ky_mp_special`
-- ----------------------------
DROP TABLE IF EXISTS `ky_mp_special`;
CREATE TABLE `ky_mp_special` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `spe_mpid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '公众号id',
  `event` enum('image','voice','video','shortvideo','location','event_location','link','view','subscribe','unsubscribe','card','default') COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '事件/消息类型',
  `keyword` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '触发的关键词',
  `addon` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '触发应用',
  `ignore` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否忽略',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '1正常 0禁用',
  PRIMARY KEY (`id`),
  KEY `mpid` (`spe_mpid`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='公众号特殊消息/事件回复';

-- ----------------------------
--  Records of `ky_mp_special`
-- ----------------------------
BEGIN;
INSERT INTO `ky_mp_special` VALUES ('1', '1', 'image', '', '', '1', '1'), ('2', '1', 'voice', '', '', '1', '1'), ('3', '1', 'video', '', '', '1', '1'), ('4', '1', 'shortvideo', '', '', '1', '1'), ('5', '1', 'location', '', 'demo', '0', '1'), ('6', '1', 'link', '', '', '1', '1'), ('7', '1', 'event_location', '', '', '1', '1'), ('9', '1', 'subscribe', '', '', '0', '1'), ('10', '1', 'unsubscribe', '', '', '1', '1'), ('11', '1', 'card', '', '', '1', '1'), ('12', '1', 'default', '', '', '1', '1'), ('13', '3', 'subscribe', '', '', '1', '1'), ('14', '3', 'unsubscribe', '', '', '1', '1'), ('15', '3', 'image', '', '', '1', '1'), ('16', '3', 'voice', '', '', '1', '1'), ('17', '3', 'video', '', '', '1', '1'), ('18', '3', 'shortvideo', '', '', '1', '1'), ('19', '3', 'location', '', '', '1', '1'), ('20', '3', 'link', '', '', '1', '1'), ('21', '3', 'event_location', '', '', '1', '1'), ('23', '3', 'card', '', '', '1', '1'), ('24', '3', 'default', '', '', '1', '1'), ('25', '15', 'subscribe', '', '', '1', '1'), ('26', '15', 'unsubscribe', '', '', '1', '1'), ('27', '15', 'image', '', '', '1', '1'), ('28', '15', 'voice', '', '', '1', '1'), ('29', '15', 'video', '', '', '1', '1'), ('30', '15', 'shortvideo', '', '', '1', '1'), ('31', '15', 'location', '', '', '1', '1'), ('32', '15', 'link', '', '', '1', '1'), ('33', '15', 'event_location', '', '', '1', '1'), ('34', '15', 'card', '', '', '1', '1'), ('35', '15', 'default', '', '', '1', '1'), ('36', '16', 'subscribe', '', '', '1', '1'), ('37', '16', 'unsubscribe', '', '', '1', '1'), ('38', '16', 'image', '', '', '1', '1'), ('39', '16', 'voice', '', '', '1', '1'), ('40', '16', 'video', '', '', '1', '1'), ('41', '16', 'shortvideo', '', '', '1', '1'), ('42', '16', 'location', '', '', '1', '1'), ('43', '16', 'link', '', '', '1', '1'), ('44', '16', 'event_location', '', '', '1', '1'), ('45', '16', 'card', '', '', '1', '1'), ('46', '16', 'default', '', '', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_notice`
-- ----------------------------
DROP TABLE IF EXISTS `ky_notice`;
CREATE TABLE `ky_notice` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '公告标题',
  `content` text COLLATE utf8mb4_unicode_ci NOT NULL COMMENT '公告内容',
  `publish_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后修改时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='系统公告';

-- ----------------------------
--  Records of `ky_notice`
-- ----------------------------
BEGIN;
INSERT INTO `ky_notice` VALUES ('1', '公告1', '<p><img src=\"http://devhhb.images.huihuiba.net/1-5ed603542b0f4.jpg\" alt=\"1-5ed603542b0f4.jpg\"/></p><p>测试公告内容，修改了</p>', '1594896021', '1', '1594896100', '1594896426'), ('2', '公告2', '<p>内容随时说</p>', '1594900011', '1', '1594900088', '1596709482'), ('3', 'fsdf', '<p>内容dsfds</p>', '1598457600', '1', '1598513323', '1598513323');
COMMIT;

-- ----------------------------
--  Table structure for `ky_notice_read`
-- ----------------------------
DROP TABLE IF EXISTS `ky_notice_read`;
CREATE TABLE `ky_notice_read` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `notice` longtext COLLATE utf8mb4_unicode_ci COMMENT '公告id串',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='已读公告';

-- ----------------------------
--  Records of `ky_notice_read`
-- ----------------------------
BEGIN;
INSERT INTO `ky_notice_read` VALUES ('1', '1', 'id2,id1,id3'), ('2', '4', 'id2,id1,id3'), ('3', '2', 'id1,id2,id3'), ('4', '8', 'id3,id2,id1'), ('5', '9', 'id3,id2,id1');
COMMIT;

-- ----------------------------
--  Table structure for `ky_order_addon`
-- ----------------------------
DROP TABLE IF EXISTS `ky_order_addon`;
CREATE TABLE `ky_order_addon` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `order_no` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '交易单号',
  `addon` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '应用标识',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `username` varchar(30) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '用户名',
  `mobile` varchar(15) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT '手机号',
  `subject` varchar(250) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '购买主题',
  `body` text CHARACTER SET utf8 NOT NULL COMMENT '购买详情',
  `total` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '订单总额（单位：分）',
  `amount` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '订单实付金额',
  `currency` varchar(10) CHARACTER SET utf8 NOT NULL DEFAULT 'cny' COMMENT '汇率类型',
  `channel` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT 'WX_WEB' COMMENT '支付类型,默认微信支付',
  `client_ip` char(15) CHARACTER SET utf8 NOT NULL DEFAULT '127.0.0.1' COMMENT '客户端ip',
  `paid` tinyint(1) NOT NULL DEFAULT '0' COMMENT '1:支付成功 0：待支付  -1：支付失败；2：已退款',
  `transaction_id` varchar(100) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '支付平台订单号',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  `pay_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '支付时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `order_no` (`order_no`) USING BTREE,
  KEY `user_id` (`uid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='应用采购订单';

-- ----------------------------
--  Records of `ky_order_addon`
-- ----------------------------
BEGIN;
INSERT INTO `ky_order_addon` VALUES ('9', 'addon159530730153555556', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '2', 'cny', 'WX_NATIVE', '106.122.210.148', '1', '4200000721202007218491029526', '1', '1595307301', '1595325003', '1595311033'), ('10', 'addon159531014953989753', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '0', '', '1', '1595310149', '1595310149', '0'), ('11', 'addon159531115349541015', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '2', 'cny', 'WX_NATIVE', '106.122.210.148', '1', '4200000721202007214490148012', '1', '1595311153', '1595324935', '1595311177'), ('12', 'addon159531167497501015', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '1', '4200000723202007217734528377', '1', '1595311674', '1595311697', '1595311697'), ('13', 'addon159531215357511009', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '1', '4200000720202007211164900634', '1', '1595312153', '1595312171', '1595312171'), ('14', 'addon159531266557979852', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '1', '4200000723202007212484015953', '1', '1595312665', '1595312686', '1595312686'), ('15', 'addon159531303910250565', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '0', '', '1', '1595313039', '1595313039', '0'), ('16', 'addon159531314355495449', 'demo', '1', 'admin', '15659827559', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.122.210.148', '0', '', '1', '1595313143', '1595313143', '0'), ('17', 'addon160192706910010154', 'demo', '4', 'test', '', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '106.47.84.120', '0', '', '1', '1601927069', '1601927069', '0'), ('18', 'addon160195275551989710', 'demo', '8', 'spa123456', '', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '49.94.179.221', '0', '', '1', '1601952755', '1601952755', '0'), ('19', 'addon160196423155979749', 'demo', '8', 'spa123456', '', '开通应用demo应用', '开通应用demo应用', '1', '1', 'cny', 'WX_NATIVE', '49.94.179.221', '0', '', '1', '1601964231', '1601964231', '0');
COMMIT;

-- ----------------------------
--  Table structure for `ky_setting`
-- ----------------------------
DROP TABLE IF EXISTS `ky_setting`;
CREATE TABLE `ky_setting` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(30) NOT NULL DEFAULT '' COMMENT '标识',
  `title` varchar(30) NOT NULL DEFAULT '' COMMENT '名称',
  `value` text COMMENT '配置值',
  `create_time` int(10) unsigned NOT NULL DEFAULT '0',
  `update_time` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='站点配置';

-- ----------------------------
--  Records of `ky_setting`
-- ----------------------------
BEGIN;
INSERT INTO `ky_setting` VALUES ('1', 'site', '站点信息', '{\"close\":\"0\",\"close_reason\":\"\\u7cfb\\u7edf\\u5347\\u7ea712\",\"icp\":\"\\u95fdICP\\u590717014461\\u53f7-1\",\"logo\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5f27aff29f820.png\",\"kefu\":\"http:\\/\\/devhhb.images.huihuiba.net\\/1-5f336a7d80daf.jpg\",\"default_group_id\":\"2\",\"keywords\":\"\\u5fae\\u4fe1\\u5173\\u7cfb\\u7ba1\\u7406\\u3001\\u5fae\\u4fe1\\u516c\\u4f17\\u53f7\\u3001\\u793e\\u4ea4\\u6570\\u636e\\u7ba1\\u7406\\u3001\\u5c0f\\u7a0b\\u5e8f\\u3001\\u5fae\\u4fe1\\u516c\\u4f17\\u5e73\\u53f0\\u3001\\u516c\\u4f17\\u53f7\\u5e94\\u7528\\u5546\\u5e97\\uff0c\\u516c\\u4f17\\u53f7\\u63d2\\u4ef6\\u5546\\u5e97\\u3001\\u516c\\u4f17\\u53f7\\u5f00\\u53d1\\u3001\\u5fae\\u4fe1CRM\\u3001\\u9910\\u996e\\u3001\\u65b0\\u96f6\\u552e\\u3001\\u5728\\u7ebf\\u6559\\u80b2\\u3001\\u667a\\u80fd\\u786c\\u4ef6\",\"description\":\"\\u9177\\u5728\\u4e91\\u7aef\\u662f\\u9886\\u5148\\u7684\\u5fae\\u4fe1\\u5168\\u884c\\u4e1a\\u8425\\u9500\\u5e73\\u53f0\\u3002\\u4e0d\\u4ec5\\u5e2e\\u52a9\\u54c1\\u724c\\u89e3\\u51b3\\u5fae\\u4fe1\\u516c\\u4f17\\u53f7\\u3001\\u5c0f\\u7a0b\\u5e8f\\u7684\\u5f00\\u53d1\\u95ee\\u9898\\uff0c\\u7ba1\\u7406\\u7c89\\u4e1dCRM\\u53ca\\u6570\\u636e\\uff0c\\u6839\\u636e\\u884c\\u4e3a\\u53ca\\u5c5e\\u6027\\u5c06\\u7c89\\u4e1d\\u81ea\\u52a8\\u6253\\u4e0a\\u6807\\u7b7e\\uff0c\\u501f\\u52a9\\u5fae\\u4fe1CRM\\u5b9e\\u73b0\\u7cbe\\u7ec6\\u5316\\u8425\\u9500\\u3002\\u4e5f\\u4e3a\\u4e2d\\u5c0f\\u4f01\\u4e1a\\u63d0\\u4f9b\\u5fae\\u5546\\u57ce\\u3001\\u667a\\u6167\\u96f6\\u552e\\u3001\\u9910\\u996eo2o\\u3001\\u5c0f\\u7a0b\\u5e8f\\u7b49\\u4e00\\u4f53\\u5316\\u89e3\\u51b3\\u65b9\\u6848\\uff0c\\u4ee5\\u66f4\\u5f00\\u653e\\u7684\\u670d\\u52a1\\u751f\\u6001\\u4e3a\\u7528\\u6237\\u63d0\\u4f9b\\u4ea7\\u54c1\\u548c\\u670d\\u52a1\\uff0c\\u6784\\u5efa\\u7ebf\\u4e0a\\u7ebf\\u4e0b\\u878d\\u5408\\u3001 \\u591a\\u6e20\\u9053\\u8425\\u9500\\u3001\\u5f00\\u653e\\u4e92\\u901a\\u7684\\u667a\\u80fd\\u5546\\u4e1a\\u670d\\u52a1\\u751f\\u6001\\u4f53\\u7cfb\\uff0c\\u5e2e\\u52a9\\u66f4\\u591a\\u4e2d\\u5c0f\\u4f01\\u4e1a\\u5411\\u667a\\u80fd\\u5546\\u4e1a\\u8f6c\\u578b\\u5347\\u7ea7\\u3002\",\"tongji\":\"<script type=\\\"text\\/javascript\\\" src=\\\"https:\\/\\/s9.cnzz.com\\/z_stat.php?id=1279377264&web_id=1279377264\\\"><\\/script>\"}', '1590290640', '1603552319'), ('2', 'upload', '附件设置', '{\"driver\":\"qiniu\",\"qiniu_ak\":\"zn9rSy52CirW07siksxMsLBo8d_NJDTSb9vljGwT\",\"qiniu_sk\":\"GW-pwZlsL01Hvleiv9TmFIhaFNKKEIzYeNYGt_1P\",\"qiniu_bucket\":\"dev-hhb\",\"qiniu_domain\":\"http:\\/\\/devhhb.images.huihuiba.net\",\"image_size\":\"2048000\",\"image_ext\":\"jpg,gif,png,jpeg\",\"file_size\":\"53000000\",\"file_ext\":\"jpg,gif,png,jpeg,zip,rar,tar,gz,7z,doc,docx,txt,xml,mp3,mp4,xls,xlsx,pdf\",\"voice_size\":\"2048000\",\"voice_ext\":\"mp3,wma,wav,amr\",\"video_size\":\"50240000\",\"video_ext\":\"mp4,flv,mov\"}', '1590292316', '1600056253'), ('3', 'weixin', '微信', '{\"platform\":{\"appid\":\"wxe801199e1be0e667\",\"appsecret\":\"b888af3de74a6b55de3d257ae7439a51\",\"token\":\"Ss6jcMRzWJr4eBIy43qAQMhbDQIgrIvy\",\"aes_key\":\"d7EDKAAJJowAsYnudcASzLjwBlJXXp3DOd4pvmRBR2L\",\"verify_file\":\"\\/9885899112.txt\"}}', '1590647777', '1590721768'), ('5', 'pay', '支付设置', '{\"wx_appid\":\"your app id\",\"wx_secret\":\"your secret\",\"wx_merchant_id\":\"your mechart id\",\"wx_key\":\"Tm44FMGt484Y44TjV34V3VG2ZEG4pf4f\",\"wx_cert_path\":\"\",\"wx_key_path\":\"\",\"wx_rsa_path\":\"\"}', '1595296451', '1603122486'), ('6', 'common', '其他设置', '{\"map_qq_key\":\"3EOBZ-JDO3O-N4UWO-SSK7I-OSQHJ-NHF4J\"}', '1596186578', '1596186578');
COMMIT;

-- ----------------------------
--  Table structure for `ky_upload_1`
-- ----------------------------
DROP TABLE IF EXISTS `ky_upload_1`;
CREATE TABLE `ky_upload_1` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '图片原名',
  `original_name` varchar(255) NOT NULL DEFAULT '' COMMENT '文件原始名称',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT '路径',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '访问url',
  `ext` char(4) NOT NULL DEFAULT '',
  `size` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '大小',
  `location` varchar(50) NOT NULL DEFAULT 'Local' COMMENT '驱动',
  `create_time` int(10) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `md5` char(32) NOT NULL DEFAULT '' COMMENT '文件md5值',
  `sha1` char(40) NOT NULL DEFAULT '' COMMENT '文件sha1',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `ky_upload_1`
-- ----------------------------
BEGIN;
INSERT INTO `ky_upload_1` VALUES ('1', '1', '1-5ecd56c6e5929.jpg', '11.jpg', 'http://devhhb.images.huihuiba.net/1-5ecd56c6e5929.jpg', 'http://devhhb.images.huihuiba.net/1-5ecd56c6e5929.jpg', 'jpg', '15687', 'Qiniu', '1590515399', '1590515399', '1', 'cbe016efeadffe8a4b819f95f6d7b3ad', 'ee852572695da71d1e0215d064ae29762b20acb9'), ('2', '1', '1-5ecd5720d7058.png', '背景.png', 'http://devhhb.images.huihuiba.net/1-5ecd5720d7058.png', 'http://devhhb.images.huihuiba.net/1-5ecd5720d7058.png', 'png', '137491', 'Qiniu', '1590515489', '1590515489', '1', '19ebfbc55ce371f1a3d68785505e31e5', '2ca997c0edca501fb591a6be82b2f2a0b7142f63');
COMMIT;

-- ----------------------------
--  Table structure for `ky_upload_2`
-- ----------------------------
DROP TABLE IF EXISTS `ky_upload_2`;
CREATE TABLE `ky_upload_2` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '图片原名',
  `original_name` varchar(255) NOT NULL DEFAULT '' COMMENT '文件原始名称',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT '路径',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '访问url',
  `ext` char(4) NOT NULL DEFAULT '',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '大小',
  `location` varchar(50) NOT NULL DEFAULT 'Local' COMMENT '驱动',
  `create_time` int(10) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `md5` char(32) NOT NULL DEFAULT '' COMMENT '文件md5值',
  `sha1` char(40) NOT NULL DEFAULT '' COMMENT '文件sha1',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `ky_upload_2`
-- ----------------------------
BEGIN;
INSERT INTO `ky_upload_2` VALUES ('6', '1', '1-5ece208768287.jpg', 'Vue.jpg', './public/uploads/image/2020-05-27/1-5ece208768287.jpg', '/public/uploads/image/2020-05-27/1-5ece208768287.jpg', 'jpg', '5539', 'Local', '1590567047', '1590567047', '1', '035a63d22c22dc86b1f35fbd34b57155', 'd94c2c1a48b48527ec748c64c606a57a729b1581'), ('7', '1', '1-5ece2087777dd.jpg', 'wechat.jpg', './public/uploads/image/2020-05-27/1-5ece2087777dd.jpg', '/public/uploads/image/2020-05-27/1-5ece2087777dd.jpg', 'jpg', '8440', 'Local', '1590567047', '1590567047', '1', '4d86742fdd3e01d9881c61b4ba659134', '1f272f28a7102481c9b0f613864d8478812c6722'), ('8', '1', '1-5ece7c72a8f5f.png', 'wechat.png', 'http://devhhb.images.huihuiba.net/1-5ece7c72a8f5f.png', 'http://devhhb.images.huihuiba.net/1-5ece7c72a8f5f.png', 'png', '222143', 'Qiniu', '1590590579', '1590590579', '1', '85f24c89bcf394dfca8a9cce426c53b2', '818dc8098b309a240cd03795271aa96efb55147b'), ('9', '1', '1-5ed5f65807802.jpg', 'logo.jpg', 'http://devhhb.images.huihuiba.net/1-5ed5f65807802.jpg', 'http://devhhb.images.huihuiba.net/1-5ed5f65807802.jpg', 'jpg', '261242', 'Qiniu', '1591080537', '1591080537', '1', 'a1c517618f054d66b082f0b343f9410d', '06df1752c0515161f9f991b7ef2c507d8385130b'), ('10', '1', '1-5ed5f6b7e9d06.jpg', 'fdj-sm.jpg', 'http://devhhb.images.huihuiba.net/1-5ed5f6b7e9d06.jpg', 'http://devhhb.images.huihuiba.net/1-5ed5f6b7e9d06.jpg', 'jpg', '107027', 'Qiniu', '1591080632', '1591080632', '1', '77bb5769aba4bb70af1b57eb45c7c93e', '8682aea9a038a12539b5075a99bc87c5f350d956');
COMMIT;

-- ----------------------------
--  Table structure for `ky_upload_3`
-- ----------------------------
DROP TABLE IF EXISTS `ky_upload_3`;
CREATE TABLE `ky_upload_3` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '图片原名',
  `original_name` varchar(255) NOT NULL DEFAULT '' COMMENT '文件原始名称',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT '路径',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '访问url',
  `ext` char(4) NOT NULL DEFAULT '',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '大小',
  `location` varchar(50) NOT NULL DEFAULT 'Local' COMMENT '驱动',
  `create_time` int(10) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `md5` char(32) NOT NULL DEFAULT '' COMMENT '文件md5值',
  `sha1` char(40) NOT NULL DEFAULT '' COMMENT '文件sha1',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
--  Table structure for `ky_upload_4`
-- ----------------------------
DROP TABLE IF EXISTS `ky_upload_4`;
CREATE TABLE `ky_upload_4` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '图片原名',
  `original_name` varchar(255) NOT NULL DEFAULT '' COMMENT '文件原始名称',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT '路径',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '访问url',
  `ext` char(4) NOT NULL DEFAULT '',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '大小',
  `location` varchar(50) NOT NULL DEFAULT 'Local' COMMENT '驱动',
  `create_time` int(10) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `md5` char(32) NOT NULL DEFAULT '' COMMENT '文件md5值',
  `sha1` char(40) NOT NULL DEFAULT '' COMMENT '文件sha1',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
--  Table structure for `ky_upload_5`
-- ----------------------------
DROP TABLE IF EXISTS `ky_upload_5`;
CREATE TABLE `ky_upload_5` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '用户id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '图片原名',
  `original_name` varchar(255) NOT NULL DEFAULT '' COMMENT '文件原始名称',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT '路径',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '访问url',
  `ext` char(4) NOT NULL DEFAULT '',
  `size` int(10) NOT NULL DEFAULT '0' COMMENT '大小',
  `location` varchar(50) NOT NULL DEFAULT 'Local' COMMENT '驱动',
  `create_time` int(10) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `md5` char(32) NOT NULL DEFAULT '' COMMENT '文件md5值',
  `sha1` char(40) NOT NULL DEFAULT '' COMMENT '文件sha1',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

SET FOREIGN_KEY_CHECKS = 1;
